--
-- Table structure for table `dashboards`
--

DROP TABLE IF EXISTS `dashboards`;
CREATE TABLE `dashboards` (
  `dashID` int(10) unsigned NOT NULL auto_increment,
  `dashName` varchar(255) NOT NULL default '',
  `dashDesc` varchar(255) NOT NULL default '',
  `dashModule` varchar(50) NOT NULL default '',
  `dashStatus` int(11) NOT NULL default '1',
  `dashLocation` varchar(25) NOT NULL default 'lcolumn',
  `dashURL` varchar(55) NOT NULL default '',
  `dashOrder` INT(10) NULL,
  PRIMARY KEY  (`dashID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `dashboards`
--


/*!40000 ALTER TABLE `dashboards` DISABLE KEYS */;
LOCK TABLES `dashboards` WRITE;
INSERT INTO dashboards VALUES
  (1,'dvt','Vulnerability Totals','dashDVT.inc',1,'rcolumn','dashDVT.inc',2),
  (2,'dmt','My Totals','dashDMT.inc',1,'rcolumn','dashDMT.inc',1),
  (3,'dss','System Stats','dashDSS.inc',1,'lcolumn','dashDSS.inc',3),
  (4,'dpe','Pending Exceptions','dashDPE.inc',1,'lcolumn','dashDPE.inc',4),
  (5,'dnw','News Items','dashDNW.inc',1,'lcolumn','dashDNW.inc',5);
UNLOCK TABLES;
/*!40000 ALTER TABLE `dashboards` ENABLE KEYS */;

--
-- Table structure for table `user_dashboards`
--

DROP TABLE IF EXISTS `user_dashboards`;
CREATE TABLE `user_dashboards` (
  `udID` int(10) unsigned NOT NULL auto_increment,
  `dashID` int(10) NOT NULL default '',
  `dashStatus` int(10) NOT NULL default '1',
  `dashLocation` varchar(25) NOT NULL default 'lcolumn',
  `dashOrder` INT(10) NULL,
  `pn_uname` varchar(55) NOT NULL default '',
  PRIMARY KEY  (`udID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `user_dashboards`
--


/*!40000 ALTER TABLE `user_dashboards` DISABLE KEYS */;
LOCK TABLES `user_dashboards` WRITE;
INSERT INTO user_dashboards VALUES
  (1,1,1,'rcolumn',2,'admin'),
  (2,2,1,'rcolumn',1,'admin'),
  (3,3,1,'lcolumn',3,'admin'),
  (4,4,1,'lcolumn',4,'admin'),
  (5,5,1,'lcolumn',5,'admin');
UNLOCK TABLES;
/*!40000 ALTER TABLE `user_dashboards` ENABLE KEYS */;
