<?php
/*
 * Dashboard module to display Metrics
 */

//echo "<p class='dashHeading'>7 Day Executive Metrics</p>";

/* leave in the system state dashboard for now
$query="select count(id) 
        from plugins";
$result=$dbconn->execute($query);
list($plugincount)=$result->fields;
echo "There are $plugincount Nessus plugins in the database.<br>";
   
$query = "select count(id) 
          from nessus_plugins 
          where TO_DAYS(now()) - TO_DAYS(created) <7";
$result = $dbconn->execute($query);
list($plugincount)=$result->fields;
if ($plugincount>0) { echo "<a href=\"plugins.php\">"; }
echo "$plugincount";
if ($plugincount>0) { echo "</a>"; }
echo " new plugin";
if ($plugincount!=1) { echo "s"; }
echo " added within last 7 days.<font size=\"1\"><br><br></font>";

echo "<p></p>";
*/

// output the number of new hosts added to the hosts table in last 7 days
$query = "SELECT count(ip)
          FROM hosts
          where TO_DAYS(now()) - TO_DAYS(createdate) <7";
$hcount = $dbconn->GetOne($query);
if($hcount == 1) {
   $hctext = "was 1 new host";   
} else {
   $hctext = "were $hcount new hosts";
}
echo "<p>There $hctext added to the database in the past 7 days.</p>";

// get the host scanstate summary
$query="select scanstate, count(scanstate) as count
        from hosts
        where ";
// add status flags to exclude from query
/*
$nscount = 0;
foreach ($nostatus as $ns) {
   if ($nscount >=1) { $query .= " and "; }
   $query .= " status <> '$ns' ";
   $nscount++;
}
*/
$query .= " status NOT IN ('" . implode("','",$nostatusArray) . "') ";
$query .= " group by scanstate";
//$query .= " order by ip";
//$result=$dbconn->execute($query);
$ssarray=$dbconn->GetArray($query);
//$hostarray=$dbconn->GetArray($query);
//foreach($hostarray as $host) {
//   $ssarray[$host[scanstate]]++;
//}
echo "<P></P>";
echo "<b>Scan State Summary:</b><hr>";
$tothosts = 0;
//foreach($ssarray as $sstate=>$scount) {
echo "<table summary='Host Scan State Summary'>
      <tr><th>Scan State</th><th>Count of IPs</th></tr>";
foreach($ssarray as $ssdata) {
   $scount = $ssdata['count'];
   $sstate = (!empty($ssdata['scanstate'])) ? $ssdata['scanstate'] : "Blank";
   $tothosts += $scount;
   if($sstate == "Scan Out of Date") {
      $sstate = "Scan Out of Date (>$maxScanAge days)";
   }
   echo "<tr><td>$sstate</td><td>$scount</td></tr>";
}
echo "</table>";
if($tothosts == 1) { 
   $text = "is 1 active IP"; 
} else {
   $text = "are $tothosts active IPs";
}
echo "<br>";
echo "There " . $text . " in the database.";


// info about new scan schedules created and/or run
echo "<p</p>";
echo "<b>Scan Schedule Summary</b><hr>";
echo "The following scan schedules were created and/or run in the last 7 days:\n";
$query = "SELECT name, username, next_scan
          FROM nessus_schedule
          WHERE TO_DAYS(now()) - TO_DAYS(next_scan) < 7
          ORDER BY next_scan DESC";
$result = $dbconn->GetArray($query);
if($result === false) {
} else {
   echo "<table summary='7 day scan schedules'>
         <tr><th>Schedule Name</th><th>Username</th><th>Scan Date</th></tr>";
   foreach($result as $sched) {
      echo "<tr><td>". $sched['name'] . "</td><td>".$sched['username'].
           "</td><td>" . dateformat($sched['next_scan']) . "</td></tr>\n";
   }
   echo "</table>";
}

// info about vulnerability summary for last 7 days
echo "<p></p>";
echo "<b>Vulnerability Summary</b><hr>";
echo "Total vulnerabilities by risk rating for past 7 days:<br>";
$query = "SELECT risk, count(risk) as rcount
          FROM nessus_results
          WHERE TO_DAYS(now()) - TO_DAYS(scantime) < 7
          GROUP BY risk
          ORDER BY risk ASC ";
$result = $dbconn->GetArray($query);
if($result === false) {
} else {
   echo "<table summary='7 day vuln summary'>
         <tr><th>Risk Severity</th><th>Count</th></tr>";
   $totvulns = 0;
   foreach($result as $data) {
      $totvulns += $data['rcount'];
      echo "<tr><td>".getrisk($data['risk'])."</td><td>".$data['rcount']."</td></tr>";
   }
   echo "<tr><td>Total Vulnerabilities</td><td>$totvulns</td></tr>";
   echo "</table>";
}

?>
