<?php
//
// $Id: defaults.php,v 1.7 2006/08/10 17:19:32 airwofl Exp $
//

/***********************************************************/
/*		    Inprotect			    	   */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect.com			   */
/*							   */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.				    	   */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.					   */
/*							   */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA			   */
/*							   */
/* Contact Information:					   */
/* Inprotect (inprotect-devel@lists.sourceforge.net	   */
/* http://inprotect.sourceforge.net			   */
/***********************************************************/
/* See the README.txt and/or help files for more	   */
/* information on how to use & config.			   */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.		   */
/*							   */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items	   */
/* discovered with this program's use.			   */
/***********************************************************/

$pageTitle = "Nessus Default Settings";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//include ('permissions.inc.php');

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
        if (isset($_GET['prefs'])) { $prefs=htmlspecialchars(mysql_escape_string(trim($_GET['prefs'])), ENT_QUOTES); }
	else { $prefs=""; }
# Not used in GET but needs to be defined to avoid PHP errors
	$submit="";
	$AllPlugins="";
	$NonDOS="";
	$DisableAll="";
        break;
case "POST" :
        if (isset($_POST['prefs'])) { $prefs=htmlspecialchars(mysql_escape_string(trim($_POST['prefs'])), ENT_QUOTES); }
	else { $prefs=""; }
        if (isset($_POST['submit'])) { $submit=htmlspecialchars(mysql_escape_string(trim($_POST['submit'])), ENT_QUOTES); }
	else { $submit=""; }
	if (isset($_POST['AllPlugins'])) { $AllPlugins=htmlspecialchars(mysql_escape_string(trim($_POST['AllPlugins'])), ENT_QUOTES); }
	else { $AllPlugins=""; }
	if (isset($_POST['NonDOS'])) { $NonDOS=htmlspecialchars(mysql_escape_string(trim($_POST['NonDOS'])), ENT_QUOTES); }
	else { $NonDOS=""; }
	if (isset($_POST['DisableAll'])) { $DisableAll=htmlspecialchars(mysql_escape_string(trim($_POST['DisableAll'])), ENT_QUOTES); }
	else { $DisableAll=""; }
	break;
}

$acl=checkacl("profile", $dbconn);
if ($acl!="Y") {
    echo "Access Denied!!!";
    $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Access denied", PEAR_LOG_WARNING);
}
else {
    $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Accessed page", PEAR_LOG_DEBUG);

    echo "<center><B>Nessus Scanner Settings</B></center><hr>";
    if ($prefs=="1" or $prefs=="") {

        echo "<A href=\"defaults.php?prefs=1\">Preferences</A> | ";
        echo "<A href=\"defaults.php?prefs=3\">Plugins</A> | ";
        echo "<A href=\"defaults.php?prefs=4\">View Configuration File</a><BR><BR>";

        $sql = "SELECT t.nessusgroup, t.nessus_id, t.field, t.type, t.value, n.value, t.category
               FROM nessus_preferences_defaults t
               LEFT JOIN nessus_preferences n
               ON t.nessus_id = n.nessus_id
               order by category desc, nessusgroup, nessus_id";
        $result=$dbconn->execute($sql);
        $counter = 0;

        if ($submit=="save") {
	    $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Save default profile", PEAR_LOG_NOTICE);
            while(!$result->EOF) {
                $counter++;
                $vname = "form".$counter;
		if (isset($_POST[$vname]))
		{
			$$vname=htmlspecialchars(mysql_escape_string(trim($_POST[$vname])), ENT_QUOTES);
		}
		elseif (isset($_GET[$vname]))
		{
			$logh->log("$username : " . $_SERVER['PHP_SELF']  . " : GET instead of POST method used - failed to save", PEAR_LOG_NOTICE);
			die("Please use the default.php form to submit your changes.");
		}
		else { $$vname=""; }
                list ($nessusgroup, $nessus_id, $field, $type, $default, $value, $category) = $result->fields;
                updatedb($nessus_id, $$vname, $dbconn, $type, $category, $logh);
                $result->MoveNext();
            }

			# find all records in the nessus_preferences table that 
			# have no matching value in nessus_preferences_defaults
			# and delete them from nessus_preferences

            $sql = "select n.nessus_id from nessus_preferences n
                   left join nessus_preferences_defaults t
                   on n.nessus_id = t.nessus_id
                   where t.nessus_id is null";
            $result=$dbconn->execute($sql);

            while(!$result->EOF) {
                list ($pleasedeleteme) = $result->fields;

                $sql2 = "delete from nessus_preferences
                        where nessus_id = \"$pleasedeleteme\"";
                $result2=$dbconn->execute($sql2);
		$logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Deleted obselete config item $pleasedeleteme", PEAR_LOG_DEBUG);
                $result->MoveNext();
            }

            echo "<B>Nessus settings saved, please proceed to the <A href=\"defaults.php?prefs=3\">Plugins Selection</A> page.</B><BR>";
        }
        else {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Display default preferences table", PEAR_LOG_DEBUG);
            $lastvalue = "";
	    print "<form method=\"post\" action=\"defaults.php\"><input type=\"hidden\" name=\"prefs\" value=\"1\"><input type=\"submit\" name=\"submit\" value=\"save\"><BR>";
            while(!$result->EOF) {
                $counter++;
                list ($nessusgroup, $nessus_id, $field, $type, $default, $value, $category) = $result->fields;
                if ($nessusgroup != $lastvalue) {
                    print "<b>$nessusgroup</b><br>";
                    $lastvalue = $nessusgroup;
                }
                $vname = "form".$counter;
                print formprint($field, $vname, $type, $default, $value);
                $result->MoveNext();
            }

            echo "<INPUT type=\"submit\" name=\"submit\" value=\"save\">
            </form>
            ";
        }
    }
    elseif ($prefs=="4") {
        $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : View detault nessus configuration", PEAR_LOG_INFO);
        echo "<A href=\"defaults.php?prefs=1\">Preferences</A> | <A href=\"defaults.php?prefs=3\">Plugins</A> | <A href=\"defaults.php?prefs=4\">View Configuration File</a><BR><BR>";
        echo "<TEXTAREA rows=15 cols=80 >\n# This file was automagically created by Inprotect\n\n";

        $query="SELECT t1.* from nessus_plugins as t1, plugins as t2 where t1.id=t2.id and t2.category ='scanner' order by id";
        $result=$dbconn->Execute($query);
        echo "begin(SCANNER_SET)\n";
        while (!$result->EOF) {
            list ($id, $enabled) = $result->fields;
            $enabled1="yes";
            if ($enabled=="N") $enabled1="no";
            echo " $id = $enabled1\n";

            $result->MoveNext();
        }
        echo "end(SCANNER_SET)\n\n";

        $query="Select nessus_id, value from nessus_preferences where category='SERVER_PREFS'";
        $result=$dbconn->Execute($query);

        echo "begin(SERVER_PREFS)\n";

        while (!$result->EOF) {
            list( $nessus_id, $value)=$result->fields;

            echo " $nessus_id = $value\n";

            $result->MoveNext();
        }

        echo "end(SERVER_PREFS)\n\n";


        $query="Select nessus_id, value from nessus_preferences where category='PLUGINS_PREFS'";
        $result=$dbconn->Execute($query);

        echo "begin(PLUGINS_PREFS)\n";

        while (!$result->EOF) {
            list( $nessus_id, $value)=$result->fields;

            echo " $nessus_id = $value\n";

            $result->MoveNext();
        }

        echo "end(PLUGINS_PREFS)\n\n";

        $query="SELECT t1.* from nessus_plugins as t1, plugins as t2 where t1.id=t2.id and t2.category <>'scanner' order by id";
        $result=$dbconn->Execute($query);
        echo "begin(PLUGIN_SET)\n";
        while (!$result->EOF) {
            list ($id, $enabled) = $result->fields;
            $enabled1="yes";
            if ($enabled=="N") $enabled1="no";
            echo " $id = $enabled1\n";

            $result->MoveNext();
        }

        echo "end(PLUGIN_SET)\n\n";
        echo "</TEXTAREA>";
    }

    elseif ($prefs=="3") {
        echo "<A href=\"defaults.php?prefs=1\">Preferences</A> |
        <A href=\"defaults.php?prefs=3\">Plugins</A> | <A href=\"defaults.php?prefs=4\">View Configuration File</a>";

        if ($submit=="submit") {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Save default plugins list", PEAR_LOG_NOTICE);
            reset ($_POST);   // if form method="post"

            $result=$dbconn->Execute("Update nessus_plugins set enabled='N'");

            while (list($key, $value) = each ($_POST)) {
		$key=htmlspecialchars(mysql_escape_string(trim($key)), ENT_QUOTES);
                if (substr($key,0,3)=="PID") {
                    $key=substr($key, 3);
                    if(is_numeric($key)) {
			$results=$dbconn->Execute("Update nessus_plugins set enabled='Y' where ID=$key");
		    }
                }
            }
        }
        if ($AllPlugins=="Enable All") {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Selected enable all plugins", PEAR_LOG_INFO);
            $result=$dbconn->Execute("Update nessus_plugins set enabled='Y'"); }

        if ($NonDOS=="Enable Non DOS") {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Selected enable all non dos plugins", PEAR_LOG_INFO);
            $result=$dbconn->Execute("Update nessus_plugins set enabled='N'");

            $result=$dbconn->Execute("select id from plugins where category<>'denial' and category<>'destructive_attack'");
            while (list($enableid)=$result->fields) {
                $result1=$dbconn->Execute("Update nessus_plugins set enabled='Y' where id=$enableid");
                $result->MoveNext();
            }
        }
	if ($DisableAll=="Disable All") {
	    $query="update nessus_plugins set enabled='N'";
	    $result=$dbconn->execute($query);
	}
	
        echo "<form method=\"post\" action=\"defaults.php\"><input type=\"hidden\" name=\"prefs\" value=\"3\">";
        echo "<table>
        <tr><td colspan=2>Plugins</td></tr>";

        $result=$dbconn->Execute("Select count(id) plugincount from plugins");
        list($pcount)=$result->fields;
        $result=$dbconn->Execute("Select count(id) plugincount from nessus_plugins where enabled='Y'");
        list($penabled)=$result->fields;

        echo "<tr><td colspan=2>$pcount Nessus plugins available, $penabled - enabled</td></tr>\n";
        echo "<tr><td colspan=2><input type=\"submit\" name=\"AllPlugins\" value=\"Enable All\"><input type=\"submit\" name=\"NonDOS\" value=\"Enable Non DOS\"><input type=\"submit\" name=\"DisableAll\" value=\"Disable All\"><FONT SIZE=\"1\"><BR><BR></FONT><input type=\"submit\" name=\"submit\" value=\"submit\"></td></tr>";


        $result=$dbconn->Execute("Select distinct family from plugins where family<>'' order by family");
        while (list($family)=$result->fields) {
            echo "<tr><td colspan=2><b>$family</b><hr></td></tr>\n";

            $result1=$dbconn->Execute("Select t1.id, t1.name, t1.category, t2.enabled from plugins as t1, nessus_plugins as t2 where t1.family='$family' and t1.id=t2.id order by t1.name");
            while(list($pid, $pname, $pcategory, $penabled)=$result1->fields) {
                echo "<tr><td align=\"right\"><INPUT type=checkbox name=\"PID$pid\" ";
                if ($penabled=="Y") {
                    echo "checked ";
                }
                echo "id=$pid></td><td><a target=\"_new\" href=\"lookup.php?id=$pid\">$pname</a> | $pcategory</td></tr>\n";
                $result1->MoveNext();
            }
            $result->MoveNext();
        }

        echo "</table>";
        echo "<input type=\"submit\" name=\"submit\" value=\"submit\"></form>";

        $result->Close();
    }
}

include("footer.php");


function updatedb($nessus_id, $fieldvalue, $dbconn, $type, $category, $logh) {
    if ($type=="C" and $fieldvalue=="") {
        $fieldvalue="no";
    }
    else
    {
	$fieldvalue=htmlspecialchars(mysql_escape_string(trim($fieldvalue)), ENT_QUOTES);
    }

    $sql = "select count(*) from nessus_preferences where nessus_id = \"$nessus_id\"";
    $result=$dbconn->execute($sql);

    list($existing)=$result->fields;
    if ($existing == 0) {
	# Do an insert statement
	$logh->log("$username : " . $_SERVER['PHP_SELF']  . " : New default preference added - " . $nessus_id, PEAR_LOG_INFO);
        $sql = "insert nessus_preferences set nessus_id = \"$nessus_id\", value=\"$fieldvalue\", type=\"$type\", category=\"$category\"";
    }
    else {
        $sql = "update nessus_preferences set value=\"$fieldvalue\", type=\"$type\", category=\"$category\" where nessus_id = \"$nessus_id\"";
    }
    $result=$dbconn->execute($sql);
}


function formprint($field, $vname, $type, $default, $value) {
	# The pseudocode below will load a default value for an undefined field
	# to help make it easier for new fields to be added into the structure
	#
    $retstr = "";
    if ( is_null($value)) {
        if ($type == "R") {
            $value = explode(";", $default);
            $value = $value[0];
        }
        else {
            $value = $default;
        }
    }

    if ($type == "C") {
		# Checkbox code here
        $retstr="$field <INPUT type=\"checkbox\" name=\"$vname\" value=\"yes\"";
        if ($value=="yes") {
            $retstr.=" checked";
        }
        $retstr.="><BR>";
    }
    elseif ($type == "R") {
		# Radio button code here
        $retstr="$field <BR>";
        $array = explode(";", $default);
        foreach($array as $myoption) {
            $retstr.="<INPUT type=\"radio\" name=\"$vname\" value=\"$myoption\"";
            if ($value == $myoption) {
                $retstr.=" checked";
            }
            $retstr.="> $myoption<BR>";
        }
    }
    elseif ($type == "P") {
		# Password code here
        $retstr="$field <INPUT type=\"password\" name=\"$vname\" value=\"$value\"><BR>";
    }
    else {
		# Assume it is a text box
        $retstr="$field <INPUT type=\"text\" name=\"$vname\" value=\"$value\"><BR>";
    }
    $retstr .= "\n";
    return $retstr;
}
?>
