<?php
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

// don't want header for text output
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
//require_once('permissions.inc.php');
require_once('adodb/tohtml.inc.php');

/* dont need any of this
$getParams = array( "scantime", "scantype", "schedid", "reporttype",
                    "sortby", "uid" );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 

      } else { 
         $$gp=""; 
      }
   }
	break;
}
*/ 

// admin and reports roles have extra permissions, check if user has either
/*
$admin = (strpos($_SESSION['roles'],"admin") === false) ? FALSE : TRUE;
$eview= (strpos($_SESSION['roles'],"eview") === false) ? FALSE : TRUE;
$esubmit= (strpos($_SESSION['roles'],"esubmit") === false) ? FALSE : TRUE;
$eapprove= (strpos($_SESSION['roles'],"eapprove") === false) ? FALSE : TRUE;
*/

if(!($uroles[admin] || $uroles[eview] || $uroles[esubmit] || $uroles[eapprove])) {
   echo "Error: invalid permissions to request this page.";
   die();
}

$query="select *
        from exceptions 
        order by submitdate";
$result=$dbconn->execute($query);

if($result === false) {
   echo "Error retrieving exceptions from DB: " . $dbconn->ErrorMsg();
   die();
}

//$data = $result->GetArray();

$tmpdate = date("Y-m-d");
//Generated date
$gendate = date("m/d/Y H:i:s");

// send the right content headers
header("Content-Type: application/vnd.ms-excel; name='excel'");
header("Content-disposition:  attachment; filename=exceptions-$tmpdate.xls");
rs2html($result,('border=1'));
/*
// Set up the output table
//$dataHead = <<<EOT
echo <<<EOT
<table border=1>
<tr>
   <th colspan=9>Exceptions</th>
</tr>
<tr>
   <th>Scan time:</th>
   <td colspan=8 align=left>$tmpdate</td>
</tr>
<tr>
   <th>Generated:</th>
   <td colspan=8 align=left>$gendate</td>
</tr>
<tr>
   <th>Profile:</th>
   <td colspan=8 align=left>$profile_name - $profile_desc</td>
</tr>
<tr>
   <th>Schedule:</th>
   <td colspan=8 align=left>$sched_name</td>
</tr>
<tr>
   <th>Owner:</th>
   <td colspan=8 align=left>$sql_uid</td>
</tr>
<tr>
   <th>IP</th>
   <th>Host</th>
   <th>Port</th>
   <th>Protocol</th>
   <th>Service</th>
   <th>Severity</th>
   <th>ScriptID</th>
   <th>Description</th>
EOT;
echo "</table>";
*/

?>
