<?php
//
// $Id: portscanres.php,v 1.7 2006/09/19 04:57:00 airwofl Exp $
//

$pageTitle = "Port Scan Results";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//include ('permissions.inc.php');

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
	if (isset($_GET['op'])) { $op=htmlspecialchars(mysql_escape_string(trim($_GET['op'])), ENT_QUOTES); }
	else { $op=""; }
	if (isset($_GET['uid'])) { $uid=htmlspecialchars(mysql_escape_string(trim($_GET['uid'])), ENT_QUOTES); }
	else { $uid=""; }
	if (isset($_GET['pid'])) { $pid=htmlspecialchars(mysql_escape_string(trim($_GET['pid'])), ENT_QUOTES); }
	else { $pid=""; }
	if (isset($_GET['sortby'])) { $sortby=htmlspecialchars(mysql_escape_string(trim($_GET['sortby'])), ENT_QUOTES); }
	else { $sortby=""; }
	if (isset($_GET['allres'])) { $allres=htmlspecialchars(mysql_escape_string(trim($_GET['allres'])), ENT_QUOTES); }
	else { $allres=""; }
	break;
}

$acl=checkacl("nmap", $dbconn);
$acladmin=checkacl("admin", $dbconn);

if ($acl!="Y") {
    echo "Access Denied! You do not have the rights to view Portscan (Nmap) results";
    $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Access denied", PEAR_LOG_WARNING);
}
else {
    $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Accessed Page", PEAR_LOG_DEBUG);
    echo "<font face=\"Verdana\" color=\"#666666\" size=\"4\">Nmap Portscan Results</font><br>";

    if ($op=="view") {
	$logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Viewing portscan results", PEAR_LOG_INFO);
	
	$uid_filter=0;
	if ($uid<>"") { $uid_filter=1; }

        $query="select count(id), username from portscan where id=$pid group by username";
        $result=$dbconn->execute($query);

        list ($pcount, $sql_uid)=$result->fields;

        if ($pcount<>0) {
	    if ($sql_uid!=$username)
	    {
		if ($acladmin!="Y") { die("Cannot access this page - You are not the report owner or an admin."); }
		else
		{
		    if (!$uid_filter)
		    {
			$uid_filter=1;
			$uid=$sql_uid;
		    }
		    else
		    {
			if ($sql_uid!=$uid) { die("Cannot access this page - error detected in URL (uid's don't match)."); }
		    }
		}
	    }
	    else { $uid=$username; }

            $previp="";

	    $sql_order="order by host, ";
	    $sql_order2="port";

	    if ($sortby=="" || !is_numeric($sortby)) { $sortby=0; }
	    if ($sortby==0) { // Do nothing as the required sql gets appended at the end of this IF block
	    }
	    elseif ($sortby==1) { $sql_order2="port DESC"; }
	    elseif ($sortby==2) { $sql_order.="type, port"; }
	    elseif ($sortby==3) { $sql_order.="type DESC, port"; }
	    elseif ($sortby==4) { $sql_order.="status, port"; }
	    elseif ($sortby==5) { $sql_order.="status DESC, port"; }
	    elseif ($sortby==6) { $sql_order.="description"; }
	    elseif ($sortby==7) { $sql_order.="description DESC"; }
	    elseif ($sortby==8) { $sql_order.="version"; }
	    elseif ($sortby==9) { $sql_order.="version DESC"; }

	    $sql_order.=$sql_order2;

            $query="select host, port, type, status, description, version from portscan_results where id=$pid ".$sql_order;
            $result=$dbconn->execute($query);

            while(!$result->EOF) {
                list($phost, $pport, $ptype, $pstatus, $pdescription, $pversion)=$result->fields;
                if ($previp<>$phost) {
		    if ($firstresloop>1) { echo "</table>"; }
		    $firstresloop=1;
                    echo "<br><font color=\"#FF0000\"><b>$phost</b></font>";

                    $hostos="";
                    $query1="select os from portscan_os where id=$pid and host='$phost'";
                    $result1=$dbconn->execute($query1);
                    while(!$result1->EOF) {
                        list($hostos)=$result1->fields;
                        $result1->MoveNext();
                    }

		    if ($hostos=="") { $hostos="Unknown OS"; }
		    echo " - $hostos<br>";
                    $previp=$phost;
                }
                if ($firstresloop==1) { echo "<table summary=\"Nmap Results\" border=\"1\" cellpadding=\"1\" cellspacing=\"1\" style=\"border-collapse: collapse\"><tr><td><b>Port&nbsp;&nbsp;</b></td><td><b>Protocol&nbsp;&nbsp;</b></td><td><b>Status&nbsp;&nbsp;</b></td><td><b>Service&nbsp;&nbsp;</b></td><td><b>Version / Banner info&nbsp;&nbsp;</b></td></tr>"; }
                echo "<tr>
                <td>$pport&nbsp;&nbsp;</td><td>$ptype&nbsp;&nbsp;</td>
                <td>$pstatus&nbsp;&nbsp;</td><td>$pdescription&nbsp;&nbsp;</td>
                <td>$pversion&nbsp;&nbsp;</td></tr>";
		$firstresloop++;
                $result->MoveNext();
            }

            echo "</table>";
        }
	else { echo "Cannot access this page - Portscan details not in the database."; }
    }
    elseif ($op=="del") {

        $query="select count(id) from portscan where id=$pid and username='$username'";
        $result=$dbconn->execute($query);

        list ($pcount)=$result->fields;

        if ($pcount<>0) {
	    $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Delete portscan results", PEAR_LOG_NOTICE);

            $query="delete from portscan_results where id=$pid";
            $result=$dbconn->execute($query);
            $query="delete from portscan where id=$pid";
            $query=$dbconn->execute($query);
            echo "Results deleted. <a href=\"portscanres.php\">Back</a> to the results page.";
        }
	else { echo "Portscan results cannot be found or Permission denied. N.B. Only the report owner can delete results"; }
    }
    else {
	$sql_order="order by ";
	$sql_order2="submittime DESC";

	if ($sortby=="" || !is_numeric($sortby)) { $sortby=0; }
	if ($sortby==0) { // Do nothing as the required sql gets appended at the end of this IF block
	}
	elseif ($sortby==1) { $sql_order2="submittime"; }
	elseif ($sortby==2) { $sql_order.="username, "; }
	elseif ($sortby==3) { $sql_order.="username DESC, "; }
	elseif ($sortby==4) { $sql_order.="scanip, "; }
	elseif ($sortby==5) { $sql_order.="scanip DESC, "; }
	elseif ($sortby==6) { $sql_order.="scancomplete, "; }
	elseif ($sortby==7) { $sql_order.="scancomplete DESC, "; }

	$sql_order.=$sql_order2;

	$url_phppost="<a href=\"portscanres.php?";
	$url_sortby=$url_phppost."sortby=";

	if ($acladmin=="Y")
	{
            $url_allres="allres=";
            echo "<br>";

            if ($allres=="" || !is_numeric($allres) || (!$allres))
            {
                $allres=0;
                if (($sortby > 1) && ($sortby < 4)) { echo $url_phppost.$url_allres; }
                else { echo $url_sortby.$sortby."&".$url_allres; }
                echo "1\">Show all results</a><br>";
            }
            else
	    {
		$allres=1;
		echo $url_sortby.$sortby."&".$url_allres."0\">Show only your results</a><br>";
	    }
	}

	$sql_onlyuser="";
	if (($acladmin!="Y") || (!$allres)) { $sql_onlyuser="where username='$username' "; }

        $query="select id, username, scanip, submittime, scancomplete from portscan ".$sql_onlyuser.$sql_order;
        $result=$dbconn->execute($query);
	echo "<br>
<table summary=\"Nmap Results\" border=\"1\">
<tr><td>&nbsp;</td><td><b>$url_sortby";

	if ($sortby==0) { echo "1"; } else { echo "0"; }
	if (($acladmin=="Y") && $allres) { echo "&".$url_allres."1"; }
	echo "\">Scan Time</a>&nbsp;</b></td><td><b>$url_sortby";
	if (($acladmin=="Y") && $allres)
	{
	    if ($sortby==2) { echo "3"; } else { echo "2"; }
	    echo "&".$url_allres."1";
	    echo "\">Owner</a>&nbsp;</b></td><td><b>$url_sortby";
	}
	if ($sortby==4) { echo "5"; } else { echo "4"; }
	if (($acladmin=="Y") && $allres) { echo "&".$url_allres."1"; }
	echo "\">Host(s)</a>&nbsp;</b></td><td><b>$url_sortby";
	if ($sortby==6) { echo "7"; } else { echo "6"; }
	if (($acladmin=="Y") && $allres) { echo "&".$url_allres."1"; }
	echo "\">Status</a>&nbsp;</b></td></tr>";

        while(!$result->EOF) {
            list($pid, $sql_uname, $pscanip, $ptime, $pstatus)=$result->fields;

	    $ftime = dateformat($ptime);

            echo "<tr><td><a href=\"portscanres.php?op=view&amp;pid=$pid";

	    if (($acladmin=="Y") && $allres) { echo "&amp;uid=$sql_uname"; }

	    echo "\">View</a> | <a href=\"portscanres.php?op=del&amp;pid=$pid\">Del</a></td>
            <td>$ftime</td>";
	    if (($acladmin=="Y") && $allres) { echo "<td>$sql_uname</td>"; }
	    echo "<td>$pscanip</td>
            <td>$pstatus</td>
            </tr>";
            $result->MoveNext();
        }
        echo "</table>";
    }
}

include('footer.php');

function dateformat($scantime) {
    if (strlen($scantime) != 14) {
        return $scantime;
    }
    $rval=substr($scantime,0,4)."-"
          .substr($scantime,4,2)."-"
          .substr($scantime,6,2)." "
          .substr($scantime,8,2).":"
          .substr($scantime,10,2).":"
          .substr($scantime,12,2);
    return $rval;

}
?>
