<?php
//
// $Id: results.php,v 1.10 2006/09/20 13:03:48 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Scan Results";
require_once('config.php');
require_once("functions.inc");
require_once('auth.php');
//require_once('permissions.inc.php');
require_once('header2.php');

$getParams = array( 
                    'scantime',
                    'scantype',
                    'schedid',
                    'reporttype',
                    'sortby',
                    'allres',
                    'fp',
                    'nfp',
                    'op',
                    'output',
                    'wh',
                    'bg'
                  );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { $$gp=htmlspecialchars(mysql_escape_string(trim($_GET[$gp])), ENT_QUOTES); }
      else { $$gp = ""; }
   }
   break;
}

$allowedAccess = ($uroles['admin'] || $uroles['reports']) ? TRUE : FALSE;
  $sql_onlyuser="";
   if (!$allowedAccess || (!$allres)) { $sql_onlyuser="and t1.username='$username' "; }
   
if ($wh=="" || !is_numeric($wh) || $wh < 0) {
   $wh="10"; }
if ($bg=="" || !is_numeric($bg) || $bg < 0) {
   $bg="0"; }

if ($scantime=="") {
   $sql_order="order by ";
   $sql_order2="scantime DESC";

   if ($sortby=="" || !is_numeric($sortby)) { $sortby=0; }
   if ($sortby==0) { // Do nothing as the required sql gets appended at the end of this IF block
   }
   elseif ($sortby==1) { $sql_order2="scantime"; }
   elseif ($sortby==2) { $sql_order.="t1.username, "; }
   elseif ($sortby==3) { $sql_order.="t1.username DESC, "; }
   elseif ($sortby==4) { $sql_order.="t2.name, "; }
   elseif ($sortby==5) { $sql_order.="t2.name DESC, "; }
   elseif ($sortby==6) { $sql_order.="t3.name, "; }
   elseif ($sortby==7) { $sql_order.="t3.name DESC, "; }

   $sql_order.=$sql_order2;

   $url_phppost="<a href=\"results.php?";
   $url_sortby=$url_phppost."sortby=";
   $url_limit_begin="&wh=$wh&bg=0";
   $wh_top=$bg+$wh;
   echo "<H2>Nessus scan results:</H2>";
   if ($allowedAccess) {
      $url_allres="allres=";
      echo "<br>";

      if ($allres=="" || !is_numeric($allres) || (!$allres)) {
         $allres=0;
         if (($sortby > 1) && ($sortby < 4)) { echo $url_phppost.$url_allres; }
         else { echo $url_sortby.$sortby.$url_limit_begin."&".$url_allres; }
         echo "1\">Show all results</a>";
      } else {
         $allres=1;
         echo $url_sortby.$sortby.$url_limit_begin."&".$url_allres."0\">Display only my Results</a>";
      }
   }
   	$query="select count(*) as totalcount from (select distinct t1.scantime, t1.username, t1.sched_id, t2.name, t3.name as name3
	from nessus_results as t1, nessus_schedule as t2, nessus_settings as t3
	where t1.scantype='A'
	and t1.sched_id = t2.id
	and t1.sid=t3.id
    ".$sql_onlyuser.") as a"; 

    $result=$dbconn->execute($query);
 	list($totalcount)=$result->fields;
    if ($totalcount>10){
	$rescount=$url_sortby.$sortby."&".$url_allres.$allres;
        if (($bg+$wh)>=$totalcount){
       	 	$bg=$totalcount-$wh;
	 }
	$resccount_five=$rescount."&bg=".$bg."&wh=5\">";
    	$resccount_ten=$rescount."&bg=".$bg."&wh=10\">";
    $resccount_twenty=$rescount."&bg=".$bg."&wh=20\">";
    if ($wh_top>$totalcount){
    $wh_top=$totalcount;
	}
    echo "<br><br>";
	echo "Limit result set to: $resccount_five 5</a> | $resccount_ten 10</a> | $resccount_twenty 20</a>";
    echo "<br><br>Currently displaying results $bg through $wh_top of $totalcount results";
	if ($bg<$totalcount){
		$skip=$bg+$wh;
    }
    else {$bg=$totalcount-$wh;}
    
	$url_skip=$rescount."&bg=".$skip."&wh=".$wh."\">";
    
	if ($bg>$wh){
		$previous=$bg-$wh;
    }
    else {$previous=0;}
	$end_count=$totalcount-$wh;
	$url_previous=$rescount."&bg=".$previous."&wh=".$wh."\">";
	$url_begin=$rescount."&bg=0"."&wh=".$wh."\">";
	$url_end=$rescount."&bg=".$end_count."&wh=".$wh."\">";
	echo "<br><br>$url_begin First $wh results</a> | $url_previous << Previous $wh <</a> | $url_skip> Next $wh >></a>";
	echo " | $url_end Last $wh results</a>";
}
   echo <<<EOT
<br><br>
<table summary="Nessus scan results" border=1 cellspacing="0" cellpadding="2" style="border-collapse: collapse">
<tr>
<th></th>
<th>$url_sortby
EOT;

   if ($sortby==0) { echo "1"; } else { echo "0"; }
   if ($allowedAccess && $allres) { echo "&".$url_allres."1"; }
   echo '">Date/Time</a></th><th>'.$url_sortby;

   if ($allowedAccess && $allres) {
      if ($sortby==2) { echo "3"; } else { echo "2"; }
      echo "&".$url_allres."1";
      echo '">Owner</a></th><th>'.$url_sortby;
   }
   if ($sortby==4) { echo "5"; } else { echo "4"; }
   if ($allowedAccess && $allres) { echo "&".$url_allres."1"; }
   echo '">Schedule</a></th><th>'.$url_sortby;
   if ($sortby==6) { echo "7"; } else { echo "6"; }
   if ($allowedAccess && $allres) { echo "&".$url_allres."1"; }
   echo '">Profile</a></th><th></th></tr>';



    $limit=" LIMIT $bg, $wh ";
    $query="select distinct t1.scantime, t1.username, t1.sched_id, t2.name, t3.name 
    from nessus_results as t1, nessus_schedule as t2, nessus_settings as t3 
    where t1.scantype='A'
    and t1.sched_id = t2.id 
    and t1.sid=t3.id 
    ".$sql_onlyuser.$sql_order.$limit; 

   $result=$dbconn->execute($query);
   while(list($scantime, $sql_uid, $schedid, $sname, $sidname) = $result->fields) {
      $fscantime = dateformat($scantime);
      echo <<<EOT
<tr>
<td>
<a href="results.php?output=full&amp;scantime=$scantime&amp;scantype=A&amp;schedid=$schedid
EOT;

      if ($allowedAccess && $allres) { echo "&amp;uid=$sql_uid"; }

      echo <<<EOT
"><img alt="HTML" src="images/html.png" border=0 title="Full Report in HTML format"></A>
EOT;
/*
<a href="results.php?output=full&amp;scantime=$scantime&amp;scantype=A&amp;schedid=$schedid

      if ($allowedAccess && $allres) { echo "&amp;uid=$sql_uid>"; }

      echo <<<EOT
"<img alt="HTML" src="images/html_delete.png" border=0 title="Minimal Report in HTML format"></A>
*/
      echo <<<EOT
<a href="respdf.php?output=min&amp;scantime=$scantime&amp;schedid=$schedid&scantype=A
EOT;

      if ($allowedAccess && $allres) { echo "&amp;uid=$sql_uid>"; }

      echo <<<EOT
"<img alt="PDF" src="images/page_white_acrobat.png" border=0 title="Report in PDF format"></A>
EOT;


// text/excel formatted report (tab separated)
      echo <<<EOT
&nbsp;<a href="restext.php?scantime=$scantime&amp;scantype=A&amp;schedid=$schedid"
EOT;
      if ($allowedAccess && $allres) { echo "&amp;uid=$sql_uid"; }
      echo <<<EOT
"><img alt="Text" src="images/page_white_excel.png" border=0 title="Report in Text format"></A>
EOT;

      echo '</td><td>'.$fscantime.'</td>';
      //if (($acl=="Y") && $allres) { echo '<td>$sql_uid</td>'; }
      if ($allowedAccess && $allres) { echo '<td>'.$sql_uid.'</td>'; }

      echo <<<EOT
<td>$sname</td>
<td>$sidname</td>
EOT;

      echo <<<EOT
<td><a href="results.php?scantime=$scantime&amp;schedid=$schedid&amp;op=delete">
<img alt="Delete" src="images/delete.png" border=0 title="Delete report"></a></td>
EOT;
      echo "</tr>";
      $result->MoveNext();
   }
   echo "</table>";
} elseif ($scantime<>"" and $scantype=="A" and $schedid<>"") {

   if (!is_numeric($schedid)) { die("Cannot access this page - error detected in URL."); }

   $uid_filter=0;
   if ($uid<>"") { $uid_filter=1; }

   $query="select count(id),username 
           from nessus_schedule 
           where id=$schedid 
           group by username";
   $result=$dbconn->execute($query);

   list($allowaccess, $sql_uid)=$result->fields;

   if ($allowaccess<>1) { die("Cannot access this page - Schedule details not in the database."); }

   $query="select count(sched_id),username 
           from nessus_results 
           where sched_id=$schedid 
                 and scantime='$scantime' 
           group by username";
   $result=$dbconn->execute($query);

   list($allowaccess, $sql_uid)=$result->fields;

   if ($sql_uid!=$username) {
      if (!$allowedAccess) { 
         die("Cannot access this page - You are not the report owner or an admin."); 
      } else {
         if (!$uid_filter) {
            $uid_filter=1;
            $uid=$sql_uid;
         } elseif (!$uroles['reports']) {
            if ($sql_uid!=$uid) { 
               die("Cannot access this page - error detected in URL (uid's don't match)."); 
            }
         } else {
            $uid = $sql_uid;
         }
      }
   } else {
      $uid=$username;
   }

   // find the number of vulnerabilites for the selected user scan
   $query="select count(scantime) 
         from nessus_results 
         where scantime='$scantime' 
               and sched_id=$schedid 
               and username='$uid'";
   $result=$dbconn->execute($query);
   
   list($numofresults)=$result->fields;
   
   if ($numofresults<1) {die("No vulnerabilities recorded");}

   // process request to mark vulnerability as false positive
   if ($fp<>"") {
      if(!is_numeric($fp)) {
         die("Cannot access this page - error detected in URL (fp).");
      }

      $query="select count(id) 
               from nessus_schedule 
               where id=$schedid 
                  and username='$username'";
      $result=$dbconn->execute($query);

      list($allowaccess)=$result->fields;

      if ($allowaccess<>1) { 
         die("Cannot access this page - Only the owner is permitted to update the report."); 
      }

      $query="update nessus_results 
            set falsepositive='Y' 
            where result_id=$fp 
                 and username='$username' 
                 and sched_id=$schedid";
      $result=$dbconn->execute($query);

   }

   // process request to mark vulnerability as not false positive
   if ($nfp<>"") {
      if(!is_numeric($nfp)) {
         die("Cannot access this page - error detected in URL (nfp).");
      }

      $query="select count(id) 
            from nessus_schedule 
            where id=$schedid 
                  and username='$username'";
      $result=$dbconn->execute($query);

      list($allowaccess)=$result->fields;

      if ($allowaccess<>1) {
         echo "Cannot access this page - Only the owner is permitted to 
               update the report."; 
         require_once('footer.php');
         die();
      }

      $query="update nessus_results 
            set falsepositive='N' 
            where result_id=$nfp 
                  and username='$username' 
                  and sched_id=$schedid";
      $result=$dbconn->execute($query);
   }

   // get the info about the selected user scan
   $query="select distinct t1.username, t2.name, t3.name, t3.description 
           from nessus_results as t1, nessus_schedule as t2, 
               nessus_settings as t3 
           where t1.username='$uid' 
               and t1.scantype='A' 
               and t1.sched_id = t2.id 
               and t1.sid=t3.id 
               and scantime='$scantime'
               and t2.id = $schedid
           order by scantime DESC";
   $result=$dbconn->execute($query);
   if($result === false) {
      echo "SQL Error getting results: " . $dbconn->ErrorMsg();
   }
   list ($sql_uid, $sched_name, $profile_name, $profile_desc)=$result->fields;

   $tmpdate = dateformat($scantime);
   echo "<H2>Nessus scan results:";
   if($output=="min") { echo " Short format"; }
   echo <<<EOT
</h2>
<table cellpadding="2" border="0" cellspacing="2">
<tr><th>Scan time:</th><td>$tmpdate</td>
EOT;

   //Generated date
   $gendate = date("m/d/Y H:i:s");

   echo <<<EOT
<th valign="top">Generated:</th><td>$gendate</td></tr>
<th valign="top">Profile:</th><td>$profile_name - $profile_desc</td>
<th valign="top">Schedule:</th><td>$sched_name</td></tr>
<tr>
<th valign="top">Owner:</th>
<td colspan=3>$sql_uid</td>
</tr>
</table>
<br>
<A HREF="results.php?scantime=$scantime&scantype=$scantype&schedid=$schedid
EOT;
   if ($sortby==1) { echo '">Sort results by Risk'; }
   else { echo '&sortby=1">Sort results by Service'; }
   echo "</A><BR>";

   // get the count for each risk level so we can draw the graph
   $query="SELECT count(risk) as count, risk 
                          FROM `nessus_results` 
                          where scantime='$scantime' 
                                and username='$uid' 
                                and sched_id=$schedid 
                                and falsepositive<>'Y' 
                                and scriptid <> 10180 ";
   // for minimized output, don't include risk=[6|7]
   //if($output=="min") {
   //   $query.=" and risk <> '7' and risk <> '6'";
   //}
   $query.=" group by risk";
   //echo $query . "\n";
   $result=$dbconn->Execute($query);
   //print_r($result);
   $prevrisk=0;
   $chartimg="graph1.php?graph=1";
   while (list($riskcount, $risk)=$result->fields) {
      for ($i=0;$i<$risk-$prevrisk-1;$i++) {
         $missedrisk=$prevrisk+$i+1;
         $chartimg.="&amp;risk$missedrisk=0";
      }
      $prevrisk=$risk;
      $chartimg.="&amp;risk$risk=$riskcount";
      $result->MoveNext();
   }

   // print out the pie chart
   echo <<<EOT
<font size="1"><br></font><img alt="Chart" src="$chartimg">
<br><br>
EOT;

   // set up the table for the summary results
   echo <<<EOT
<font color="red"><b>Summary of scanned hosts</b></font>
<br>
<table summary="Summary of scanned hosts" border="1" cellspacing="2" cellpadding="2" style="border-collapse: collapse">
<tr>
<th>Host</th>
<th>Serious</th>
<th>High</th>
<th>Medium</th>
<th>Medium/Low</th>
<th>Low/Medium</th>
<th>Low</th>
<th>Info</th>
<th>Trend</th>
</tr>
EOT;

   // get the list of hosts for this run
   $query = "select distinct nr.host, h.hostname 
             from nessus_results as nr
             left join hosts as h
             on nr.host=h.ip
             where nr.scantime='$scantime' 
                and nr.username='$uid' 
                and nr.sched_id=$schedid ";
/*
   $nscount=0;
   foreach ($nostatus as $ns) {
      if($nscount >= 1) { $query .= " and ";
      $query .= " h.status<>'$ns' ";
      $nscount++;
   }
*/
   //the next like breaks the web ap in upgrades
   //$query .= " and h.status NOT IN ('" . implode("','",$nostatusArray) . "') ";
   $query .= " order by INET_ATON(nr.host) ASC";

   $result=$dbconn->execute($query); 
   $hosts=array();
   while(list($hostip, $hostname)=$result->fields) {
      $hosts[$hostip]=$hostname; // create array of all hosts in this scan for use later
      //echo '<tr><td><a href="results.php?scantime='.$scantime.'&amp;scantype=A&amp;schedid='.$schedid.'#'.$hostip.'">'.$hostip.' - '.$hostname.'</a></td>';
      echo '<tr><td><a href="#'.$hostip.'">'.$hostip.' - '.$hostname.'</a></td>';

      $prevrisk=0;

      // get the results for each host
      $query="SELECT count(risk) as count, risk 
            FROM `nessus_results` 
            where scantime='$scantime' 
                  and username='$uid' 
                  and sched_id=$schedid 
                  and host='$hostip' 
                  and falsepositive<>'Y' 
                  and scriptid <>10180 
            group by risk";
      $result1=$dbconn->execute($query);

      $drawtable=0;

      while(list($riskcount, $risk)=$result1->fields) {
         $drawtable=1;
         for ($i=0;$i<$risk-$prevrisk-1;$i++) {
            echo "<td>-</td>";
         }

         echo "<td>$riskcount</td>";
         $prevrisk=$risk;
         $result1->MoveNext();
      }

      if ($drawtable==0) {
         echo "<td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td>";
      }
      echo '<td><a href="trend.php?submit=Go&amp;type=1&amp;ip='.$hostip.'&amp;days=30';

      if ($allowedAccess && $uid_filter) { echo "&amp;uid=$sql_uid"; }
      echo '"><img alt="Trend" border=0 src="images/trend.png"></a></td>';
      echo "</tr>";
      $result->MoveNext();
   }
   echo "</table><p>";

   // print the icon legend
   if ($enableFP) {
      echo "<img alt='True' src='images/true.png' border=0> - True result&nbsp;&nbsp;";
      echo "<img alt='False' src='images/false.png' border=0> - False positive result&nbsp;&nbsp;";
   }
   if ($enableNotes) {
      echo "<img alt='Note' src='images/note.png' border=0> - Add a custom note&nbsp;&nbsp;";
   }
   echo "<img alt='Info' src='images/info.png' border=0> - Additional information is available</p>";

/* reuse $hosts array from previous query
$result=$dbconn->execute("select distinct host 
                          from nessus_results 
                          where scantime='$scantime' 
                                and username='$uid' 
                                and sched_id=$schedid 
                          order by INET_ATON(host) ASC");

while(list($hostip)=$result->fields) {
*/

   // walk through the hosts in this scan and output the detailed results
   foreach($hosts as $hostip=>$hostname) {
      if($output=="min") { 
         echo "<h3>Details for Serious, High, Medium and Medium/Low severity risks only.</h3>"; 
      }
      echo <<<EOT
<br><font color="red"><b><a name="$hostip">$hostip - $hostname</a></b></font>
<table summary="$hostip - Open Ports">
<tr><th colspan=2>Open Ports</th></tr>
EOT;

      // get the "open ports", defined as a risk=7 with no msg
      $query="select username, service, risk, 
                     falsepositive, result_id 
            from nessus_results 
            where scantime='$scantime' 
                  and username='$uid' 
                  and sched_id=$schedid 
                  and host='$hostip' 
                  and msg='' 
                  and risk='7'
            order by result_id ASC";
      $result1=$dbconn->execute($query); 

      $arrResults="";

      while(list( $sql_uid, 
                  $service, 
                  $risk, 
                  $falsepositive, 
                  $resid) = $result1->fields ) {
         $tmpport1=preg_split("/\(|\)/",$service);
         $tmpport2=preg_split("/\//",$tmpport1[1]);
         $service_num=$tmpport2[0];
         $service_proto=$tmpport2[1];

         $arrResults[]=array( $sql_uid, 
                              $service_num, 
                              $service_proto, 
                              $service, 
                              $risk, 
                              $falsepositive, 
                              $resid);
         $result1->MoveNext();
      }

      if(!empty($arrResults)) {
         uasort ($arrResults, 'arrPortResultsCompare');
      }

      $k=1;
      $pos = "";
      if(!empty($arrResults)) {
         foreach ($arrResults as $key=>$value) {
            list( $sql_uid, 
                  $service_num, 
                  $service_proto, 
                  $service, 
                  $risk, 
                  $falsepositive, 
                  $resid) = $value;

            if($k % 2) {
               echo "<tr><td>$service</td>";
               $pos = "open";
            } else {
               echo "<td>$service</td></tr>";
               $pos = "closed";
            }
            $k++;

   /* not necessary for just open ports
      if ($falsepositive=="Y") {
         if ($sql_uid==$username) {
            echo '<a href="results.php?scantime='.$scantime.'&amp;scantype='.$scantype.'&amp;schedid='.$schedid.'&amp;nfp='.$resid.'">';
         }
         echo '<img alt="Clear false positive" src="images/false.png" title="Clear false positive" border=0>';
      } else {
         if ($sql_uid==$username) {
            echo '<a href="results.php?scantime='.$scantime.'&amp;scantype='.$scantype.'&amp;schedid='.$schedid.'&amp;fp='.$resid.'">';
         }
         echo '<img alt="Mark as false positive" src="images/true.png" title="Mark as false positive" border=0>';
      }

      if ($sql_uid==$username) { echo "</a>"; }
*/

            $result1->MoveNext();
         }
         // close up the table
         if($pos!="closed") {
            echo "<td>&nbsp;</td></tr>";
         }
      } else {
         echo "<tr><td>No open ports found</td></tr>";
      }
      echo "</table><p></p>";


   // now for the real risks (1-7) with msg<>''
   // set up the table
      echo <<<EOT
<table summary="$hostip - risks">
<tr>
<th>Service</th>
<th>Severity</th>
<th>PluginID</th>
<th>Description</th>
</tr>
EOT;

      // get the scan results for the host
      $query="select username, service, risk, 
                     falsepositive, result_id, 
                     msg, scriptid 
            from nessus_results 
            where scantime='$scantime' 
                  and username='$uid' 
                  and sched_id=$schedid 
                  and host='$hostip' 
                  and msg<>'' ";
      // for minimized output, don't include risk=[5|6|7]
      if($output=="min") {
         $query.=" and risk NOT IN( '7', '6', '5')";
      }
      $query.=" order by risk ASC, result_id ASC";
      $result1=$dbconn->execute($query);

      $arrResults="";

      while(list( $sql_uid, 
                  $service, 
                  $risk, 
                  $falsepositive, 
                  $resid, 
                  $msg, 
                  $scriptid) = $result1->fields ) {
         $tmpport1=preg_split("/\(|\)/",$service);
         if (sizeof($tmpport1)==1) { $tmpport1[1]=$tmpport1[0]; }
   #echo "$tmpport1[0] $tmpport1[1]<BR>";
         $tmpport2=preg_split("/\//",$tmpport1[1]);
   #echo "$tmpport2[0] $tmpport2[1]<BR>";
         $service_num=$tmpport2[0];
         $service_proto=$tmpport2[1];
   
         $arrResults[]=array( $sql_uid, 
                              $service_num, 
                              $service_proto, 
                              $service,
                              $risk, 
                              $falsepositive, 
                              $resid, 
                              $msg, 
                              $scriptid );
         $result1->MoveNext();
      }

      if(!empty($arrResults)) {
         uasort ($arrResults, 'arrScanResultsCompare');
      } else { // empty, print out message
         echo "<td colspan=3>No vulnerability results matching this reports 
               filtering criteria were found.</td></tr>";
      }
   
      foreach ($arrResults as $key=>$value) {
         list( $sql_uid, 
               $service_num, 
               $service_proto, 
               $service, 
               $risk, 
               $falsepositive, 
               $resid, 
               $msg, 
               $scriptid ) = $value;

// No need to do this anymore as the HTML entities are converted when
// importing the results
//            $msg=htmlspecialchars($msg);

// Do NOT do a check for admin and filter out username var here. 
// Otherwise you will get all user's comments due to the poor way
// the Inprotect DB is structured.

         // Print Notes associated with this result (resid)
         // modified to remove username filter - will tag the note with the
         // username which we now get in the results
         if ($enableNotes) {
            $result_note=$dbconn->execute("select note, username 
                                          from nessus_notes 
                                          where pid=$scriptid 
                                                and resid = $resid");
                                                //and username='$username'");
            //The next line breaks for upgrade installs
            //$notes=$result_note->GetArray();
            if (count($notes)>0) {
               $msg.='<p><FONT COLOR="#0044FF"><B>Custom Notes:</B>';
               /* removed, getting all data in one query now...
               $note_num=1;
               $query_note="select note 
                           from nessus_notes 
                           where username='$username' 
                                 and pid=$scriptid";
               $result_note=$dbconn->execute($query_note);
               while(!$result_note->EOF) {
               */
               foreach($notes as $note_num=>$customnote) {
                  //list($customnote)=$result_note->fields;
                  $note_num++; // do this as the index starts at 0
                  $msg.="\n$note_num. [$customnote[username]] - $customnote[note]";
                  //$note_num++;
                  //$result_note->MoveNext();
               }
               $msg.="</FONT></p>";
            }
         } // end Print Notes

         $msg=preg_replace("/^[ \t]*/","",$msg);
         $msg=preg_replace("/\n/","<br>",$msg);
//         $tr = array("\\n" => "<br>");
//         $msg=strtr($msg,$tr);
         //$msg=wordwrap(preg_replace("/\n/","<br>",$msg),100,"<br>",1);
         $msg=wordwrap($msg,100,"<br>",1);

         // Add Exceptions
         //if ($enableException && $risk <= 6) {
         if ($enableException) {
            $msg .= "<p><FONT COLOR='#0044FF'><b>Exceptions:</b><br>";
            if ($uroles['eview'] || $uroles['esubmit'] || $uroles['eapprove']) {
               $msg .= printException($hostip, $scriptid, $dbconn, FALSE,
                                      $hostname, $service_num);
            }
            //if ($esubmit) {
            //   $msg .= addException($hostip,$resid,$scriptid,$schedid,$hostname);
            //}
         } // end Exceptions

         $tmprisk = getrisk($risk);

         // output the table cells
         echo <<<EOT
<tr>
<td>$service</td>
<td>$tmprisk</td>
<td>$scriptid</td>
<td width="70%">
<A class="msg" NAME="$resid"></a>$msg
<font size="1">
<br><br>
</font>
EOT;

         // Add link to popup with Script Info
         echo <<<EOT
<a href="lookup.php?id=$scriptid" onClick="popup('lookup.php?id=$scriptid','lookup'); return false;">
<img alt="Info" src="images/info.png" title="More info..." border=0></a>
EOT;
         // Add Custom Notes icon
         // don't filter on username - any user can add a note to any result
         //if ($sql_uid==$username) {
         if($enableNotes) {
            if ($output=="min") {
               echo <<<EOT
&nbsp;&nbsp;
<a href="notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&schedid=$schedid&sortby=$sortby&resid=$resid&httpfrom=resmin" 
  onClick="popup('notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&schedid=$schedid&sortby=$sortby&resid=$resid&httpfrom=resmin','Notes'); 
  return false;"><img alt="Note" src="images/note.png" title="Add note" border=0></a>
EOT;
            } else {
               echo <<<EOT
&nbsp;&nbsp;
<a href="notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&schedid=$schedid&sortby=$sortby&resid=$resid&httpfrom=results" 
  onClick="popup('notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&schedid=$schedid&sortby=$sortby&resid=$resid&httpfrom=results','Notes'); 
  return false;"><img alt="Note" src="images/note.png" title="Add note" border=0></a>
EOT;
            }
         }
         //}

         // Add False Positive Indicator/link
         if ($enableFP && ($sql_uid==$username || $uroles['admin'])) {
            if ($falsepositive=="Y") {
               echo <<<EOT
&nbsp;&nbsp;
<a href="results.php?scantime=$scantime&scantype=$scantype&schedid=$schedid&nfp=$resid">
<img alt="Clear false positive" src="images/false.png" title="Clear false positive" border=0></a>
EOT;
            } else {
               echo <<<EOT
&nbsp;&nbsp;
<a href="results.php?scantime=$scantime&scantype=$scantype&schedid=$schedid&fp=$resid">
<img alt="Mark as false positive" src="images/true.png" title="Mark as false positive" border=0></a>
EOT;
            }
         }

         echo "</td></tr>";
         $result1->MoveNext();
      }
      echo "</table>";
      $result->MoveNext();
   }

// process request to delete scan results
} elseif ($scantime<>"" and $schedid<>"" and $op=="delete") {

   if (!is_numeric($schedid)) {
      die("Cannot access this page - error detected in URL (schedid).");
   }
   $query="select count(id) 
           from nessus_schedule 
           where username='$username' 
                 and id=$schedid";
   $result=$dbconn->execute($query);
   
   list($allowaccess)=$result->fields;
   if ($allowaccess<>1) {
      die("Cannot access this page - only the owner is allowed to delete the report (1).");
   }

   $query="select count(scantime) 
           from nessus_results 
           where scantime='$scantime' 
               and username='$username' 
               and sched_id=$schedid";
   $result=$dbconn->execute($query);
   
   list($numofresults)=$result->fields;

   if ($numofresults<1) { die("Cannot access this page - unable to find report or possible error in the URL."); }

   $query="delete from nessus_results 
           where sched_id = $schedid 
               and username='$username' 
               and scantime='$scantime'";
   $result=$dbconn->execute($query);
   echo '<font color="#666666" size="2">Vulnerability test results have been deleted.<BR></font>';

}

echo "<BR>";

require_once('footer.php');

?>
