<?php
//
// scanRequest.php - for managing scan requests
//

$pageTitle = "Scan Reqeust";
require_once('functions.inc');
require_once('config.php');
require_once('auth.php');
//require_once('permissions.inc.php');
require_once('header2.php');

//$useremail = $_SESSION['useremail'];

// set up array of GET/POST params that need to be assigned to variables
$getParams = array( 'requestID', 'confirm', 'op', 'sortby', 'view' );
$postParams = array( 'serverHostname', 'serverIP', 'serverOS', 'op',
                     'serverLocation', 'serverNetwork', 'serverState',
                     'desiredScanDate', 'changeControl', 'requestStatus',
                     'requestID', 'year','month','day','time', 'sched_id',
                     'submit'
                   );

// get the current DATETIME
$now = date("Y-m-d H:i:s");

/*
// set up the email headers
$query = "SELECT settingName, settingValue
          FROM inprotect_settings";
$results = $dbconn->GetArray($query);
if($results === false) {
   echo "SQL Error retrieving settings: " . $dbconn->ErrorMsg();
} else {
   foreach($results as $ms) {
      switch($ms['settingName']) {
      case 'mailfrom':
      case 'replyto':
         $mailSettings[$ms['settingName']] = $ms['settingValue'];
         break;
      case 'serverLocationArray':
         $serverLocationArray = explode(",",$ms['settingValue']);
         break;
      case 'serverNetworkArray':
         $serverNetworkArray = explode(",", $ms['settingValue']);
         break;
      case 'serverStateArray':
         $serverStateArray = explode(",", $ms['settingValue']);
         break;
      case 'nostatus':
         $nostatus = explode(",", $ms['settingValue']);
         break;
      }
   }
}
*/
$headers = "From: $mailfrom\r\nReply-To: $replyto\r\nX-Mailer: InProtect";

// proces the GET/POST params
switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   $isget = 1;
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp = ""; 
      }
   }
   break;
case "POST" :
   $isget = 0;
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else {
         $$pp = "";
      }
   }
   break;
}

// write to logfile
$logh->log("$username : " . $_SERVER['PHP_SELF']  .
           " : Accessed Page", PEAR_LOG_DEBUG);

// see how we were called and act accordingly
if($isget) {
   if ($op == "new") {
      // give the user the form to submit a new scan request
      if($requestID == "") { // create the requestID
         $requestID = "sr-" . substr($username,0,4) . "-" . time();
      }
      $formFields = array( "Scan Request ID" => $requestID,
                           "Server Name" => array( "name" => "serverHostname",
                                                   "type" => "input",
                                                   "value" => ""),
                           "Server IP" => array( "name" => "serverIP",
                                                   "type" => "input",
                                                   "value" => ""),
                           "Server O/S" => array( "name" => "serverOS",
                                                   "type" => "input",
                                                   "value" => ""),
                           "Server Location" => array( "name" => "serverLocation",
                                                   "type" => "select",
                                                   "value" => $serverLocationArray),
                           "Server Network" => array( "name" => "serverNetwork",
                                                   "type" => "select",
                                                   "value" => $serverNetworkArray),
                           "Server State" => array( "name" => "serverState",
                                                   "type" => "select",
                                                   "value" => $serverStateArray),
                           "Desired Date" => array( "name" => "desiredScanDate",
                                                   "type" => "timeinput",
                                                   "value" => "",
                                                   "comment" => "24-hour format") );
      $formButtons = array( "Submit" => array( "name" => "submit",
                                               "type" => "submit",
                                               "value" => "Submit Scan Request"));
      $formHidden = array( "requestID" => $requestID );

      $formData = array( "summary" => "Scan Request",
                         "fields" => $formFields,
                         "hidden" => $formHidden,
                         "buttons" => $formButtons);
      drawForm($formData,$_SERVER['PHP_SELF']);

   } elseif ($op == "edit" && ($uroles['scanRequest'] || $uroles['nessus'])) {
      // draw the form to allow user to edit scan request
      // retrieve the info about the request
      $query = "SELECT *
                FROM scan_requests
                WHERE requestID = '$requestID'";
      $result = $dbconn->GetRow($query);
      if($result === false) { //nothing found
        echo "SQL Error searching for $requestID: " . $dbconn->ErrorMsg();
        require_once('footer.php');
        die();
      }
      if($result['requestStatus'] == "Scheduled" && !$uroles['nessus']) {
         // only certain role can modify a scheduled scan request
         echo "You don't have rights to modify a scheduled scan request.";
         echo "<p>Return to the <a href='scanRequest.php'>Scan Request List</a></p>";
         require_once('footer.php');
         die();
      }

      // set up the array to pass to the function to draw the form
      $formFields = array( "Scan Request ID" => $requestID,
                           "Server Name" => array( "name" => "serverHostname",
                                                   "type" => "input",
                                                   "value" => $result['serverHostname']),
                           "Server IP" => array( "name" => "serverIP",
                                                   "type" => "input",
                                                   "value" => $result['serverIP']),
                           "Server O/S" => array( "name" => "serverOS",
                                                   "type" => "input",
                                                   "value" => $result['serverOS']),
                           "Server Location" => array( "name" => "serverLocation",
                                                   "type" => "select",
                                                   "value" => $serverLocationArray,
                                                   "selected" => $result['serverLocation']),
                           "Server Network" => array( "name" => "serverNetwork",
                                                   "type" => "select",
                                                   "value" => $serverNetworkArray,
                                                   "selected" => $result['serverNetwork']),
                           "Server State" => array( "name" => "serverState",
                                                   "type" => "select",
                                                   "value" => $serverStateArray,
                                                   "selected" => $result['serverState']),
                           "Desired Date" => array( "name" => "desiredScanDate",
                                                   "type" => "timeinput",
                                                   "value" => $result['desiredScanDate'],
                                                   "comment" => "24-hour format") );

      $formButtons = array( "Submit" => array( "name" => "submit",
                                               "type" => "submit",
                                               "value" => "Update Scan Request"));

      $formHidden = array( "requestID" => $requestID );
      $formData = array( "summary" => "Scan Request",
                         "fields" => $formFields,
                         "hidden" => $formHidden,
                         "buttons" => $formButtons);

      drawForm($formData,$_SERVER['PHP_SELF']);
   } elseif ($op == "view") { 
      echo "<P>Return to the <a href='" . $_SERVER['PHP_SELF'] .
           "'>Scan Request List</a>.</p>";
      // retrieve the info about the request
      $query = "SELECT *
                FROM scan_requests
                WHERE requestID = '$requestID'";
      $result = $dbconn->GetRow($query);
      if($result === false) { //nothing found
        echo "Invalid requestID specified: " . $dbconn->ErrorMsg();
        require_once('footer.php');
        die();
      }
      $formFields = array( "Scan Request ID" => $requestID,
                           "Server Name" => $result['serverHostname'],
                           "Server IP" => $result['serverIP'],
                           "Server O/S" => $result['serverOS'],
                           "Server Location" => $result['serverLocation'],
                           "Server Network" => $result['serverNetwork'],
                           "Server State" => $result['serverState'],
                           "Desired Date" => $result['desiredScanDate'],
                           "Submitted By" => $result['requestorID'],
                           "Submitted" => $result['submitDate'],
                           "Last Updated" => $result['updateDate'],
                           "Last Updated By" => $result['lastUpdateID'],
                           "Scheduled By" => $result['schedulerID']);

      // for users with nessus role, pre-populate a pulldown of
      //   the users defined scan schedules so they can select it
      //   and automatically add the IP to it.
      if($uroles['nessus'] && $result['requestStatus'] <> "Scheduled") { 
         // display the button to schedule the scan
         $schedules = array();
         $query = "SELECT id, name
                   FROM nessus_schedule
                   WHERE username = '$username'";
         $schedresult = $dbconn->GetArray($query);
         if(!($schedresult === false)) {
            foreach($schedresult as $schedule) {
               $schedules = $schedules + array( $schedule[id] => $schedule['name'] );
            }
         }
         // add the scan schedule pulldown to the array of form fields
         if(!empty($schedules)) {
            $formFields = array_merge($formFields, array( "Scan Schedule" =>
                                           array( "name" => "sched_id",
                                                  "type" => "select",
                                                  "selected" => $result['schedID'],
                                                  "nameIndex" => 1,
                                                  "value" => $schedules )));
         }
         // add a text box for the scheduled to indicate the CC
         $formFields = array_merge($formFields, array(
                           "Change Control" => array( "name" => "changeControl",
                                                      "type" => "input",
                                                      "value" => $result['changeControl'])));
         $formHidden = array( "requestID" => $requestID );
         $formButtons = array( "Submit" => array( "name" => "submit",
                                               "type" => "submit",
                                               "value" => "Schedule Scan Request"));
         $formData = array( "summary" => "Scan Request",
                            "fields" => $formFields,
                            "hidden" => $formHidden,
                            "buttons" => $formButtons);
      } else {
         $formFields = array_merge($formFields, 
             array( "Change Control" => $result['changeControl'] ), 
             array( "Schedule Status" => $result['requestStatus']));
         $formData = array( "summary" => "Scan Request",
                            "fields" => $formFields);
      }
      drawForm($formData,$_SERVER['PHP_SELF']);
   } elseif ($op == "delete" && ($uroles['scanRequest'] || $uroles['nessus'])) {
      if($confirm == "yes") {
         // delete the indicated scan request
         $delquery = "DELETE FROM scan_requests
                      WHERE requestID = '$requestID'
                      LIMIT 1";
         $delresult = $dbconn->execute($delquery);
         if($delresult === false) {
            echo "SQL Error deleting scan request: " . $dbconn->ErrorMsg();
         } else {
            echo "Scan request $requestID successfully deleted";
            echo "<P>Return to the <a href='" . $_SERVER['PHP_SELF'] .
                 "'>Scan Request List</a>.</p>";
         }
         // send out emails here
         $to = "$scanrequestemail,$scanapproveemail";
         $subject = 'Scan request ' . $requestID . ' deleted';
         if(!sendEmail($to, $subject, "delete", $dbconn, $headers)) {
            echo "There was an error sending the notification email.";
         }
      } else {
         $query = "SELECT requestStatus
                   FROM scan_requests
                   WHERE requestID = '$requestID'";
         $status = $dbconn->GetOne($query);
         if($status <> "Scheduled") {
            // display a confirmation dialog
            echo "<p>Confirm Deletion of Scan Request $requestID?</p>";
            echo "<p><a href='" . $_SERVER['PHP_SELF'] . 
                 "?op=delete&confirm=yes&requestID=" . $requestID .
                 "'>Yes</a> | <a href='" . $_SERVER['PHP_SELF'] .
                 "'>No</a></p>";
         } else {
            echo "<p>You can't delete a scheduled scan request.</p>";
         }
      }
   } else {
      // set the correct order, default is by submitDate
      switch($sortby) {
      case "requestorID":
         $obc = "ORDER BY requestorID ASC";
         break;
      case "requestStatus":
         $obc = "ORDER BY requestStatus ASC";
         break;
      case "submitDate":
         $obc = "ORDER BY submitDate DESC";
         break;
      case "desiredScanDate":
         $obc = "ORDER BY desiredScanDate DESC";
         break;
      case "changeControl":
         $obc = "ORDER BY changeConotrol ASC";
         break;
      default:
         $obc = "ORDER BY requestStatus ASC, submitDate DESC";
         break;
      }
      //default to viewing only pending requests
      if($view == "") {
         echo "<p><a href='" . $_SERVER['PHP_SELF'] . 
              "?view=all&sortby=$sortby'>View All Scan Requests</a></p>";
         $whereclause = "WHERE requestStatus = 'Pending'";
         
      } elseif ($view == "all") {
         echo "<p><a href='" . $_SERVER['PHP_SELF'] . 
              "?sortby=$sortby'>View Only Pending Scan Requests</a></p>";
         $whereclause = "";
      }
      // display a table with all the scan requests, newest at the top
      echo "<p><a href='scanRequest.php?op=new'>Submit a New Scan Request</a></p>";
      $query = "SELECT requestID, serverHostname, serverIP, requestorID,
                   submitDate, desiredScanDate, requestStatus, changeControl
                FROM scan_requests
                $whereclause
                $obc";
      $results = $dbconn->GetArray($query);
      if($results === false) {
         echo "There was an error retrieving the scan request data from the 
               database:  " . $dbconn->ErrorMsg();
         require_once('footer.php');
         die();
      }
      
      $baseURL = $_SERVER['PHP_SELF'] . "?view=$view&sortby=%var%";
      $tableFieldMap = array( "Request ID" => "requestID",
                            "Hostname" => "serverHostname",
                            "IP" => "serverIP",
                            "Requestor" => array( 'var' => "requestorID",
                                                  'link' => $baseURL ),
                            "Request Date" => array( 'var' => "submitDate",
                                                     'link' => $baseURL ),
                            "Desired Date" => array( 'var' => "desiredScanDate",
                                                     'link' => $baseURL ),
                            "Change Control" => array( 'var' => "changeControl",
                                                       'link' => $baseURL ), 
                            "Status" => array( 'var' => "requestStatus",
                                               'link' => $baseURL ),
                            "Links" => array( "View" => array(
                                                    "url" => "scanRequest.php?op=view&requestID=%param%",
                                                    "param" => "requestID",
                                                    "icon" => "images/zoom.png"),
                                              "Edit" => array(
                                                    "url" => "scanRequest.php?op=edit&requestID=%param%",
                                                    "param" => "requestID",
                                                    "icon" => "images/pencil.png"),
                                              "Delete" => array(
                                                    "url" => "scanRequest.php?op=delete&requestID=%param%",
                                                    "param" => "requestID",
                                                    "icon" => "images/delete.png")));
      drawTable($tableFieldMap, $results, "Scan Requests");
   }
} elseif ($uroles['nessus'] || $uroles['scanRequest']) {
   // user needs to have rights to edit a scan request
   // form was submitted
   if($submit == "Submit Scan Request") {
      // see if this host/IP exists in the hosts table and is "active"
      $hostExists = FALSE;
      $query = "SELECT count(id)
                FROM hosts
                WHERE (hostname = '$serverHostname' AND
                       ip = '$serverIP') AND
                      status NOT IN ('" . implode(",",$nostatusArray) . "')";
      $hostResult = $dbconn->GetOne($query);
      if($hostResult === false) {
         echo "SQL Error searching hosts table: " . $dbconn->ErrorMsg();
      } else {
         if($hostResult >= 1) {
            // found an entry, don't need to create a new one
            $hostExists = TRUE;
         }
      }
         
      // convert the desiredScanDate into a common format
      $desiredScanDate = "$year-$month-$day $time:00";
      // create the entry in the DB
      $query = "INSERT INTO scan_requests
                   ( requestID, serverHostname, serverIP, serverOS,
                     serverLocation, serverNetwork, serverState,
                     desiredScanDate, requestStatus, submitDate,
                     requestorID )
                VALUES ( '$requestID', '$serverHostname', '$serverIP', '$serverOS',
                         '$serverLocation', '$serverNetwork', '$serverState',
                         '$desiredScanDate', 'Pending', '$now',
                         '$username')";
      $result = $dbconn->execute($query);
      if($result === false) {
         $errMsg[] = "There was an error saving the scan request: " . $dbconn->ErrorMsg();
         dispSQLError($errMsg,1);
         require_once('footer.php');
         die();
      } else {
         echo "<p>Scan Request $requestID sucessfully submitted.</p>";
         if(!$hostExists) {
         /* removed - automatically create the entry
            echo "<p>Click <a href='hosts.php?op=add&os=" . 
                  htmlentities($serverOS) . "&ip=" .
                  htmlentities($serverIP) . "&host=" . 
                  htmlentities($serverHostname) . "&status=" .
                  htmlentities($serverState) . "&ref=" . 
                  $_SERVER['PHP_SELF'] . "'>here</a> 
                  to add this new host to the database.</p>";
         */
            $insHost = "INSERT INTO hosts 
                          (hostname, ip, status, os, createdate, description,
                           contact, scanstate)
                        VALUES ('$serverHostname', '$serverIP', '$serverState', 
                                '$serverOS', '$now', 
                                'Auto Created via scan request', '$username',
                                'Pending Scan')";
            $result = $dbconn->execute($insHost);
            if($result === false) {
               echo "There was an error automatically creating the entry in the hosts table.";
               echo "<P>SQL Error: <pre>" . $dbconn->ErrorMsg() . "</pre>";
               echo "<p>Click <a href='hosts.php?op=add&os=" . 
                     htmlentities($serverOS) . "&ip=" .
                     htmlentities($serverIP) . "&host=" . 
                     htmlentities($serverHostname) . "&status=" .
                     htmlentities($serverState) . "&ref=" . 
                     $_SERVER['PHP_SELF'] . "'>here</a> 
                     to add it manually.</p>";
            } else {
               echo "<p>New host was automatically added to hosts table using
                     the information provided in the scan request form.</p>";
            }
         }
         echo "<p>Return to the <a href='" . 
              $_SERVER['PHP_SELF'] . 
              "'>Scan Request List</a></p>";
         // send out emails here
         $to = "$scanrequestemail, $useremail";
         $subject = 'Scan request ' . $requestID . ' submitted';
         if(!sendEmail($to, $subject, $requestID,$dbconn,$headers)) {
            echo "There was an error sending the notification email.";
         }

      }
   } elseif ($submit == "Update Scan Request") {
      // convert the desiredScanDate into a common format
      $desiredScanDate = "$year-$month-$day $time:00";
      // update the DB with the changes
      $query = "UPDATE scan_requests
                SET updateDate = '$now',serverHostname = '$serverHostname',
                    serverLocation = '$serverLocation',serverOS = '$serverOS',
                    serverNetwork = '$serverNetwork',serverIP = '$serverIP',
                    desiredScanDate = '$desiredScanDate',
                    serverState = '$serverState', lastUpdateID = '$username'
                WHERE requestID = '$requestID'";
      $result = $dbconn->execute($query);
      if($result === false) {
         echo "There was an error saving the scan request data: " . $dbconn->ErrorMsg();
         require_once('footer.php');
         die();
      } else {
         echo "Scan request $requestID updated";
         echo "<p>Return to the <a href='scanRequest.php'>Scan Request List</a></p>";
         // send out emails here
         $to = "$scanrequestemail, $useremail";
         $subject = 'Scan request ' . $requestID . ' updated';

         if(!sendEmail($to, $subject, $requestID,$dbconn,$headers)) {
            echo "There was an error sending the notification email.";
         }
      }
   } elseif ($submit == "Schedule Scan Request" && $uroles['nessus']) {
      // only people with ability to run a scan can schedule it
      // update the DB entry
      $query = "UPDATE scan_requests
                SET closeDate = '$now',
                    schedulerID = '$username',
                    requestStatus = 'Scheduled',
                    changeControl = '$changeControl',
                    schedID = '$sched_id'
                WHERE requestID = '$requestID'";
      $result = $dbconn->execute($query);
      if($result === false) {
         echo "There was an error saving the scan request data: " . $dbconn->ErrorMsg();
         require_once('footer.php');
         die();
      } else {
         // see if we have a scan schedule to add this IP to and add it
         if($sched_id <> "") {
            $query = "SELECT serverIP
                      FROM scan_requests
                      WHERE requestID = '$requestID'";
            $ip = $dbconn->GetOne($query);
            if($ip <> "") {
               $query = "SELECT count(id)
                         FROM nessus_hosts
                         WHERE sched_id = '$sched_id'
                            AND hostip = '$ip'";
               $exists = $dbconn->GetOne($query);
               if ($exists == 0) {
                  // need to check to make sure that this IP can be
                  // added to the schedule (nessus_zones and nessus_zones_users
                  // checks, same as from sched.php)
                  if(inrange($ip, $dbconn)) {
                     // user has the ability to scan this IP, add it to the 
                     // schedule and report back to the user
                     $query = "INSERT INTO nessus_hosts
                                 (username, hostip, sched_id)
                               VALUES ('$username','$ip','$sched_id')";
                     if(!($result = $dbconn->execute($query) === false)) {
                        // added it, now get the sched name for a message
                        // back to the user
                        $query = "SELECT name 
                                  FROM nessus_schedule
                                  WHERE id = '$sched_id'";
                        $sched = $dbconn->GetOne($query);
                        $msg = "$ip successfully added to scan schedule '$sched'."; 
                     } else {
                        $msg = "Error: there is no Network Zone configured ".
                               "that permits you to scan this IP address." .
                               "<br>IP has not automatically been added to " .
                               "the indicated scan schedule." .
                               "<br> (ip = $ip, username = $username, ".
                               "sched_id = $sched_id)";
                     }
                  }
               }
            }
         }
         echo "<p>Scan request $requestID updated with a status of 'Scheduled'</p>";
         echo $msg;
         echo "<p>Return to the <a href='scanRequest.php'>Scan Request List</a></p>";
         // send out emails here
         $query = "SELECT pn_email
                   FROM users, scan_requests
                   WHERE users.pn_uname = scan_requests.requestorID
                      AND scan_requests.requestID = '$requestID'";
         $requestorEmail = $dbconn->GetOne($query);
         $to = "$scanapproveemail, $requestorEmail";
         $subject = 'Scan request ' . $requestID . ' scheduled';
         if(!sendEmail($to, $subject, $requestID,$dbconn,$headers)) {
            echo "There was an error sending the notification email.";
         }
      }
   } else {
     // must be a request to update the inital scan request
   }
}

// close out the HTML page
require_once('footer.php');

function sendEmail($to,$sub,$rid,$dbconn,$headers) {
   if($rid == "delete") {
      $msg = "The indicated scan request was deleted from InProtect.";
      return( mail($to, $sub, $msg, $headers));
   } elseif(isset($to) && isset($sub) && isset($rid) && isset($headers)) {
      $query = "SELECT sr.requestID, sr.serverHostname, sr.serverIP, 
                  sr.serverOS, sr.serverNetwork, sr.serverState, 
                  sr.serverLocation, sr.desiredScanDate,
                  sr.requestorID, sr.submitDate, sr.changeControl, sr.schedID,
                  sr.lastUpdateID, sr.updateDate, ns.name
                FROM scan_requests as sr
                LEFT JOIN nessus_schedule as ns
                ON sr.schedID = ns.id
                WHERE sr.requestID = '$rid'";
      $data = $dbconn->GetRow($query);
      $msg = "
Scan Request:  " . $data['requestID'] . "
Server Hostname:  ".$data['serverHostname']."
Server IP:  ".$data['serverIP']."
Server O/S:  ".$data['serverOS']."
Server Location:  ".$data['serverLocation']."
Server Network:  ".$data['serverNetwork']."
Server State:  ".$data['serverState']."
Desired Date:  ".$data['desiredScanDate']."
Requested By:  ".$data['requestorID']."
Submit Date:  ".$data['submitDate']."
Change Control:  ".$data['changeControl']."
Scan Schedule:  ".$data['name']."
Updated By:  ".$data['lastUpdateID']."
Update Date:  ".$data['updateDate']."

Link:  https://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."?op=view&requestID=$rid";
      return( mail($to, $sub, $msg, $headers));
   } else {
      return(FALSE);
   }
}
?>
