<?php
//
// $Id: schedstats.php,v 1.2 2006/08/10 17:19:33 airwofl Exp $
//

$pageTitle = "Schedule Stats";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

if (isset($_REQUEST['refresh'])) { $req_refresh=htmlspecialchars(mysql_escape_string(trim($_REQUEST['refresh'])), ENT_QUOTES); }
else { $req_refresh=""; }
if (isset($_REQUEST['sortby'])) { $sortby=htmlspecialchars(mysql_escape_string(trim($_REQUEST['sortby'])), ENT_QUOTES); }
else { $sortby=""; }

if (is_numeric($req_refresh) && $req_refresh >= 1 ) { 
    if( isset($meta_info) && is_array($meta_info) )
    {
        $meta_info_count = count($meta_info);
    }
    else
    {
        $meta_info_count = 0;
    }
    $meta_info[$meta_info_count]["http-equiv"] = "refresh";
    $meta_url = "schedstats.php?refresh=".$req_refresh;
    if (is_numeric($sortby))
    {
        $meta_url.="&sortby=".$sortby;
    }
    $meta_info[$meta_info_count]["content"] = $req_refresh.";url=".$meta_url;
}

$getParams = array( "op", "host", "schedid" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
	break;
}

$logh->log($username . " : " . $_SERVER['PHP_SELF']  . 
           " : Accessed Page", PEAR_LOG_DEBUG);

if ($op=="stop") {
   $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
              " : Requested stop for scheduleid " . $schedid, PEAR_LOG_DEBUG);
   if (!is_numeric($schedid)) {
	   $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                 " : Security violation - Requested to stop non numeric 
                  scheduleid " . $schedid, PEAR_LOG_CRIT);
      echo "Can not access this page";
      require_once('footer.php');
	   die();
   }
   $query="select count(id) 
           from nessus_schedule 
           where username='$username' and id=$schedid";
   $result=$dbconn->execute($query);

   list($allowaccess)=$result->fields;
   if ($allowaccess<>1) {
      $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                 " : Security violation - Schedule not owned by this 
                  userid " . $scheduleid, PEAR_LOG_CRIT);
      echo "Can not access this page";
      require_once('footer.php');
	   die();
   }

   $query="select count(host) 
           from nessus_scan 
           where host='$host' and sched_id=$schedid and server_id=0";
   $result=$dbconn->execute($query);
   list($allowaccess)=$result->fields;
   if ($allowaccess==1) {
	   $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                 " : Sending stop message for scheduleid, host " . 
                 $schedid . ", " . $host, PEAR_LOG_NOTICE);
      $query="update nessus_scan 
              set status='P' 
              where sched_id=$schedid and host='$host' and server_id=0";
      $result=$dbconn->execute($query);
	   if(!$result) { 
         echo "Scan has already been scheduled. Please see go to the 
               <A HREF=\"livestats.php\">Live Stats page</A> 
               to stop scan."; 
         require_once('footer.php');
         die();
      }
	   $stophost=$host;
   } else {
	   $query2="select count(host) 
               from nessus_scan 
               where host='$host' and sched_id=$schedid and server_id>0";
	   $result2=$dbconn->execute($query2);
      list($allowaccess2)=$result2->fields;
	   if ($allowaccess2<>1) {
	      $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Security violation - Attempt to stop invalid 
                    schedule or schedule owned by another user - 
                    scheduleid, host " . $schedid . ", " . 
                    $host, PEAR_LOG_CRIT);
         echo "Cannot access this page.";
         require_once('footer.php');
	      die();
	   } else {
         echo "Scan has already been scheduled. Please see go to the 
               <A HREF=\"livestats.php\">Live Stats page</A> to stop scan.";
         require_once('footer.php');
	      die();
	   }
   }
}

$sql_order="order by ";
$sql_order2="nessus_schedule.name, inet_aton(nessus_scan.host)";

if ($sortby=="" || !is_numeric($sortby)) { $sortby=0; }
if ($sortby==0) { // Do nothing as the required sql gets appended at the end of this IF block
}
elseif ($sortby==1) { $sql_order2="nessus_schedule.name DESC, inet_aton(nessus_scan.host)"; }
elseif ($sortby==2) { $sql_order2="inet_aton(nessus_scan.host), nessus_schedule.name"; }
elseif ($sortby==3) { $sql_order2="inet_aton(nessus_scan.host) DESC, nessus_schedule.name"; }
elseif ($sortby==4) { $sql_order.="nessus_schedule.username, "; }
elseif ($sortby==5) { $sql_order.="nessus_schedule.username DESC, "; }

$sql_order.=$sql_order2;

echo <<<EOT
<B>Scans still to be scheduled</b>
<br>
EOT;

$query="select nessus_scan.host, nessus_schedule.name, 
           nessus_schedule.username, nessus_scan.sched_id 
        from nessus_scan
        left join nessus_schedule on nessus_scan.sched_id=nessus_schedule.id 
        where nessus_scan.status='S' and nessus_scan.server_id=0 " . $sql_order;
$result=$dbconn->execute($query);

$refreshurl = "schedstats.php";
if($req_refresh<>"") {
   $refreshurl .= "?refresh=".$req_refresh;
}

$query3="select count(*) 
         from nessus_scan 
         where server_id>0 and status='R'";
$result3=$dbconn->execute($query3);
list($numtesting)=$result3->fields;

$query4="select count(*) 
         from nessus_scan 
         where server_id=0";
$result4=$dbconn->execute($query4);
list($numstill2btested)=$result4->fields;
?>
<p></p>
<a href="<?php echo $refreshurl;?>">Refresh list</a> | 
<A HREF="livestats.php?refresh=<?php echo $req_refresh;?>">Current Scanning Stats</A>
<p></p>
<table>
<tr valign="top">
<td>
<form method="get">
Auto Refresh:
<select name="refresh">
<option value="0">None</option>
<option value="15" <?php if($req_refresh==15) echo "SELECTED"; ?>>15 Seconds</option>
<option value="60" <?php if($req_refresh==60) echo "SELECTED"; ?>>1 Minute</option>
<option value="300" <?php if($req_refresh==300) echo "SELECTED"; ?>>5 Minutes</option>
</select>
<?php if ($sortby<>"") { echo "<input type=\"hidden\" name=\"sortby\" value=\"$sortby\">"; } ?>
<input type="submit" value="Set">
</form></td>
<td>&nbsp;&nbsp;&nbsp;</td>
<td>Number of hosts currently being tested:<br>
Number of hosts still to be tested:</td>
<td>&nbsp;&nbsp;&nbsp;<A HREF="livestats.php?refresh=<?php echo $req_refresh;?>"><?php echo $numtesting;?></A><br>
&nbsp;&nbsp;&nbsp;<?php echo $numstill2btested;?></td>
</tr>
</table>
<?php

$url_sortby="<a href=\"schedstats.php?";
if($req_refresh<>"") {
        $url_sortby.="refresh=".$req_refresh;
}
$url_sortby.="&amp;sortby=";

// set up the table header
$tableHeader = "
<table summary='Scans'>
<tr>
   <th>$url_sortby
";
if ($sortby==0) { 
   $tableHeader .= "1"; 
} else {
   $tableHeader .= "0"; 
}
$tableHeader .= "
'>Schedule</a>
</th>
<th>$url_sortby
";
if ($sortby==2) {
   $tableHeader .= "3"; 
} else { 
   $tableHeader .="2"; 
}
$tableHeader .= "
'>Host</a>
</th>
<th>$url_sortby
";
if ($sortby==4) {
   $tableHeader .="5"; 
} else { 
   $tableHeader .="4"; 
}
$tableHeader .= "
'>Owner</a>
</th>
<th>Action</th>
</tr>
";

// counter to know when to draw table header
$lc = 0;
while (!$result->EOF)
{
   if($lc == 0) {
      echo $tableHeader;
      $lc++;
   }
   list($host, $name, $db_username, $schedid)=$result->fields;

   echo <<<EOT
<tr>
   <td>$name</td>
   <td>$host</td>
   <td>$db_username</td>
   <td>
EOT;
   $query1="select count(id) 
            from nessus_schedule 
            where username='$username' and id=$schedid";
   $result1=$dbconn->execute($query1);

   list($allowaccess1)=$result1->fields;
   if (($op=="stop") && ($host==$stophost) && ($schedid==$stopschedid)) {
      echo "Stopping";
   } elseif ($allowaccess1==1) {
      echo "<a href=\"schedstats.php?op=stop&amp;schedid=$schedid&amp;host=$host";
      if($req_refresh<>"") {
         echo "&amp;refresh=".$req_refresh;
      }
      echo "\">Stop</a>";
   }
   echo "</td></tr>";
   $result->MoveNext();
}

echo "</table>";

require_once('footer.php');
?>
