<?php

require("../config.php");
require("../validateip.inc.php");

// file with tab delimited data to import
if(!$argv[1]) {
   die ("Usage:  $_ $argv[0] <input.txt>\n");
}

$handle = fopen($argv[1], 'r');

// if empty first line, die
if( ($headers = fgetcsv($handle,1024,"\t")) !== FALSE ) {
   // truncate current table so we can load it fresh
   $query = "truncate hosts";
   $dbconn->execute($query);
   // get empty recordset from table
   $query = "select * from hosts where id = -1";
   $rs = $dbconn->execute($query);
   $record = array();
   $numHosts = 0;
   while ( ($data = fgetcsv($handle, 1024, "\t")) !== FALSE ) {
      for ($i=0;$i<count($headers);$i++) {
         $record["$headers[$i]"] = "$data[$i]";
      }
//      var_dump($record);

      // need to do multiple inserts if it's multi-IP, <sigh>
      if(strpos($record['ip'], ",") !== FALSE) { 
//         echo("multiple ips.\n");
         $ips = explode(",", $record["ip"]);
         foreach($ips as $ip) {
            $mrecord = $record;
            $mrecord['ip'] = trim($ip);
//            var_dump($mrecord);
            //only want to insert entries with valid IP addresses
	    if(validateip($mrecord['ip'])) {
               $insertSQL=$dbconn->GetInsertSQL($rs, $mrecord);
               $dbconn->execute($insertSQL);
	    }
         }
      } else {
	 if(validateip($record['ip'])) {
            $insertSQL=$dbconn->GetInsertSQL($rs, $record);
            $dbconn->execute($insertSQL);
	 }
      }
      $numHosts++;
   }
//   print_r($record);
   print "Processed $numHosts records.\n";
} else {
   die ("$file is empty.");
}
   
      
?>
