<?php
//
// $Id: settings.php,v 1.10 2006/08/10 17:19:33 airwofl Exp $
//
$pageTitle = "Nessus Profile Settings";
require_once('functions.inc');
require_once('config.php');
require_once('auth.php');
require_once('Crypt/CBC.php');
require_once('header2.php');

# stype is currently not used but needs to be defined as it's specified in the SQL
$stype="";

// array of the nav links, for use later
$navLinks = array( "Options" => "settings.php?item=edit&amp;op=Edit&amp;sid=%sid%",
                   "Preferences" => "settings.php?item=edit&amp;sid=%sid%&amp;page=1&amp;prefs=1",
                   "Plugins" => "settings.php?item=edit&amp;sid=%sid%&amp;page=1&amp;prefs=3",
                   "Edit Users" => "settings.php?item=editusers&amp;sid=%sid%",
                   "View Configuration File" => "settings.php?item=edit&amp;sid=%sid%&amp;page=1&amp;prefs=4"
                 );

// arrays for the Get and Post params
$getParams = array( "item", "page", "delete", "prefs", "uid", "sid",
                    "op" );
$postParams = array( "saveplugins", "page", "delete", "prefs", "uid", "sid",
                    "op", "sname", "sdescription", "sautoenable", "item",
                    "AllPlugins", "NonDoS", "DisableAll", "submit", "fam",
                    "cloneid", "auto_cat_status", "auto_fam_status");

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) {
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES);
      } else {
         $$gp="";
      }
   }
   $submit="";
   $AllPlugins="";
   $NonDOS="";
   $DisableAll="";
   $saveplugins="";
   break;
case "POST" :
   foreach ($postParams as $pp) {
      if (isset($_POST[$pp])) {
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else {
         $$pp="";
      }
   }
   break;
}

$logh->log($username . " : " . $_SERVER['PHP_SELF']  .
           " : Accessed Page", PEAR_LOG_DEBUG);

if (!($uroles['profile'] || $uroles['admin'])) {
   echo "Access Denied!!!<br>";
   $logh->log($username . " : " . $_SERVER['PHP_SELF']  .
              " : Unauthorized Access", PEAR_LOG_DEBUG);
   require_once('footer.php');
   die();
} else {
   $query = "select count(*) from nessus_plugins";
   $result=$dbconn->execute($query);
   list($pluginscount)=$result->fields;

   if ($pluginscount==0) {
      echo "<h2>Please run updateplugins.pl script first before using
            the web interface.</h2>";
      $logh->log($username . " : " . $_SERVER['PHP_SELF']  .
                 " : Update Plugins Needed", PEAR_LOG_DEBUG);
      require_once('footer.php');
      die ();
   }

   if ($item=="new") {
      // build pulldown of existing scan policies/profiles in case user
      // wants to clone an existing policy instead of starting from scratch
      $query = "SELECT id, name, description
                FROM nessus_settings";
      $result = $dbconn->GetArray($query);
      $allpolicies = "<select name='cloneid'>\n";
      $allpolicies .= "<option value=''>None</option>\n";
      if($result) {
         foreach($result as $sp) {
            $allpolicies .= "<option value='" . $sp['id'] . "'>" .
                            $sp['name'] . " - " . $sp['description'] . 
                            "</option>\n";
         }
      }
      $allpolicies .= "</select>";
      echo <<<EOT
<form method="post" action="settings.php">
<input type="hidden" name="item" value="save">
<table>
<tr>
<td>Name:</td>
<td><input type="text" name="sname" value=""></td>
</tr>
<tr>
<td>Description:</td>
<td><input type="text" name="sdescription" value=""></td>
</tr>
<tr>
<td> Clone existing scan policy:</td><td>$allpolicies</td>
</tr>
<tr>
<td>Make this policy available to all users</td>
<td><input type='checkbox' name='stype' checked>Global Policy</input></td>
</tr>
<tr>
<td>Autoenable plugins option:</td>
<td><select name="sautoenable">
<option value="N">None
<option value="C">Autoenable by category</option>
<option value="F">Autoenable by family</option>
</select></td>
</tr>
<tr>
<td>Set all autoenabled categories to:
<td><select name="auto_cat_status">
<option value="1">Enable All</Option>
<option value="2">Enable New</Option>
<option value="3">Disable New</Option>
<option value="4">Disable All</Option>
<option value="5">Intelligent</Option>
</select></td></tr>
<tr>
<td>Set all autoenabled families to:
<td><select name="auto_fam_status">
<option value="1">Enable All</Option>
<option value="2">Enable New</Option>
<option value="3">Disable New</Option>
<option value="4">Disable All</Option>
<option value="5">Intelligent</Option>
</select></td></tr>
</table><BR>
EOT;

        $query="select * 
                from nessus_category 
                order by name";
        $result = $dbconn->execute($query);

        echo <<<EOT
<B>Autoenable plugins in categories:</B><BR>
<table summary="Category Listing" border=1 cellspacing="0" cellpadding="0" 
style="border-collapse: collapse">
<tr><td><b>Category</b></td>
<td><b>Enable All</b></td>
<td><b>Enable New</b></td>
<td><b>Disable New</b></td>
<td><b>Disable All</b></td>
<td><b>Intelligent</b></td></tr>
EOT;

        while (!$result->EOF) {
            list($cid, $category)=$result->fields;
            echo <<<EOT
<tr><td>$category</td>
<td><input type="radio" name="c_$cid" value="1" checked></td>
<td><input type="radio" name="c_$cid" value="2"></td>
<td><input type="radio" name="c_$cid" value="3"></td>
<td><input type="radio" name="c_$cid" value="4"></td>
<td><input type="radio" name="c_$cid" value="5"></td>
</tr>
EOT;
            $result->MoveNext();
        }
        echo "</table>";

        $query="select * 
                from nessus_family 
                order by name";
        $result=$dbconn->execute($query);

        echo <<<EOT
<B>Autoenable plugins in Families:</B><BR>
<table summary="Family Listing" border=1 cellspacing="0" cellpadding="0"
style="border-collapse: collapse">
<tr><td><b>Family</b></td>
<td><b>Enable All</b></td>
<td><b>Enable New</b></td>
<td><b>Disable New</b></td>
<td><b>Disable All</b></td>
<td><b>Intelligent</b></td></tr>
EOT;

        while (!$result->EOF) {
            list ($fid, $family)=$result->fields;
            echo <<<EOT
<tr><td>$family</td>
<td><input type="radio" name="f_$fid" value="1" checked></td>
<td><input type="radio" name="f_$fid" value="2"></td>
<td><input type="radio" name="f_$fid" value="3"></td>
<td><input type="radio" name="f_$fid" value="4"></td>
<td><input type="radio" name="f_$fid" value="5"></td>
</tr>
EOT;

            $result->MoveNext();
        }
        echo <<<EOT
</table>
<input type="submit" name="submit" value="Save">
</form>
EOT;

   } elseif ($item=="save") {
      // first see if user requested to clone an existing policy
      if($cloneid <> '') {
         // get the data from the original profile
         $query = "SELECT autoenable, type
                   FROM nessus_settings
                   WHERE id = $cloneid";
         $result = $dbconn->GetArray($query);
         if($result === false) {
            $errMsg[] = "Error selecting profile data for id = $cloneid: " .
                        $dbconn->ErrorMsg();
            dispSQLError($errMsg,1);
            require_once('footer.php');
            die();
         } else {
            $orig = $result[0];
         }
         // create new entry in the nessus_settings table first and get
         // the new id
         $insert = "INSERT INTO nessus_settings
                      (name, description, autoenable, type, owner)
                    VALUES
                      ('$sname', '$sdescription', '$orig[autoenable]', 
                       '$orig[type]', '$username')";
         $result = $dbconn->execute($insert);
         if($result === false) {
            $errMsg[] = "Error creating nessus_settings record: ".
                        $dbconn->ErrorMsg();
            $error++;
            dispSQLError($errMsg,$error);
            require_once('footer.php');
            die();
         } else {
            $newPID = $dbconn->Insert_ID();
         }
         /* now we need to copy all the data from the other tables with the
          * new sid = newPID
          * nessus_settings_users -> sid, username
          * nessus_settings_family
          * nessus_settings_category
          * nessus_settings_preferences
          * nessus_settings_plugins
          */

         $query="insert into nessus_settings_users (sid, username) 
                 values ($newPID, '$username')";
         $result=$dbconn->execute($query);
         if($result === false) {
            $errMsg[] = "Error creating nessus_settings_users record: ".
                        $dbconn->ErrorMsg();
            $error++;
         }
         $query="insert into nessus_settings_family
                   (select $newPID as sid, fid, status 
                    from nessus_settings_family
                    where sid=$cloneid)";
         $result=$dbconn->execute($query);
         if($result === false) {
            $errMsg[] = "Error copying nessus_settings_family records: ".
                        $dbconn->ErrorMsg();
            $error++;
         }
         $query="insert into nessus_settings_category
                   (select $newPID as sid, cid, status 
                    from nessus_settings_category
                    where sid=$cloneid)";
         $result=$dbconn->execute($query);
         if($result === false) {
            $errMsg[] = "Error copying nessus_settings_category records: ".
                        $dbconn->ErrorMsg();
            $error++;
         }
         $query="insert into nessus_settings_preferences 
                   (select $newPID as sid, id, nessus_id, value, 
                       category, type 
                    from nessus_settings_preferences
                    where sid=$cloneid)";
         $result=$dbconn->execute($query);
         if($result === false) {
            $errMsg[] = "Error copying nessus_settings_preferences records: ".
                        $dbconn->ErrorMsg();
            $error++;
         }
         $query = "insert into nessus_settings_plugins 
                    (select id, $newPID as sid, enabled, category, 
                        family from nessus_settings_plugins 
                     where sid = $cloneid)";
         $result=$dbconn->execute($query);
         if($result === false) {
            $errMsg[] = "Error copying nessus_settings_plugins records: ".
                        $dbconn->ErrorMsg();
            $error++;
         }
      } else {
         // create a new profile from scratch
         if($sname<>"" and ($sautoenable=="N" or $sautoenable=="C" 
            or $sautoenable=="F")) {
      
            # see if this is duplicate name or not
            $query="SELECT count(name)
                    FROM nessus_settings
                    WHERE name='$sname'";
      
            $result=$dbconn->execute($query);
            list($count)=$result->fields;
            if ($count>0) {
               echo "Cannot create new profile. Duplicate profile name $sname exists.";
            } else {
               $query="INSERT into nessus_settings
                       (name, description, autoenable, owner, auto_cat_status,
                        auto_fam_status)
                       values ('$sname', '$sdescription', 
                               '$sautoenable', '$username', $auto_cat_status,
                               $auto_fam_status)";
               $result=$dbconn->execute($query);
               if($result === false) {
                  $errMsg[] = "Error creating nessus_settings record: ".
                              $dbconn->ErrorMsg();
                  $error++;
               } else {
                  $sid = $dbconn->Insert_ID();
               }
   
               $query="insert into nessus_settings_users (sid, username) 
                       values ($sid, '$username')";
               $result=$dbconn->execute($query);
               if($result === false) {
                  $errMsg[] = "Error creating nessus_settings_users record: ".
                              $dbconn->ErrorMsg();
                  $error++;
               }
   
               reset ($_POST);   // if form method="post"
   
               // improve logic here, only add these if this profile
               // is set to autoenable anything, otherwise skip this
               if($sautoenable == "C" OR $sautoenable == "F") {
                  while (list($key, $value) = each ($_POST)) {
                     $value=htmlspecialchars(mysql_real_escape_string(trim($value)), ENT_QUOTES);
      
                     # if the profile is auto-enabling by family and this is
                     # a family setting, make the DB insert
                     if ($sautoenable == "F" && substr($key,0,2)=="f_") {
                        $type=substr($key,0,1);
                        $key=substr($key, 2);
                        $query="insert into nessus_settings_family  
                                values($sid, $key, $value)";
                        $results=$dbconn->Execute($query);
                        if($result === false) {
                           $errMsg[] = "Error creating nessus_settings_family records: ".
                                       $dbconn->ErrorMsg();
                           $error++;
                        }
                     # if the profile is auto-enabling by category and this is
                     # a category setting, make the DB insert
                     } elseif ($sautoenable == "C" && substr($key,0,2)=="c_") {
                        $type=substr($key,0,1);
                        $key=substr($key, 2);
                        $query="insert into nessus_settings_category 
                                values($sid, $key, $value)";
                        $results=$dbconn->Execute($query);
                        if($result === false) {
                           $errMsg[] = "Error creating nessus_settings_category records: ".
                                       $dbconn->ErrorMsg();
                           $error++;
                        }
                     }
                  }
               }
   
// not sure why we do this, there can't be any values in these tables
// with sid=$sid as $sid is a new ID
//               $query="select count(*) 
//                       from nessus_settings_preferences 
//                       where sid=$sid";
//               $result=$dbconn->execute($query);
//               list($count)=$result->fields;
//   
//               if (!$count>0) {
                  $query="insert into nessus_settings_preferences 
                          select $sid as sid, id, nessus_id, value, 
                                 category, type 
                          from nessus_preferences";
                  $result=$dbconn->execute($query);
                  if($result === false) {
                     $errMsg[] = "Error creating nessus_settings_preferences records: ".
                                 $dbconn->ErrorMsg();
                     $error++;
                  }
//               }
//   
//               $query = "select count(*) 
//                         from nessus_settings_plugins 
//                         where sid=$sid";
//               $result=$dbconn->execute($query);
//               list($count)=$result->fields;
//    
//               if (!$count>0) {
                  $query = "insert into nessus_settings_plugins 
                            select id, $sid as sid, enabled, category, 
                                   family from nessus_plugins 
                            where deleted is null";
                  $result=$dbconn->execute($query);
                  if($result === false) {
                     $errMsg[] = "Error creating nessus_settings_plugins records: ".
                                 $dbconn->ErrorMsg();
                     $error++;
                  }
//               }
    
               if ($sautoenable=="C") {
                  $query="select t1.cid, t1.status 
                          from nessus_settings_category as t1, 
                               nessus_category as t2 
                          where sid=$sid";
                  $result=$dbconn->execute($query);
    
                  while (!$result->EOF) {
                     list($cid, $catstatus)=$result->fields;
                     if ($catstatus==4) {
                        $query1="update nessus_settings_plugins 
                                 set enabled='N' 
                                 where category=$cid 
                                       and sid=$sid";
                        $result1=$dbconn->execute($query1);
                        if($result1 === false) {
                           $errMsg[] = "Error updating nessus_settings_plugins records: ".
                                       $dbconn->ErrorMsg();
                           $error++;
                        }
                     } elseif ($catstatus==1) {
                        $query1="update nessus_settings_plugins 
                                 set enabled='Y' 
                                 where category=$cid 
                                       and sid=$sid";
                        $result1=$dbconn->execute($query1);
                        if($result1 === false) {
                           $errMsg[] = "Error updating nessus_settings_plugins records: ".
                                       $dbconn->ErrorMsg();
                           $error++;
                        }
                     }
                     $result->MoveNext();
                  }
               } elseif($sautoenable=="F") {
                  $query="select t1.fid, t1.status 
                          from nessus_settings_family as t1, 
                               nessus_category as t2 
                          where sid=$sid";
                  $result=$dbconn->execute($query);
   
                  while (!$result->EOF) {
                     list($fid, $catstatus)=$result->fields;
                     if ($catstatus==4) {
                        $query1="update nessus_settings_plugins 
                                 set enabled='N' 
                                 where family=$fid 
                                       and sid=$sid";
                        $result1=$dbconn->execute($query1);
                        if($result1 === false) {
                           $errMsg[] = "Error updating nessus_settings_plugins records: ".
                                       $dbconn->ErrorMsg();
                           $error++;
                        }
                     } elseif ($catstatus==1) {
                        $query1="update nessus_settings_plugins 
                                 set enabled='Y' 
                                 where family=$fid 
                                       and sid=$sid";
                        $result1=$dbconn->execute($query1);
                        if($result1 === false) {
                           $errMsg[] = "Error updating nessus_settings_plugins records: ".
                                       $dbconn->ErrorMsg();
                           $error++;
                        }
                     }
                     $result->MoveNext();
                  }
               }
            }
         } else {
            echo "Please specify profile name";
         }
      }
      if(!$error) {
         echo <<<EOT
Step 1. Done - Profile $sname created!!!<BR>
Step 2. <a href="settings.php?item=editusers&amp;sid=$sid">Edit Profile Users</a></br>
Step 3. <A href="settings.php?item=edit&amp;sid=$sid&amp;page=1">Edit profile details</A>
EOT;
      } else {
         dispSQLError($errMsg, $error);
      }
   // end item=save
   } elseif ($item=="edit") {
      printProfileName($dbconn, $sid);

      if ($page==1) {

         if ($prefs=="1" or $prefs=="") {
            printNavLinks($navLinks, "Preferences");

            // get the profile prefs for use later
            $sql = "SELECT t.nessusgroup, t.nessus_id, t.field, 
                           t.type, t.value, n.value, t.category
                    FROM nessus_preferences_defaults t
                    LEFT JOIN nessus_settings_preferences n
                    ON t.nessus_id = n.nessus_id
                       and n.sid = $sid
                    order by category desc, nessusgroup, nessus_id";
            $result=$dbconn->execute($sql);
            if($result === false) { // SQL error
               echo "Error: There was an error with the DB lookup: ".
                    $dbconn->ErrorMsg() . "<br>";
            }
            $counter = 0;

            // user requested Save, update the DB with the values
            if ($submit=="save") {
               // Check to see if this is the owner doing the change
               $foo = $dbconn->execute("select owner 
                                        from nessus_settings 
                                        where id = $sid");
               list ($myowner)=$foo->fields;
               if ($myowner <> $username && !$uroles[admin]) {
                  $logh->log("$username : " . $_SERVER['PHP_SELF'] . 
                             " : Access deined to profile", PEAR_LOG_NOTICE);
                  echo "Access denied: You do not own this profile 
                        and are not an admin - (owner = $myowner).";
                  require_once('footer.php');
                  die();
               }

               while(!$result->EOF) {
                  $counter++;
                  $vname="form".$counter;
                  if (isset($_POST[$vname])) {
                     $$vname=htmlspecialchars(mysql_real_escape_string(
                             trim($_POST[$vname])), ENT_QUOTES);
                  } elseif (isset($_GET[$vname])) {
                     $logh->log("$username : " . $_SERVER['PHP_SELF'] .
                                " : GET instead of POST method used - 
                                failed to save", PEAR_LOG_NOTICE);
                     echo "Please use the settings.php form to submit your changes.";
                     require_once('footer.php');
                     die();
                  } else {
                     $$vname="";
                  }
                  list ($nessusgroup, $nessus_id, $field, $type, 
                        $default, $value, $category) = $result->fields;
                  if (strstr($nessus_id, "[password]")) { // password field
                     if ($$vname!="" && !strstr($$vname,'ENC{')) {  // not encrypted
                        $enc = new Crypt_CBC($dbk, $cipher);
                        $encrypted_val = $enc->encrypt($$vname);
                        $$vname = "ENC{" . base64_encode($encrypted_val) . "}";
                     }
                  }
             
                  updatedb($nessus_id, $$vname, $dbconn, $type, $category, $sid);
                  $result->MoveNext();
               } // end while loop

               /*
                * find all records in the nessus_settings_preferences table that
                * have no matching value in nessus_preferences_defaults
                * and delete them from nessus_preferences
                */

               $sql = "select n.nessus_id 
                       from nessus_settings_preferences n
                       left join nessus_preferences_defaults t
                       on n.nessus_id = t.nessus_id
                       where t.nessus_id is null";
               $result=$dbconn->execute($sql);

               while(!$result->EOF) {
                  list ($pleasedeleteme) = $result->fields;
                  $sql2 = "delete from nessus_settings_preferences
                           where nessus_id = \"$pleasedeleteme\"";
                  $result2=$dbconn->execute($sql2);
                  $result->MoveNext();
               }

               echo <<<EOT
Nessus settings saved, please proceed to the 
<A href="settings.php?item=edit&amp;sid=$sid&amp;page=1&amp;prefs=3">Plugins Selection</A> page<BR>
EOT;
            // end save
            } else { 
               // display the settings form
               $lastvalue = "";
               echo <<<EOT
<form method="post" action="settings.php">
<input type="hidden" name="item" value="edit">
<input type="hidden" name="sid" value="$sid">
<input type="hidden" name="page" value="1">
<input type="hidden" name="prefs" value="1">
EOT;

               while(!$result->EOF) {
                  $counter++;
                  list ($nessusgroup, $nessus_id, $field, $type, 
                        $default, $value, $category) = $result->fields;
                  if ($nessusgroup != $lastvalue) {
                     print "<b>$nessusgroup</b><br>";
                     $lastvalue = $nessusgroup;
                  }
                  $vname = "form".$counter;
                  print formprint($nessus_id, $field, $vname, $type, $default, $value, $dbconn);
                  $result->MoveNext();
               }

               echo "<INPUT type=\"submit\" name=\"submit\" value=\"save\">
                    </form>";
            }
         // end pref=1 or pref=""
         } elseif ($prefs=="4") {
            printNavLinks($navLinks,"View Configuration File");

            $query="SELECT t1.id, t1.enabled  
                    from nessus_settings_plugins as t1, 
                         plugins as t2 
                    where t1.id=t2.id 
                          and t2.category ='scanner' 
                          and t1.sid=$sid 
                    order by id";
            $result=$dbconn->Execute($query);
            echo "begin(SCANNER_SET)\n";

            while (!$result->EOF) {
               list ($id, $enabled) = $result->fields;
               $enabled1="yes";
               if ($enabled=="N") {
                  $enabled1="no";
               }
               echo " $id = $enabled1\n";

               $result->MoveNext();
            }

            echo "end(SCANNER_SET)\n\n";

            $query="Select nessus_id, value 
                    from nessus_settings_preferences 
                    where category='SERVER_PREFS' 
                          and sid=$sid";
            $result=$dbconn->Execute($query);

            echo "begin(SERVER_PREFS)\n";

            while (!$result->EOF) {
               list( $nessus_id, $value)=$result->fields;
               echo " $nessus_id = $value\n";
               $result->MoveNext();
            }

            echo "end(SERVER_PREFS)\n\n";

            $query="Select nessus_id, value 
                    from nessus_settings_preferences 
                    where category='PLUGINS_PREFS' 
                          and sid=$sid";
            $result=$dbconn->Execute($query);

            echo "begin(PLUGINS_PREFS)\n";

            while (!$result->EOF) {
               list( $nessus_id, $value)=$result->fields;
               // don't display the passwords
               if (strstr($value, "ENC{")) {
                  echo " $nessus_id = <SensitiveData>\n";
                  /* for debug testing of encrypted values only
                  $value = substr($value,4);
                  echo "-- |$value|\n";
                  $value = substr($value, 0, strlen($value) - 1);
                  echo "-- |$value|\n";
                  $cbc = new Crypt_CBC($dbk, $cipher);
                  $decvalue = $cbc->decrypt(base64_decode($value));
                  echo " $nessus_id = $decvalue\n";
                  */
               } else {
                  echo " $nessus_id = $value\n";
               }
               $result->MoveNext();
            }

            echo "end(PLUGINS_PREFS)\n\n";

            $query="SELECT t1.id, t1.enabled 
                    from nessus_settings_plugins as t1, 
                         plugins as t2 
                    where t1.id=t2.id 
                         and t2.category <>'scanner' 
                         and t1.sid=$sid 
                    order by id";
            $result=$dbconn->Execute($query);
            echo "begin(PLUGIN_SET)\n";

            while (!$result->EOF) {
               list ($id, $enabled) = $result->fields;
               $enabled1="yes";
               if ($enabled=="N") {
                  $enabled1="no";
               }
               echo " $id = $enabled1\n";
               $result->MoveNext();
            }

            echo "end(PLUGIN_SET)\n\n";
            echo "</TEXTAREA>";
         // end prefs=4
         } elseif ($prefs=="3") {
            // manual plugin selection pages
            printNavLinks($navLinks, "Plugins");

            if ($saveplugins=="Save") {
               reset ($_POST);   // if form method="post"
               // edited to work on a per family basis so we can break
               // down the page to lighten up the HTML
               $result=$dbconn->Execute("Update nessus_settings_plugins 
                                         set enabled='N' 
                                         where sid=$sid and family=$fam");
               while (list($key, $value) = each ($_POST)) {
                  $key=htmlspecialchars(mysql_real_escape_string(trim($key)), ENT_QUOTES);

                  if (substr($key,0,3)=="PID") {
                     $key=substr($key, 3);
                     if(is_numeric($key)){
                        $results=$dbconn->Execute("Update nessus_settings_plugins 
                                                   set enabled='Y' 
                                                   where ID=$key 
                                                      and sid=$sid");
                     }
                  }
               }
            }

            if ($AllPlugins=="Enable All") {
               $result=$dbconn->Execute("Update nessus_settings_plugins 
                                         set enabled='Y' 
                                         where sid=$sid");
            }
            if ($NonDOS=="Enable Non DOS") {
               $query="select id 
                       from nessus_category 
                       where name='denial'";
               $result=$dbconn->execute($query);
               list ($cid)=$result->fields;
               $query = "update nessus_settings_plugins 
                         set enabled='N' 
                         where sid=$sid 
                            and category=$cid";
               $result=$dbconn->execute($query);
               $query="select id 
                       from nessus_category 
                       where name='destructive_attack'";
               $result=$dbconn->execute($query);
               list ($cid)=$result->fields;
               $query = "update nessus_settings_plugins 
                         set enabled='N' 
                         where sid=$sid 
                            and category=$cid";
               $result=$dbconn->execute($query);
            }
            if ($DisableAll=="Disable All") {
               $query="update nessus_settings_plugins 
                       set enabled='N' 
                       where sid=$sid";
               $result=$dbconn->execute($query);
            }

            // this doesn't make sense to do here as we just
            // set the plugins manually... we shouldn't override
            // those settings for existing plugins
            /*
            $query="select autoenable 
                    from nessus_settings 
                    where id=$sid";
            $result=$dbconn->execute($query);
            list($sautoenable)= $result->fields;

            if ($sautoenable=="C") {
               $query="select t1.cid, t1.status 
                       from nessus_settings_category as t1, 
                          nessus_category as t2 
                       where sid=$sid";
               $result=$dbconn->execute($query);

               while (!$result->EOF) {
                  list($cid, $catstatus)=$result->fields;
                  if ($catstatus==4) {
                     $query1="update nessus_settings_plugins 
                              set enabled='N' 
                              where category=$cid 
                                  and sid=$sid";
                     $result1=$dbconn->execute($query1);
                  } elseif ($catstatus==1) {
                     $query1="update nessus_settings_plugins 
                              set enabled='Y' 
                              where category=$cid 
                                 and sid=$sid";
                     $result1=$dbconn->execute($query1);
                  }
                  $result->MoveNext();
               }
            } elseif($sautoenable=="F") {
               $query="select t1.fid, t1.status 
                       from nessus_settings_family as t1, 
                       nessus_category as t2 
                       where sid=$sid";
               $result=$dbconn->execute($query);

               while (!$result->EOF) {
                  list($fid, $catstatus)=$result->fields;
                  if ($catstatus==4) {
                     $query1="update nessus_settings_plugins 
                              set enabled='N' 
                              where family=$fid 
                                 and sid=$sid";
                     $result1=$dbconn->execute($query1);
                  } elseif ($catstatus==1) {
                     $query1="update nessus_settings_plugins 
                              set enabled='Y' 
                              where family=$fid 
                                 and sid=$sid";
                     $result1=$dbconn->execute($query1);
                  }
                  $result->MoveNext();
               }
            }
            */

            echo "<p><b>Plugins</b></p>";

            // get total number of plugins
            $result=$dbconn->Execute("Select count(id) plugincount 
                                      from nessus_settings_plugins 
                                      where sid=$sid");
            list($pcount)=$result->fields;
            // get count of enabled plugins
            $result=$dbconn->Execute("Select count(id) plugincount 
                                      from nessus_settings_plugins 
                                      where enabled='Y' 
                                         and sid=$sid");
            list($penabled)=$result->fields;

            echo <<<EOT
<p>$pcount Nessus plugins available - $penabled - enabled</p>
<input type="submit" name="saveplugins" value="Save">
<input type="submit" name="AllPlugins" value="Enable All">
<input type="submit" name="NonDOS" value="Enable Non DOS">
<input type="submit" name="DisableAll" value="Disable All">
EOT;

            // get all the plugin families, ordered by family
            $result=$dbconn->GetArray("Select id, name 
                                      from nessus_family 
                                      order by name");
            $numFams = count($result) - 1;
            $famSelect = "<select id='family' onChange=\"showDiv(document.getElementById('family').value, 'family', $numFams);return false;\">\n";
            $i = 0;
            $famQuery = "Select t1.id, t1.name, 
                            t1.category, t2.enabled 
                         from plugins as t1, 
                            nessus_settings_plugins as t2 
                         where t2.family=? 
                            and t1.id=t2.id 
                            and t2.sid=?
                         order by t1.name";
            $stmt = $dbconn->Prepare($famQuery);
            foreach ($result as $family) {
               $famTabs .= "<option value='$i'>" . $family['name'] . "</option>\n";
               $result1 = $dbconn->GetArray($stmt, array($family['id'], $sid));
               $famContent .= createHiddenDiv($family['name'], $i, $result1,
                                              $family['id'],$sid);
               $i++;
            }

            echo "<p>" . $famSelect . $famTabs . "</select></p>\n";
            echo $famContent;

         // end pref=3
         }
      // end page=1
      } else {
         if ($op == "Edit") {
            printNavLinks($navLinks, "Options");

            $query = "select id, name, description, autoenable, type,
                         owner, auto_cat_status, auto_fam_status 
                      from nessus_settings 
                      where id=$sid";
            $result=$dbconn->execute($query);

            echo <<<EOT
<form method="post" action="settings.php">
<input type="hidden" name="item" value="update">
<input type="hidden" name="sid" value="$sid">
EOT;
            list ($sid, $sname, $sdescription, $sautoenable, $stype, $sowner, $auto_cat_status, $auto_fam_status)=$result->fields;
            if($stype=='G') { $stc = "checked"; }

            echo <<<EOT
<table>
<tr>
   <th>Name:</th>
   <td><input type="text" name="sname" value="$sname" size=50>
</tr>
<tr>
   <th>Description:</th>
   <td><input type="text" name="sdescription" value="$sdescription" size=50></td>
</tr>
<tr>
<th>Make this policy available to all users</th>
<td><input type='checkbox' name='stype' $stc>Global Policy</input></td>
</tr>
<tr>
<th valign='top'>Autoenable options:</th>
<td><SELECT name="sautoenable">
<option value="N"
EOT;
            if ($sautoenable=="N") { echo " selected";}
            echo ">None<option value=\"C\"";
            if ($sautoenable=="C") { echo " selected";}
            echo ">Autoenable by category<option value=\"F\"";
            if ($sautoenable=="F") { echo " selected";}
            echo ">Autoenable by family </select>";

            // now the auto-enable status pulldowns
            echo "<br>Initial status for autoenabled Categories: ";
            echo "<select name='auto_cat_status'>";
            echo "<option value='1'";
            if ($auto_cat_status == 1) { echo " selected";}
            echo ">Enable All</option>";
            echo "<option value='2'";
            if ($auto_cat_status == 2) { echo " selected";}
            echo ">Enable New</option>";
            echo "<option value='3'";
            if ($auto_cat_status == 3) { echo " selected";}
            echo ">Disable New</option>";
            echo "<option value='4'";
            if ($auto_cat_status == 4) { echo " selected";}
            echo ">Disable All</option>";
            echo "<option value='5'";
            if ($auto_cat_status == 5) { echo " selected";}
            echo ">Intelligent</option><br>";
            echo "</select>";
            echo "<br>Initial status for autoenabled Families: ";
            echo "<select name='auto_fam_status'>";
            echo "<option value='1'";
            if ($auto_fam_status == 1) { echo " selected";}
            echo ">Enable All</option>";
            echo "<option value='2'";
            if ($auto_fam_status == 2) { echo " selected";}
            echo ">Enable New</option>";
            echo "<option value='3'";
            if ($auto_fam_status == 3) { echo " selected";}
            echo ">Disable New</option>";
            echo "<option value='4'";
            if ($auto_fam_status == 4) { echo " selected";}
            echo ">Disable All</option>";
            echo "<option value='5'";
            if ($auto_fam_status == 5) { echo " selected";}
            echo ">Intelligent</option>";
            echo "</select>";
            echo "<p></p>"; 
            echo "<B>Autoenable plugins in categories:</B><BR>";
            $query = "select t1.cid, t2.name, t1.status 
                      from nessus_settings_category as t1, 
                           nessus_category as t2 
                      where t1.sid=$sid 
                            and t1.cid=t2.id 
                      order by t2.name";
            $result = $dbconn->execute($query);
            echo <<<EOT
<table border=1 bordercolor="#6797BF" cellspacing="0" cellpadding="0" 
style="border-collapse: collapse">
<tr><td>Name</td>
<td>Enable All</td>
<td>Enable New</td>
<td>Disable New</td>
<td>Disable All</td>
<td>Intelligent</td></tr>
EOT;

            while (!$result->EOF) {
               list ($cid, $name, $status) = $result->fields;
               echo <<<EOT
<tr><td>$name</td>
<td><input type="radio" name="c_$cid" value="1" 
EOT;
               if ($status==1) {echo "checked";}
               echo "></td><td><input type=\"radio\" name=\"c_$cid\" value=\"2\" ";
               if ($status==2) {echo "checked";}
               echo "></td><td><input type=\"radio\" name=\"c_$cid\" value=\"3\" ";
               if ($status==3) {echo "checked";}
               echo "></td>";
               echo "<td><input type=\"radio\" name=\"c_$cid\" value=\"4\" ";
               if ($status==4) {echo "checked";}
               echo "></td>";
               echo "<td><input type=\"radio\" name=\"c_$cid\" value=\"5\" ";
               if ($status==5) {echo "checked";}
               echo "></td></tr>";
               $result->MoveNext();
            }
            echo "</table><BR>";
            $query = "select t1.fid, t2.name, t1.status 
                      from nessus_settings_family as t1, 
                           nessus_family as t2 
                      where t1.sid=$sid 
                            and t1.fid=t2.id 
                      order by t2.name";
            $result = $dbconn->execute($query);
            echo <<<EOT
<B>Autoenable plugins in families:</B><BR>
<table border=1 bordercolor="#6797BF" cellspacing="0" cellpadding="0" 
style="border-collapse: collapse">
<tr><td>Name</td>
<td>Enable All</td>
<td>Enable New</td>
<td>Disable New</td>
<td>Disable All</td>
<td>Intelligent</td></tr>
EOT;

            while (!$result->EOF) {
               list ($fid, $name, $status) = $result->fields;
               echo "<tr><td>$name</td>";
               echo "<td><input type=\"radio\" name=\"f_$fid\" value=\"1\" ";
               if ($status==1) {echo "checked";}
               echo "></td>";
               echo "<td><input type=\"radio\" name=\"f_$fid\" value=\"2\" ";
               if ($status==2) {echo "checked";}
               echo "></td>";
               echo "<td><input type=\"radio\" name=\"f_$fid\" value=\"3\" ";
               if ($status==3) {echo "checked";}
               echo "></td>";
               echo "<td><input type=\"radio\" name=\"f_$fid\" value=\"4\" ";
               if ($status==4) {echo "checked";}
               echo "></td>";
               echo "<td><input type=\"radio\" name=\"f_$fid\" value=\"5\" ";
               if ($status==5) {echo "checked";}
               echo "></td></tr>";
               $result->MoveNext();
            }
            echo "</table><BR>";

            echo "<input type=\"submit\" name=\"submit\" value=\"Update\">
               </form>";
         // end op=Edit
         //} elseif ($delete=="Delete") {
         } elseif ($op == "Delete") {
            if ($confirm=="yes") {
               $query = "delete from nessus_settings where id=$sid";
               $result=$dbconn->execute($query);
               $query="delete from nessus_settings_preferences 
                       where sid=$sid";
               $result=$dbconn->execute($query);
               $query="delete from nessus_settings_plugins 
                       where sid=$sid";
               $result=$dbconn->execute($query);
               $query = "delete from nessus_settings_family 
                         where sid=$sid";
               $result=$dbconn->execute($query);
               $query = "delete from nessus_settings_category 
                         where sid=$sid";
               $result=$dbconn->execute($query);

               echo "Profile has been deleted<BR>";;
            } else {
               echo "Do you want to delete this profile?<BR>
               <a href=\"settings.php\">No</A> | <a href=\"settings.php?sid=$sid&amp;item=edit;op=Delete&amp;confirm=yes\">Yes</a>";
            }
         // end op=Delete
         }
      // end else
      }
   // end item=edit
   } elseif ($item=="update") {
      // Check to see if this is the owner doing the change
      $result = $dbconn->execute("select owner 
                                  from nessus_settings 
                                  where id = $sid");
      list ($myowner)=$result->fields;
      if ($myowner <> $username && !$uroles[admin]) {
         echo "Access denied: You do not own this profile and are not an admin 
               - (owner = $myowner)\n";
         require_once('footer.php');
         die ();
      }

      $query = "update nessus_settings 
                set name='$sname', description='$sdescription', 
                   type='$stype', autoenable='$sautoenable',
                   auto_cat_status = $auto_cat_status,
                   auto_fam_status = $auto_fam_status
                where id=$sid";
      $result=$dbconn->execute($query);

      reset ($_POST);   // if form method="post"

      while (list($key, $value) = each ($_POST)) {
         $value=htmlspecialchars(mysql_real_escape_string(trim($value)), ENT_QUOTES);

         if (substr($key,0,2)=="f_") {
            $type=substr($key,0,1);
            $key=substr($key, 2);
            $query="update nessus_settings_family 
                    set status=$value 
                    where sid=$sid and fid=$key";
            $results=$dbconn->Execute($query);
         } elseif(substr($key,0,2)=="c_") {
            $type=substr($key,0,1);
            $key=substr($key, 2);
            $query="update nessus_settings_category set status=$value where sid=$sid and cid=$key";
            $results=$dbconn->Execute($query);
         }
      }

      if ($sautoenable=="C") {
         $query="select t1.cid, t1.status from nessus_settings_category as t1, nessus_category as t2 where sid=$sid";
         $result=$dbconn->execute($query);

         while (!$result->EOF) {
            list($cid, $catstatus)=$result->fields;
            if ($catstatus==4) {
               $query1="update nessus_settings_plugins set enabled='N' where category=$cid and sid=$sid";
               $result1=$dbconn->execute($query1);
            } elseif ($catstatus==1) {
               $query1="update nessus_settings_plugins set enabled='Y' where category=$cid and sid=$sid";
               $result1=$dbconn->execute($query1);
            }
            $result->MoveNext();
         }
      } elseif($sautoenable=="F") {
         $query="select t1.fid, t1.status from nessus_settings_family as t1, nessus_category as t2 where sid=$sid";
         $result=$dbconn->execute($query);

         while (!$result->EOF) {
            list($fid, $catstatus)=$result->fields;
            if ($catstatus==4) {
               $query1="update nessus_settings_plugins set enabled='N' where family=$fid and sid=$sid";
               $result1=$dbconn->execute($query1);
            } elseif ($catstatus==1) {
               $query1="update nessus_settings_plugins set enabled='Y' where family=$fid and sid=$sid";
               $result1=$dbconn->execute($query1);
            }
            $result->MoveNext();
         }
      }
      echo "Profile Updated<BR>";
      echo "Return to <a href='javascript:back()'>Previous Page</a> or ";
      echo "<a href='settings.php'>Select another profile</a> to edit.";
   // end item=update
   } elseif ($item=="editusers" && $uroles[admin]) {

      printProfileName($dbconn, $sid);
      /*
      $query="select name, description 
              from nessus_settings 
              where id=$sid";
      $result=$dbconn->execute($query);
      echo "<p><b>Profile:</b> ".$result->fields[0] . " - " .
           $result->fields[1] . "</p>";
      */

      if ($op=="add") {
         if (isset($_POST['susers'])) {
            $susers=$_POST['susers'];
            for ($i = 0; $i < count($susers); $i++) {
               $susers[$i]=htmlspecialchars(mysql_real_escape_string(trim($susers[$i])), ENT_QUOTES);
               $query="delete from nessus_settings_users 
                       where sid=$sid and username='$susers[$i]'";
               $result=$dbconn->execute($query);
               $query="insert into nessus_settings_users (sid, username) 
                       values ($sid, '$susers[$i]')";
               $result=$dbconn->execute($query);
            }
         }
      }

      if ($op=="del") {
         $query="delete from nessus_settings_users 
                 where id=$uid";
         $result=$dbconn->execute($query);
      }
      $query="select id, username 
              from nessus_settings_users 
              where sid=$sid 
              order by username";
      $result=$dbconn->execute($query);

      printNavLinks($navLinks, "Edit Users");
/*
      echo <<<EOT
<p>
<A href="settings.php?item=edit&amp;submit=Edit&amp;sid=$sid">Options</a> | 
<A href="settings.php?item=edit&amp;sid=$sid&amp;page=1$amp;pref=1">Preferences</a> |
<A href="settings.php?item=edit&amp;sid=$sid&amp;page=1&amp;prefs=3">Plugins</A> |
Edit Users |
<A href="settings.php?item=edit&amp;sid=$sid&amp;page=1&amp;prefs=4">View Configuration File</a>
</p>
EOT;
*/
     echo <<<EOT
<table>
<tr>
   <th>User</th>
   <th>&nbsp;</th>
</tr>
EOT;

      while(!$result->EOF) {
         list($suid, $uname)=$result->fields;
         echo <<<EOT
<tr>
   <td>$uname</td>
   <td><a href="settings.php?item=editusers&amp;sid=$sid&amp;op=del&amp;uid=$suid">Del</a></td>
</tr>
EOT;
         $result->MoveNext();
      }

      echo <<<EOT
</table>
<form method="post" action="settings.php">
<input type="hidden" name="item" value="editusers">
<input type="hidden" name="op" value="add">
<input type="hidden" name="sid" value="$sid">
<p></p>
Available Users:<br>
<select name="susers[]" size="3" multiple>
EOT;

      $query="select pn_uname 
              from users 
              order by pn_uname";
      $result=$dbconn->execute($query);

      while(!$result->EOF) {
         list($uname)=$result->fields;
         echo "<option value=\"$uname\"> $uname";
         $result->MoveNext();
      }

      echo <<<EOT
</select>
<br>
<input type="submit" name="submit" value="Add Users">
</form>
EOT;
   // end item=editusers
   } else {
      if(!$uroles['admin']) { 
         $wclause = "where (owner = '$username' or type = 'G')"; 
      } else {
         $wclause = "";
      }
      $query="select id, name, description, owner, type
              from nessus_settings 
              $wclause
              order by name";
      $result=$dbconn->execute($query);

      echo <<<EOT
<B>Nessus Scanner Profiles</B>
<p>
Please select a profile to edit:
</p>
<table>
<tr>
   <th>Profile</th>
   <th>Description</th>
   <th>Owner</th>
   <th>Type</th>
   <th></th>
</tr>
EOT;
      while (!$result->EOF) {
         list($sid, $sname, $sdescription, $sowner, $stype)=$result->fields;
         echo <<<EOT
<tr>
<td>$sname</td>
<td>$sdescription</td>
<td>$sowner</td>
<td>$stype</td>
<td>
<a href="settings.php?item=edit&amp;op=Edit&amp;sid=$sid"><img src="images/pencil.png"></a>
<a href="settings.php?item=edit&amp;op=Deletesid=$sid&amp;"><img src="images/delete.png"></a>
</td>
</tr>
EOT;
         $result->MoveNext();
      }
      echo <<<EOT
</table>
<!--
</select><BR>
<input type="submit" name="submit" value="Edit">
<input type="submit" name="delete" value="Delete">
<input type="submit" name="submit" value="Edit">
<input type="submit" name="submit" value="Delete">
</form>
<BR>
-->
<p>
<a href="settings.php?item=new">Create New Profile</a> |
<a href="defaults.php">Edit default profile</A>
</p>
EOT;
   // end else
   }
}

require_once('footer.php');

function updatedbold($fieldname, $fieldvalue, $dbconn, $type, $sid) {
    if ($type=="C" and $fieldvalue=="") {
        $fieldvalue="no";
    }

    $query= "Update nessus_settings_preferences 
             set value='$fieldvalue', type='$type' 
             where id='$fieldname' and sid=$sid";
    $result=$dbconn->execute($query);
}


function updatedb($nessus_id, $fieldvalue, $dbconn, $type, $category, $sid) {
    if ($type=="C" and $fieldvalue=="") {
        $fieldvalue="no";
    }

    $sql = "select count(*) 
            from nessus_settings_preferences 
            where sid = $sid and nessus_id = \"$nessus_id\"";
    $result=$dbconn->execute($sql);

    list($existing)=$result->fields;
    if ($existing == 0) {
      # Do an insert statement
        $sql = "insert nessus_settings_preferences 
                set nessus_id = \"$nessus_id\", value=\"$fieldvalue\", 
                  type=\"$type\", category=\"$category\", sid=$sid";
    } else {
        $sql = "update nessus_settings_preferences 
                set value=\"$fieldvalue\", type=\"$type\", 
                  category=\"$category\" 
                where nessus_id = \"$nessus_id\" and sid = $sid";
    }
    $result=$dbconn->execute($sql);
}


function fieldlink($fieldname, $dbconn) {
    /* This function will return a url that maps to a link to the edgeos 
       knowledgebase for the item being displayed 
       Assumptions: DBVersion must be set to x.xx 
       This should be checked once the code is cleaned a bit */

    $fieldquery = "select edgeos, label 
                   from nessus_preferences 
                   where id = '$fieldname' limit 1";
    $fieldresult = $dbconn->execute($fieldquery);
    list($edgeos,$label)=$fieldresult->fields;
    if ($edgeos > 0) {
        if ($label == "") {
            $returnvalue = "^$edgeos^";
        }
        else {
            $returnvalue = " <A href=\"http://www.edgeos.com/nessuskb/details.php?option_id=$edgeos\">$label</A> ";
        }
    }
    else {
        /* Weird cases here */
        $returnvalue = "^";
    }
    return $returnvalue;
}


/**
 * @param string $nessus plugin key
 * @return integer $kbid edgeos knowledgebase id
 * @author adamc
 */
function getKBID($dbconn, $nessus_id)
{
    $kbid = null;
    $nessus_id = addslashes(rtrim($nessus_id, " :")); // sanitise string for db query
    $fieldquery = "SELECT nessus_nkb 
                   FROM nessus_nkb 
                   WHERE nessus_key='" . $nessus_id . "' LIMIT 1";
    $fieldresult = $dbconn->execute($fieldquery);
    list($kbid) = $fieldresult->fields;
    return $kbid;
}


/**
 * @param string $key nessus plugin key
 * @param string $nessus_id nessus plugin id
 * @return string $url url for edgeos knowledgebase entry
 * @author adamc
 */
function getKBURL($dbconn, $key, $nessus_id)
{
    $kbid = getKBID($dbconn, $nessus_id);
    if( $kbid > 0 )
    {
        $url = "<a href=\"http://www.edgeos.com/nessuskb/details.php?option_id=" . $kbid . "\">" . $key . "</a>";
    }
    else
    {
        $url = $key;
    }
    return $url;
}


function formprint($nessus_id, $field, $vname, $type, $default, $value, $dbconn) {
    # Commenting this out as there is no nessus_nkb table in 0.22
    #$field = getKBURL($dbconn, $field, $nessus_id); 
   # The pseudocode below will load a default value for an undefined field
   # to help make it easier for new fields to be added into the structure
   #
    $retstr = "";
    if ( is_null($value)) {
        if ($type == "R") {
            $value = explode(";", $default);
            $value = $value[0];
        }
        else {
            $value = $default;
        }
    }

    if ($type == "C") {
      # Checkbox code here
        $retstr="&nbsp;&nbsp;&nbsp;$field <INPUT type=\"checkbox\" name=\"$vname\" value=\"yes\"";
        if ($value=="yes") {
            $retstr.=" checked";
        }
        $retstr.="><BR>";
    }
    elseif ($type == "R") {
      # Radio button code here
        $retstr="&nbsp;&nbsp;&nbsp;$field <BR>";
        $array = explode(";", $default);
        foreach($array as $myoption) {
            $retstr.="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT type=\"radio\" name=\"$vname\" value=\"$myoption\"";
            if ($value == $myoption) {
                $retstr.=" checked";
            }
            $retstr.="> $myoption<BR>";
        }
    }
    elseif ($type == "P") {
      # Password code here
        #$retstr="$nessus_id $field <INPUT type=\"password\" name=\"$vname\" value=\"$value\"><BR>";
        $retstr="&nbsp;&nbsp;&nbsp;$field <INPUT type=\"password\" name=\"$vname\" value=\"$value\"><BR>";
    }
    else {
      # Assume it is a text box
        $retstr="&nbsp;&nbsp;&nbsp;$field <INPUT type=\"text\" name=\"$vname\" value=\"$value\"><BR>";
    }
    $retstr .= "\n";
    return $retstr;
}

function printProfileName($dbconn, $sid) {
   $query="select name, description 
           from nessus_settings 
           where id=$sid";
   $result=$dbconn->execute($query);
   echo "<p><b>Profile:</b> ".$result->fields[0] . " - " .
         $result->fields[1] . "</p>";
   echo "<p><a href='settings.php'>Select another profile to edit</a></p>";
}

function printNavLinks($navLinks, $section) {
   global $sid;
   $nt = "";
   foreach ($navLinks as $navName=>$navURL) {
      if($navName == $section) { // don't print link
         $nt .= "$navName | ";
      } else {
         $navURL = str_replace("%sid%",$sid,$navURL);
         $nt .= "<a href=\"$navURL\">$navName</a> | ";
      }
   }
   // strip off the last "|"
   $nt = substr($nt,0,-3);
   echo "<p>$nt</p>";
}

function createHiddenDiv($name, $num, $data, $fam, $sid) {
   $style = $text = "";
   if($num == 0)  {
      $style = "style='{display: block;}'";
   }
   $text = "<div id='family" . $num . "' name='$name' class='settings' $style>\n";
   $text .= "<form method='post' action='settings.php' name='fam$fam'>";
   $text .= "<input type='hidden' name='item' value='edit'>";
   $text .= "<input type='hidden' name='sid' value='$sid'>";
   $text .= "<input type='hidden' name='page' value='1'>";
   $text .= "<input type='hidden' name='prefs' value='3'>";
   $text .= "<input type='hidden' name='fam' value='$fam'>";

   $text .= "<table>\n";
   $text .= "<tr>";
   $text .= "<th colspan=5>$name</td>";
   $text .= "</tr>\n";
   $text .= "<tr>";
   $text .= "<th>Enabled</th>";
   $text .= "<th>PluginID</th>";
   $text .= "<th>Plugin Name</th>";
   $text .= "<th>Plugin Category</th>";
   $text .= "</tr>\n";

   foreach($data as $element) {
      $text .= "<tr>";
      $checked = "";
      if($element['enabled'] == "Y") { $checked = " checked"; }
      $text .= "<td align='right'><INPUT type=checkbox name='PID" . $element['id'] . "' id='" .
               $element['id'] . "' $checked></input></td>";
      $text .= "<td>" . $element['id'] . "</td>";
      $text .= "<td><a href='lookup.php?id=" . $element['id'] . "' target='_blank'>" . $element['name'] .
               "</a></td>";
      $text .= "<td>" . $element['category'] . "</td>";
      $text .= "</tr>\n";
   }
   $text .= "</table>\n";
   $text .= "<input type=\"submit\" name=\"saveplugins\" value=\"Save\"></form>";
   $text .= "</div>\n";
   return $text;
}
?>
