<?php
//
// $Id: validateip.inc.php,v 1.4 2006/08/10 17:19:33 airwofl Exp $
//

function validateip($ip) {
    $retip=0;

    if (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {
        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        if ($ip1<>0) {
            $retip=1;
        }
    } elseif (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])-([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {

        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        $ip2=intval($r[5])*16777216+intval($r[6])*65536+intval($r[7])*256+intval($r[8]);

        if ($ip2>$ip1 and $ip1<>0) {
            $retip=1;
        }
    }
    return($retip);
}

function inrange($ip, $dbconn) {
    $check=0;
    if (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {

        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        $ip2=0;

        if ($ip1<>0) {
            $check=1;
        }
    } elseif (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])-([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {

        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        $ip2=intval($r[5])*16777216+intval($r[6])*65536+intval($r[7])*256+intval($r[8]);

        if ($ip2>$ip1 and $ip1<>0) {
            $check=1;
        }
    }

    if ($check==1) {
        $uname=htmlspecialchars(mysql_escape_string(trim($_SESSION['user'])), ENT_QUOTES);
        $found=0;

        $query="SELECT range_start, range_end 
                FROM nessus_zone_ranges 
                INNER JOIN nessus_user_zones 
                   ON nessus_user_zones.zid=nessus_zone_ranges.zoneid 
                WHERE nessus_user_zones.username='$uname'";

        $result=$dbconn->execute($query);

        while(!$result->EOF) {

            list($range_start, $range_end)=$result->fields;

            $rip1=0;
            $rip2=0;

            if ($ip2==0 and $range_start==$range_end) {
                $rip1=$range_start;

                if ($rip1==$ip1) {
                    $found=1;
                    break;
                }
            }

            if ($range_start<$range_end) {

                $rip1=$range_start;
                $rip2=$range_end;

                if (($ip1>=$rip1 and $ip1<=$rip2 and $ip2==0) 
                     or ($ip1>=$rip1 and $ip2<=$rip2 and $ip2<>0)) {
                    $found=1;
                    break;
                }
            }
            $result->MoveNext();
        }
        return($found);
    } else {
        return(0);
    }
}

?>
