<?php
//
// $Id: webconfig.php,v 1.7 2006/08/10 17:19:33 airwofl Exp $
//

require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
//require_once('permissions.inc.php');
require_once('header2.php');

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Page accessed", PEAR_LOG_DEBUG);

$getParams = array( "section" );
$postParams = array( "op", "submit" );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   $op="";
   break;
case "POST" :
   foreach($postParams as $pp) {
	   if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
	break;
}

if (!$uroles['admin']) {
    echo "Access denied!!!";
} else {
   if ($op=="save") {
      $update="UPDATE inprotect_settings
              SET settingValue = ?
              WHERE settingName = ?";
      $ustmt = $dbconn->Prepare($update);

      // get the data from the $_POST
      $query = "SELECT settingName
                FROM inprotect_settings";
      $result = $dbconn->GetArray($query);
      foreach($result as $setting) {
	     if (isset($_POST[$setting['settingName']])) { 
            $val=htmlspecialchars(mysql_real_escape_string(trim($_POST[$setting['settingName']])), ENT_QUOTES); 
         } else { 
            $val=""; 
         }
         $updateres=$dbconn->execute($ustmt,array( $val,
                                                   $setting[settingName]));
         if($updateres === false) {
            $errMsg[] = "Error updating inprotect_settings: " . $dbconn->ErrorMsg();
            dispSQLError($errMsg,1);
         }
      }

   }
   //Display Inprotect Settings
   // get the list of sections defined
   $sq = "SELECT distinct settingSection
          FROM inprotect_settings
          ORDER BY settingSection";
   $result = $dbconn->GetArray($sq);
   $query="SELECT *
           FROM inprotect_settings 
           WHERE settingSection = ?";
   $stmt = $dbconn->Prepare($query);
   if($result === false) {
      $errMsg[] = "SQL Error getting settingSections: " . $dbconn->ErrorMsg();
      dispSQLError($errMsg, 1);
   } else {
      $i = 0;
      $numSections = count($result) - 1;
      foreach($result as $section) {
         $result2 = $dbconn->GetArray($stmt,array($section['settingSection']));
         if($result2 === false) {
            $errMsg[] = "SQL Error getting data: " . $dbconn->ErrorMsg();
            dispSQLError($errMsg, 1);
         } else {
            if($settingTabs != "") { $settingTabs .= " | "; }
            $settingTabs .= "<a href=\"javascript:\" onClick=\"showDiv($i, 'section',$numSections);return false;\">" . $section['settingSection'] . "</a>";
            $settingContent .= createHiddenDiv($section['settingSection'], $i, $result2);
            $i++;
         }
      }
   }
   echo "<div>";
   echo "<form method='post' action='" . $_SERVER[PHP_SELF] . "'>";
   echo "<input type='hidden' name='op' value='save'>";
   echo "<p>" . $settingTabs . "</p>\n";
   echo $settingContent;
   echo "<p><input type='submit' name='submit' value='Save'></p>";
   echo "</form>";
   echo "</div>";
/*
   echo <<<EOT
<form method="post" action="$_SERVER[PHP_SELF]">
<input type="hidden" name="op" value="save">
<table>
EOT;
      foreach($result as $setting) {
         echo "<tr><th>$setting[settingDescription]</th>";
         echo "<td><input type='text' name='$setting[settingName]'
                    value='$setting[settingValue]' size=50></input></td></tr>";
      }
      echo <<<EOT
</table>
<input type="submit" name="submit" value="Save">
</form>
EOT;
   }
*/
}
require_once('footer.php');

function createHiddenDiv($name, $num, $data) {
   $text = "";
   if($num == 1) {
      $style = "style='{display: block;}'";
   }
   $text = "<div id='section" . $num . "' name='$name' class='settings' $style>\n";
   $text .= "<table>\n";
   foreach($data as $element) {
      $text .= "<tr><th align=left>" . $element['settingDescription'] . "</th>";
      $text .= "<td><input type='text' name='" . $element['settingName'] . "' value='" .
               $element['settingValue'] . "' size=50</input></td></tr>\n";
   }
   $text .= "</table>\n</div>\n";
   return $text;
}
?>
