<?php
//
// $Id: config.php,v 1.5 2006/08/10 17:19:32 airwofl Exp $
// 

//ini_set("ERROR_REPORTING", E_ALL);
ini_set("ERROR_REPORTING", E_ALL & ~E_NOTICE);
ini_set("ERROR_LOG", "/var/log/inprotect/php.log");
ini_set("DISPLAY_ERRORS", 'off');

// register_globals cheat code
//HTTP_GET_VARS
while (list($key, $val) = @each($HTTP_GET_VARS)) {
       $GLOBALS[$key] = $val;
}
//HTTP_POST_VARS
while (list($key, $val) = @each($HTTP_POST_VARS)) {
       $GLOBALS[$key] = $val;
}
//_FILES
while (list($key, $val) = @each($_FILES)) {
       $GLOBALS[$key] = $val;
}
//$HTTP_SESSION_VARS
while (list($key, $val) = @each($HTTP_SESSION_VARS)) {
       $GLOBALS[$key] = $val;
}
//$HTTP_SERVER_VARS
while (list($key, $val) = @each($HTTP_SERVER_VARS)) {
       $GLOBALS[$key] = $val;
}

$dbtype="mysql";
$dbhost="localhost";
$dbuname="inprotect";
$dbpass="inprotect";
$dbname="inprotect";
$dbk="secretEncryptionKey";
$cipher='Blowfish';

$handler = "file";
$name    = "/var/log/inprotect/inprotectgui.log";
$ident   = "Inprotect";
$ver = "0.32";
$conf = array("mode" => 0660);

include ('inc/Log.php');
$logh =& Log::Factory($handler, $name, $ident, $conf, PEAR_LOG_DEBUG);
include ('adodb/adodb.inc.php');

// Start connection
$dbconn = ADONewConnection($dbtype);
$dbh = $dbconn->Connect($dbhost, $dbuname, $dbpass, $dbname);
if (!$dbh) {
    $dbpass = "";
    die("$dbtype://$dbuname:$dbpass@$dbhost/$dbname failed to connect" . 
        $dbconn->ErrorMsg());    
}

/* following have been moved to DB
//Change this value to 1 if you want to test any IP address
$allowscan=1;

//Enable scan of private IPs. (192.168.x.x, 10.x.x.x)
$enableprivate=1;

//Use SSL?
$enablessl=1;

//Verify email address
$emailverify=0;

//Password quality settings
$pq_minLength = 8;
$pq_maxLength = 64;
$pq_minAlpha = 1;
$pq_minLower = 0;
$pq_minUpper = 0;
$pq_minSpecial = 0;
$pq_minNumber = 1;

// Modules
//   reports
$enableFP = FALSE;
$enableException = TRUE;
$enableNotes = FALSE;
$enablePS = FALSE;
$enableUpdates = FALSE;

// array of possible roles
$allRoles = array( "admin" => "Administrator (incl. users)",
                   "uadmin" => "User Administration",
                   "nessus" => "Run Nessus scans",
                   "nmap" => "Run Nmap scans",
                   "scanRequest" => "Manage Scan Requests",
                   "reports" => "View all scan reports",
                   "zones" => "Edit Network Zones",
                   "eapprove" => "Approve Exceptions",
                   "esubmit" => "Submit Exception Requests",
                   "eview" => "View Exceptions",
                   "profile" => "Edit Nessus Scan Profiles" );

// LDAP user authentication options
$authLDAP = FALSE;  // use LDAP auth
$authFailLocal = TRUE;  // fall-through to local auth if user not found in LDAP
$authLDAP_host = "ldap://localhost:389";
$authLDAP_port = ""; // 38901=non-ssl, 63601 for SSL
$authLDAP_baseDN = "dc=mindache,dc=com";
$authLDAP_searchBase = "ou=inprotect" . $authLDAP_baseDN;
$authLDAP_searchAttr = "uid";
$authLDAP_searchResults = array( "dn" );

// status flags to skip in hosts table
$nostatus = array( "Decommissioned", 
                   "Retired", 
                   "Offline", 
                   "Virtual",
                   "Alias");

// max scan age (make sure it matches value in /usr/local/etc/inprotect.cfg)
$maxScanAge = 180;

// possible values for select DB tables
$hostScanStateArray = array ("Passed","Pending Scan","Pending Fixes","Pending Exceptions","Scan Out of Date","Fixes Applied - Pending ReScan" );
$serverLocationArray = array( "Andover","Franklin","MWDC","POS" );
$serverStateArray = array("Production","Pending Production","Test","Development","UAT" );
$serverNetworkArray = array("DMZ","Internal","Test","Lab","Other" );
$requestStatusArray = array("Pending","Scheduled","Rejected" );
$exceptionStatusArray = array ("Pending","Rejected","Approved");
$exceptionTypeArray = array( "False Positive","Ambiguous Vulnerability","True Positive");

* end stuff moved to DB
*/

/* moved to dashboards table in DB
// dashboard variables, used in multiple places
$dashCheckboxes = array( "dvt" => "Vulnerability Totals",
                         "dpe" => "Pending Exceptions",
                         "dmt" => "My Totals",
                         "dss" => "System Stats",
                         "dem" => "Executive Metrics",
                         "dnw" => "News Items" );

// order dictates how they show up on the dashboard
$dashModules = array( "dmt" => "dashDMT.inc",
                      "dvt" => "dashDVT.inc",
                      "dem" => "dashMetrics.inc",
                      "dpe" => "dashDPE.inc",
                      "dss" => "dashDSS.inc",
                      "dnw" => "dashDNW.inc");

// where the dashboards are located on the page (column)
$dashLocation = array( "dss" => "lcolumn",
                       "dvt" => "rcolumn",
                       "dpe" => "lcolumn",
                       "dmt" => "rcolumn",
                       "dem" => "lcolumn",
                       "dnw" => "lcolumn");
*/


/* moved to inprotect_settings table in DB
$suggestionEmailAddress = "email@doamin.com";
$scanRequestSubmitEmail = "email@domain.com";
$scanRequestApproveEmail = "email@domain.com";
$fromEmail = "email@domain.com,email2@domain.com";
$replyTo = "email@domain.com,email2@domain.com";
*/

// get the config data from the database
$query = "SELECT settingName, settingValue
          FROM inprotect_settings";
$result = $dbconn->GetArray($query);
if($result === false) {
   die("Unable to get configuration settings from DB - exiting");
} else {
   foreach($result as $setting) {
      if(strpos($setting['settingValue'],",")) {
         $$setting['settingName'] = explode(",",$setting['settingValue']);
      } else {
         $$setting['settingName'] = $setting['settingValue'];
      }
   }
}

?>
