<?php
/*
 * Dashboard module for dispalying the current plugin totals
 */

//echo "<p class='dashHeading'>Pending Exceptions</p>";

if($uroles['eview'] || $uroles['admin'] || $uroles['esubmit'] || $uroles['eapprove']) {
   $query="SELECT status, count(status) as count
           from exceptions
           group by status
           order by status ASC";
   $result=$dbconn->GetArray($query);
   $details = "<table>";
   $count = 0;
   foreach ($result as $data) {
      $count += $data['count'];
      $details .= "<tr><th>$data[status]</th><td>$data[count]</td></tr>";
   }
   $details .= "</table>";
   echo "<p>There ";
   if($count == 1)
      echo "is $count <a href='exceptions.php'>exception</a>";
   else 
      echo "are $count <a href='exceptions.php'>exceptions</a>";
   echo " in the database.</p>";

   echo "<p><center>$details</center></p>";
   
   $limit = 10;
   $query="SELECT eid, submitDate, status, plugin, type, ip, 
                  closeDate, approver, hostname
           FROM exceptions 
           WHERE status = 'Pending'
           ORDER BY submitDate DESC LIMIT 0,$limit";
   $result=$dbconn->GetArray($query);

   if(!($result === false)) { // there are pending exceptions
      $limit = (count($result) > $limit) ? $limit : count($result); 
      echo "<center>Latest $limit pending exceptions</center>";
      echo "<table summary='Latest pending exceptions'>";
      echo "<tr>
            <th>EID</th>
            <th>IP</th>
            <th>SubmitDate</th>
            <th>plugin</th>
            <th>type</th>
            </tr>
            <tr>";
      foreach($result as $key=>$edata) {
         $elink = make_link('exception',$edata['eid']);
         echo "<tr>
               <td>$elink</td>
               <td>$edata[ip]</td>
               <td>$edata[submitDate]</td>
               <td>$edata[plugin]</td>
               <td>$edata[type]</td>
               </tr>";
      }
      echo "</tr></table>";
   }
} else {
   echo "Insufficient rights to view this dashboard module.";
}
?>
