<?php
//
// $Id: graph1.php,v 1.5 2006/08/10 17:19:32 airwofl Exp $
//

require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once("jpgraph/jpgraph.php");
require_once("jpgraph/jpgraph_pie.php");
require_once("jpgraph/jpgraph_pie3d.php");

$getParams = array( "risk1", "risk2", "risk3", "risk4", "risk5",
                    "risk6", "risk7" );
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp = ""; 
      }
   }
	break;
}

if ($risk1=="" || $risk2=="" || $risk3=="" || $risk4=="" || $risk5=="" || $risk6=="" || $risk7=="") { JpGraphError::Raise(" No vulnerability data or incomplete data to chart. "); }
if (!is_numeric($risk1)) { JpGraphError::Raise(" Incorrect parameter - risk1 is not numeric. "); }
if (!is_numeric($risk2)) { JpGraphError::Raise(" Incorrect parameter - risk2 is not numeric. "); }
if (!is_numeric($risk3)) { JpGraphError::Raise(" Incorrect parameter - risk3 is not numeric. "); }
if (!is_numeric($risk4)) { JpGraphError::Raise(" Incorrect parameter - risk4 is not numeric. "); }
if (!is_numeric($risk5)) { JpGraphError::Raise(" Incorrect parameter - risk5 is not numeric. "); }
if (!is_numeric($risk6)) { JpGraphError::Raise(" Incorrect parameter - risk6 is not numeric. "); }
if (!is_numeric($risk7)) { JpGraphError::Raise(" Incorrect parameter - risk7 is not numeric. "); }

$data = array($risk1,$risk2,$risk3,$risk4,$risk5,$risk6,$risk7);

$totalvulns=$risk1+$risk2+$risk3+$risk4+$risk5+$risk6+$risk7;
if ($totalvulns > 0) {
$graph = new PieGraph(450,200,"auto");
$graph->SetAntiAliasing();
$graph->SetShadow();

$graph->title->Set("Vulnerabilities Found - $totalvulns");
$graph->title->SetFont(FF_FONT1,FS_BOLD);

$p1 = new PiePlot3D($data);
$p1->SetSize(0.5);
$p1->SetStartAngle(290);
$p1->SetAngle(50);
$p1->SetCenter(0.35);


$legend=array("Serious - $risk1","High - $risk2","Medium - $risk3","Medium/Low - $risk4","Low/Medium - $risk5","Low - $risk6","Info - $risk7");

$p1->SetLegends($legend);
$colors=array("red", "yellow", "magenta", "orange", "navy", "green","blue");
$p1->SetSliceColors($colors);
$p1->ExplodeAll(8);
//$dplot[0]->SetFillColor("blue");
//$dplot[1]->SetFillColor("green");
//$dplot[2]->SetFillColor("navy");
//$dplot[3]->SetFillColor("orange");
//$dplot[4]->SetFillColor("magenta");
//$dplot[5]->SetFillColor("yellow");
//$dplot[6]->SetFillColor("red");

$graph->Add($p1);
$graph->Stroke();
}
?>
