<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<head>
<?php
if (isset($pageTitle)) {
   echo "<title>InProtect - $pageTitle</title>";
} else {
   echo "<title>InProtect</title>";
}

// Insert META information tags if applicable
if( isset($meta_info) && is_array($meta_info) ) {
    foreach( $meta_info as $tag_info ) {
        $meta_string = "<meta";
        foreach( $tag_info as $tag_property=>$tag_value ) {
            $meta_string .= " " . $tag_property . "=\"" . $tag_value ."\"";
        }
        $meta_string .= " />";
        echo $meta_string;
    }
}
?>

<link rel="stylesheet" type="text/css" href="./css/inprotect.css" />
<script type="text/javascript" src="inprotect.js"></script>
<script type="text/javascript">
<!--
startList = function() {
   if (document.all&&document.getElementById) {
      navRoot = document.getElementById("menu");
      for (i=0; i<navRoot.childNodes.length; i++) {
         node = navRoot.childNodes[i];
         if (node.nodeName=="LI") {
            node.onmouseover=function() {
               this.className+=" over";
            }
            node.onmouseout=function() {
               this.className=this.className.replace(" over", "");
            }
         }
      }
   }
}
window.onload=startList;
-->
</script>


</head>
<body>
<div id="header">
<div class="leftheader">
   <img alt="Logo" src="images/logo-blue.png">
</div>

<div class="rightheader">
   Logged in as: <I><?php echo $username; ?></I>&nbsp;&nbsp;<BR/>
   InProtect <I>v<?php echo $version; ?></I><br/>
   System Time: <I><?php echo date("m/d/Y H:i:s"); ?></I>
</div>
</div>
<div style="{clear:both;}"></div>
<div id="container">

<div id="nav">
<div>
<ul id="menu">
   <li id="first">
      <div><A HREF="index.php" Class="navlink"> Home</a></div>
   </li>
   <li>
      <div><A HREF="control.php" Class="navlink">Settings</a></div>
      <ul>

<?php
if($uroles['admin'] || $uroles['profile'] || $uroles['zones'] || $uroles['uadmin']) {
   if($uroles['admin']) {
      echo "<li><a href='webconfig.php' class='navlink'>Inprotect Settings</a></li>";
   }
   if($uroles['profile']) {
      echo "<li><a href='settings.php' class='navlink'>Nessus Scan Profiles</A></li>";
   }
   if($uroles['zones']) {
      echo "<li><a href='servers.php' class='navlink'>Nessus Servers</A></li>";
      echo "<li><a href='zones.php' class='navlink'>Network Zones</A></li>";
   }
   if($uroles['admin'] || $uroles['uadmin']) {
      echo "<li><a href='admin.php' class='navlink'>Manage Users</A></li>";
      echo "<li><a href='gadmin.php' class='navlink'>Manage Groups</A></li>";
   }
}

echo "<li><a href='user.php' class='navlink'>My Settings</a></li>";

if ($enableUpdates || $uroles['admin']) {
   echo "<li><A HREF='updates.php' Class='navlink'>Updates</a></li>";
}
echo <<<EOT
      </ul>
   </li>
EOT;
if( $uroles['nessus'] || $uroles['nmap'] || $uroles['scanRequest'] ) {
   echo "<li>
            <div><A HREF='scan.php' Class='navlink'>Security Scan</a></div>
            <ul>";
   if($uroles['nessus']) {
      echo "<li><A HREF='sched.php' Class='navlink'>Nessus Security Scan</a></li>";
   }
   if($enablePS && $uroles['nmap']) {
      echo "<li><A HREF='portscan.php' Class='navlink'>NMap Port Scan</a></li>";
   }
   if($uroles['scanRequest'] || $uroles['nessus']) {
      echo "<li><A HREF='scanRequest.php' Class='navlink'>Scan Requests</a></li>";
   }
   echo "</ul></li>";
}
?>
   <li>
      <div><A HREF="reports.php" Class="navlink">Reports</a></div>
      <ul>
         <li><A HREF="results.php" Class="navlink">Nessus Scan Results</a></li>
<?php
         if($enablePS) {
            echo "<li><a href='portscanres.php' class='navlink'>Nmap Scan Results</a></li>";
         }
?>
         <li><a href="plugins.php" class="navlink">Latest Plugins</a></li>
         <li><a href="top10v.php" class="navlink">Top 10 Vulns</a></li>
         <li><a href="top10h.php" class="navlink">Top 10 Hosts</a></li>
         <li><a href="trend.php" class="navlink">Vuln Trend Analysis</a></li>
         <li><a href="stats.php" class="navlink">Scan Trend - by Date</a></li>
         <li><a href="statss.php" class="navlink">Scan Trend - by Scan</a></li>
      </ul>
   </li>
   <li>
      <div><A HREF="search.php" Class="navlink">Search</a></div>
   </li>
   <li>
      <div><A HREF="status.php" Class="navlink">Status</a></div>
      <ul>
         <li><a href="livestats.php" class="navlink">Running Nessus Scans</a></li>
         <li><a href="schedstats.php" class="navlink">Pending Nessus Scans</a></li>
         <li><a href="server-status.php" class="navlink">Nessus Server Status</a></li>
      </ul>
   </li>
   <li>
      <div><A HREF="hosts.php" Class="navlink">Hosts</a></div>
   </li>
<?php
// only display the exceptions tab if user has rights to access it
if( $uroles['eview'] || $uroles['esubmit'] || $uroles['eapprove'] ) {
   echo <<<EOT
   <li>
      <div><A HREF="exceptions.php" Class="navlink">Exceptions</a></div>
      <ul>
         <li><A HREF="exceptions.php?view=all" Class="navlink">All Exceptions</a></li>
         <li><a href="exceptions.php?view=pending" Class="navlink">Pending Exceptions</a></li>
      </ul>
   </li>
EOT;
}
?>
   <li>
      <div><A HREF="help.php" Class="navlink">Help</a></div>
   </li>
   <li>
      <div><A HREF="index.php?logout=true" Class="navlink">Logout</a></div>
   </li>
   <li id="last">
      <div>
      <a href="mailto:<?php echo $suggestionemail; ?>?subject=InProtect Suggestion" title="Make a Suggestion" class="navlink"><img src="images/email_link.png" alt="Make a Suggestion"></a>
      </div>
   </li>
</ul>
</div>
<div style="{clear: left;}"></div>
</div>

<div id="mainBody" class="column">
