<?php
//
// $Id: index.php,v 1.6 2006/09/19 04:57:00 airwofl Exp $
//

$pageTitle = "Home";
require_once('functions.inc');
require_once('config.php');
require_once('auth.php');
//require_once('permissions.inc.php');
require_once('header2.php');

$logh->log("$username : " . $_SERVER['PHP_SELF']  .
           " : Accessed Page", PEAR_LOG_DEBUG);


// set up the containing DIV for the dashboards
echo "<div id='dashContainer'>";

// get the users dashboard settings so we can dynamically create the content
/* old way
$dquery = "SELECT dashboard
           FROM users
           WHERE pn_uname = '$username'";
$dash = $dbconn->GetOne($dquery);
*/
// new way
$dquery = "SELECT d.dashModule, ud.dashLocation, d.dashURL, 
                  ud.dashStatus, d.dashName, ud.dashLocation, d.dashDesc
           FROM dashboards as d
           LEFT JOIN user_dashboards as ud ON ud.dashID = d.dashID
           WHERE ud.pn_uname = '$username' AND d.dashStatus = 1 AND
                 ud.dashStatus = 1
           ORDER BY d.dashOrder";
$dashboards = $dbconn->GetArray($dquery);
if($dashboards === false) {
   $errMsg[] = "Error getting dashboard configuraiton: " . $dbconn->ErrorMsg();
   dispSQLError($errMsg,1);
} else {
   // go through the valid modules and display those that the user has set to on
   foreach($dashboards as $dash) {
      if($dash['dashStatus'] == 1) { // dashboard is enabled
         // set up div with correct class that controls left/right location
         echo "<div id='dashModule' class='" . $dash['dashLocation'] . "'>";
         // add the header bar with the buttons to move the dashboard
         echo "<p class='dashHeading'>" . $dash['dashDesc'] . "</p>";
         include($dash['dashURL']);
         echo "</div>";
      }
   }
}

echo "<br /></div>"; // close dashContainer div
require_once('footer.php');

?>
