<?php
//
// $Id: lookup.php,v 1.9 2006/09/20 13:03:48 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net                        */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Lookup";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$getParams = array( "id", "op", "nid" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
}

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Accessed page", PEAR_LOG_DEBUG);
if(!is_numeric($id)) {
	$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
              " : Security violation - Requested non numeric pluginid " . 
              $id, PEAR_LOG_CRIT);
   echo "Cannot access this page - id is non numeric";
   require_once('footer.php');
	die();
}

if ($op=="delnote" and $nid<>"") {
    if(!is_numeric($nid)) { 
       require_once('footer.php');
       echo "Cannot access this page - nid is non numeric"; 
       die();
    }
    $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
               " : Security violation - Requested non numeric noteid " . 
               $nid, PEAR_LOG_CRIT);

    $query="delete from nessus_notes 
            where id=$nid and username='$username'";
    $result=$dbconn->execute($query);
}

$result=$dbconn->Execute("select * 
                          from plugins 
                          where ID='$id'");
list($pid, $pname, $pfamily, $pcategory, $pcopyright, $psummary, $pdescription, $pversion, $pcve_id, $pbugtraq_id)= $result->fields;

$pdescription=htmlspecialchars($pdescription, ENT_QUOTES);

echo "
<B>Nessus plugin details:</B><BR>
<B>ID:</B> $pid<BR><BR>
<B>Name:</B> $pname<BR><BR>
<B>Family:</B> $pfamily<BR><BR>
<B>Category:</B> $pcategory<BR><BR>
<B>Copyright:</B> $pcopyright<BR><BR>
<B>Summary:</B> $psummary<BR><BR>
<B>Description:</B> ".preg_replace("/\n/","<br>",$pdescription)."<BR><BR>
<B>Version:</B> $pversion<BR><BR>
<B>CVE IDs: </B>";
$CVEs = preg_split ("/[\s,]+/", $pcve_id);
foreach($CVEs as $CVE){
   echo"<a href=\"http://cve.mitre.org/cgi-bin/cvename.cgi?name=$CVE\">$CVE</a> ";
}
$Bugtraqs = preg_split ("/[\s,]+/", $pbugtraq_id);
echo"<br/><B>Bugtraq IDs: </B>";
foreach($Bugtraqs as $Bugtraq){
   echo"<a href=\"http://www.securityfocus.com/bid/$Bugtraq\">$Bugtraq</a>  ";
}

$result->Close();
echo <<<EOT
<BR/><BR/>
<B>
<a href="search.php?plugin=$pid&amp;showInfo=true&amp;submit=Search">
<img alt="View Systems with this vulnerability" src="images/info.png" border=0>
&nbsp;&nbsp;
View Systems with this vulnerability</A>
</b>
<BR><BR>
EOT;
if($enableNotes) {
   echo '<font color="red"><B>Notes:</B></font><BR>';

   $query = "select id, note 
             from nessus_notes 
             where username='$username' and pid=$id";
   $result=$dbconn->execute($query);
   while (!$result->EOF) {
       list($nid, $note)=$result->fields;
       echo "<hr><a href=\"lookup.php?op=delnote&amp;nid=$nid&amp;id=$id\"><img alt=\"Delete Note\" src=\"images/false.png\" border=0></a>&nbsp;&nbsp;$note<BR>";
   
       $result->MoveNext();
   }

   echo <<<EOT
<BR>
<a href="notes.php?op=add&amp;pid=$id&httpfrom=lookup">
<img alt="Add a Custom Note" src="images/note.png" border=0>
&nbsp;&nbsp;Add a Custom Note</a></font>
EOT;
}

include("footer.php");
?>
