<?php
//
// $Id: plugins.php,v 1.8 2006/08/10 17:19:32 airwofl Exp $
//

$pageTitle = "Scanner Plugins";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//include ('permissions_inc.php');

// the number of plugins per page
$size=10;

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
	if (isset($_GET['offset'])) { $offset=htmlspecialchars(mysql_escape_string(trim($_GET['offset'])), ENT_QUOTES); }
	else { $offset=""; }
	break;
}

if ($offset<>"") {
   if(!is_numeric($offset)) {
      $logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Security violation - Requested non numeric offset", PEAR_LOG_CRIT);
      die("Cannot access this page - offset is non numeric");
   }
} else {
   $offset=0;
}

$logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Accessed Page", PEAR_LOG_DEBUG);
echo "Plugins info<br>";

$query="SELECT count(*) from plugins";
$result=$dbconn->execute($query);
$count=$result->fields[0];
echo "There are <B>".$count."</B> Nessus plugins in the database<BR><BR><B>Latests 10 plugins added to the database:</B><BR>";

$query="SELECT t2.id, t2.name, t2.bugtraq_id, t2.cve_id, 
               date_format(t1.created,\"%W %M %e, %Y - %r\"), 
               t3.description 
        from plugins as t2, nessus_plugins as t1, risk_level as t3 
        where t2.id=t1.id and t1.risk=t3.id 
        order by created desc limit $offset,10";
$result=$dbconn->execute($query);

echo <<<EOT
<table summary="10 Latest Plugins added">
<tr>
   <th>Date</b></th>
   <th>Risk</th>
   <th>PluginID</th>
   <th>BID</th>
   <th>CVE</th>
   <th>Name</th>
</tr>
EOT;

while(!$result->EOF) {
   list($id, $name, $pbugtraq_id, $pcve_id, $date, $risk)=$result->fields;
   echo <<<EOT
<tr>
   <td valign="top">$date&nbsp;</td>
   <td valign="top">$risk&nbsp;</td>
   <td valign="top">$id</td>
   <td valign="top">
EOT;

   $Bugtraqs = preg_split ("/[\s,]+/", $pbugtraq_id);
   sort($Bugtraqs);
   if ($pbugtraq_id<>"") {
	   foreach($Bugtraqs as $Bugtraq) {
	      echo"<a href=\"http://www.securityfocus.com/bid/$Bugtraq\">$Bugtraq</a>&nbsp;<br>";
	   }
   } else { 
      echo "-"; 
   }
   echo "</td><td valign=\"top\">";
   $CVEs = preg_split ("/[\s,]+/", $pcve_id);
   sort($CVEs);
   if ($pcve_id<>"") {
	   foreach($CVEs as $CVE) {
         echo"<a href=\"http://cve.mitre.org/cgi-bin/cvename.cgi?name=$CVE\">$CVE</a>&nbsp;<br>";
	   }
   } else { 
      echo "-"; 
   }

   echo "</td><td valign=\"top\"><a href=\"lookup.php?id=$id\">$name</A>&nbsp;</td></tr>";

   $result->MoveNext();
}
echo "</table>";
echo "<BR><B>Latest 10 plugins updated:</B><BR>";

$query="SELECT t2.id, t2.name, t2.bugtraq_id, t2.cve_id, 
               date_format(t1.modified,\"%W %M %e, %Y - %r\"), 
               t3.description 
        from plugins as t2, nessus_plugins as t1, risk_level as t3 
        where t2.id=t1.id and t1.modified is not null and t1.risk=t3.id 
        order by modified desc limit $offset,10";
$result=$dbconn->execute($query);

echo <<<EOT
<table summary="10 Latest Plugins updated">
<tr>
   <th>Date</th>
   <th>Risk</th>
   <th>PluginID</th>
   <th>BID</th>
   <th>CVE</th>
   <th>Name</th>
</tr>
EOT;

while(!$result->EOF) {
   list($id, $name, $pbugtraq_id, $pcve_id, $date, $risk)=$result->fields;
   echo <<<EOT
<tr>
   <td valign="top">$date&nbsp;</td>
   <td valign="top">$risk&nbsp;</td>
   <td valign="top">$id</td>
   <td valign="top">
EOT;

   $Bugtraqs = preg_split ("/[\s,]+/", $pbugtraq_id);
   sort($Bugtraqs);
   if ($pbugtraq_id<>"") {
      foreach($Bugtraqs as $Bugtraq) {
         echo"<a href=\"http://www.securityfocus.com/bid/$Bugtraq\">$Bugtraq</a>&nbsp;<br>";
      }
   } else { 
      echo "-"; 
   }
   echo "</td><td valign=\"top\">";
   $CVEs = preg_split ("/[\s,]+/", $pcve_id);
   sort($CVEs);
   if ($pcve_id<>"") {
      foreach($CVEs as $CVE){
         echo"<a href=\"http://cve.mitre.org/cgi-bin/cvename.cgi?name=$CVE\">$CVE</a>&nbsp;<br>";
      }
   } else { 
      echo "-"; 
   }

   echo "</td><td valign=\"top\"><a href=\"lookup.php?id=$id\">$name</A>&nbsp;</td></tr>";

   $result->MoveNext();
}

echo "</table>";

$previous=$offset-$size;
if ($previous < 0) $previous = 0;
$last=$count-$size;
$next=$offset+$size;
if ($next>$last) $next=$last;

echo <<<EOT
<p>
<a href="plugins.php?offset=0">&lt&lt First</a>
<a href="plugins.php?offset=$previous">&lt Previous </a>
<a href="plugins.php?offset=$next">| Next &gt;</a>
<a href="plugins.php?offset=$last"> Last &gt;&gt;</a>
EOT;

include ('footer.php');
?>
