<?php
//
// $Id: respdf.php,v 1.11 2006/09/19 04:57:00 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
#error_reporting(E_ALL);
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
//include ('permissions.inc.php');

//php4 version of htmlspecialchars_decode which is only available in php5 upwards
if (!function_exists('htmlspecialchars_decode'))
{
	function htmlspecialchars_decode($str)
	{
		$str = preg_replace("/&gt;/",">",$str);
		$str = preg_replace("/&lt;/","<",$str);
		$str = preg_replace("/&quot;/","\"",$str);
		$str = preg_replace("/&#039;/","'",$str);
		$str = preg_replace("/&amp;/","&",$str);

		return $str;
	}
}

$logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Page accessed", PEAR_LOG_INFO);

# Bizarre - have to define it here otherwise you get an "undefined" error when doing a save target from Firefox....
$schedid="";

switch ($_SERVER['REQUEST_METHOD']) 
{ 
case "GET" :
	if (isset($_GET['schedid'])) { 
      $schedid=htmlspecialchars(mysql_escape_string(trim($_GET['schedid'])), ENT_QUOTES); 
   } else {
      $schedid=""; 
   }
	if (isset($_GET['scantime'])) { 
      $scantime=htmlspecialchars(mysql_escape_string(trim($_GET['scantime'])), ENT_QUOTES); 
   } else { 
      $scantime=""; 
   }
	if (isset($_GET['scantype'])) {
      $scantype=htmlspecialchars(mysql_escape_string(trim($_GET['scantype'])), ENT_QUOTES); 
   } else { 
      $scantype=""; 
   }
	if (isset($_GET['uid'])) { 
      $uid=htmlspecialchars(mysql_escape_string(trim($_GET['uid'])), ENT_QUOTES); 
   } else { 
      $uid=""; 
   }
	if (isset($_GET['format'])) { 
      $format=htmlspecialchars(mysql_escape_string(trim($_GET['format'])), ENT_QUOTES); 
   } else { 
      $format=""; 
   }
	break;
}

// get user rights
/*
$admin=(strpos($_SESSION['roles'],"admin")) === FALSE ? FALSE : TRUE;
$reports=(strpos($_SESSION['roles'],"reports")) === FALSE ? FALSE : TRUE;
*/

if (!is_numeric($schedid)) {die("Cannot access this page - error detected in URL.");}

$uid_filter=0;
if ($uid<>"") { $uid_filter=1; }

// get the schedule information
$query="select count(id),username 
        from nessus_schedule 
        where id=$schedid 
        group by username";
$result=$dbconn->execute($query);

list($allowaccess, $sql_uid)=$result->fields;
if ($allowaccess<>1) { 
   die("Cannot access this page - Schedule details not in the database."); 
}

// make sure there are results for the scan and check rights
$query="select count(sched_id),username 
        from nessus_results 
        where sched_id=$schedid 
              and scantime='$scantime' 
        group by username";
$result=$dbconn->execute($query);

list($allowaccess, $sql_uid)=$result->fields;

if ($sql_uid!=$username)
{
   if (!$uroles[admin] && !$uroles[reports]) { 
     die("Cannot access this page - You are not the report owner or an admin."); 
   } else {
	   if (!$uid_filter) {
	      $uid_filter=1;
	      $uid=$sql_uid;
	   }	else {
	      if ($sql_uid!=$uid) { 
            die("Cannot access this page - error detected in URL (uid's don't match)."); 
         }
	   }
   }
} else {
   $uid=$username;
}

/* not sure we need this, maybe once the server gets more data???
ini_set("max_execution_time","360");
ini_set("memory_limit","64M");
*/

//Seperates the parts of the date so it doesn't just display it as one big number
$scanyear = substr($scantime, 0, 4);
$scanmonth = substr($scantime, 4, 2);
$scanday = substr($scantime, 6, 2);
$scanhour = substr($scantime, 8, 2);
$scanmin = substr($scantime, 10, 2);
$scansec = substr($scantime, 12);

//Generated date
$gendate = date("m/d/Y H:i:s");

//here you can set the preference for the table colors
$head_fill_color = array(100,149,237);
$head_text_color = 255;
$fill_color = array(224,235,255);
$text_color = 0;
$line_color = array(0,0,0);
$boarder_type = 1; #doesn't work yet, there's always a full boarder for now

//row height for the table
$row_height = 5;


// get the number of vulnerabilites for this scan
$query="select count(scantime) 
        from nessus_results
        where scantime='$scantime' 
              and username='$uid' 
              and sched_id=$schedid";
$result=$dbconn->execute($query);

list($numofresults)=$result->fields;
if ($numofresults<1) {die("No vulnerabilities recorded");}

//include pdf libraries
define('FPDF_FONTPATH','inc/font/');
require('inc/InproTable.php');

set_time_limit(300);
//start pdf file, add page, set font
// letter = 216x279 - 10mm margin (196mmx259mm effective)
$pdf = new PDF('P','mm',"letter");
$pdf->AddPage();
$pdf->SetFont('Times', 'B', 14);
$pdf->Cell(0, 9, 'Vulnerability Scan Report', 1, 1, 'C', 0);

$pdf->SetFont('Arial', '', 10);

$pdf->Cell(98,6,"Scan time: $scanmonth/$scanday/$scanyear $scanhour:$scanmin:$scansec",1,0,'C');
$pdf->Cell(98,6,"Generated: $gendate",1,1,'C');

// get the scan info
if ($scantime<>"" and $scantype=="A" and $schedid<>"") {
    $query="select distinct t1.username, t2.name, t3.name, 
                   t3.description 
            from nessus_results as t1, nessus_schedule as t2, 
                 nessus_settings as t3 
            where t1.username='$uid' 
                  and t1.scantype='A' 
                  and t1.sched_id = t2.id 
                  and t1.sid=t3.id and scantime='$scantime' 
            order by scantime DESC";
    $result=$dbconn->execute($query);
    list ($sql_uid, $sched_name, $profile_name, $profile_desc)=$result->fields;

    $pdf->Cell(85,6,"Profile: $profile_name - $profile_desc",1,0,'C');
    $pdf->Cell(66,6,"Schedule: $sched_name",1,0,'C');
    $pdf->Cell(45,6,"Owner: $sql_uid",1,0,'C');
#    $pdf->Ln();

    $pdf->SetFont('Arial', '', 10);

    //get current possition so we can put the pie chart to the side
    $valX = $pdf->GetX();
    $valY = $pdf->GetY();
    $riskarray = array(); //array of risks for pie chart
    $colorarray=array(); //array of colors for pie chart

    // get the data for the pie chart of # of risks
    $query = "SELECT DISTINCT nr.host as host, 
                              h.hostname as hostname 
              FROM `nessus_results` as nr
              Left Join hosts as h
              On nr.host=h.ip
              where nr.scantime='$scantime' 
                    and nr.username='$uid' 
                    and nr.scantype='$scantype' 
                    and nr.sched_id=$schedid 
              order BY nr.host";

    $result=$dbconn->Execute($query);
    //initialise variable for number of hosts while loop
    $hosts = array();
    while ($row = $result->fields) {
       $hosts[$row['host']]=$row['hostname'];
       $result->MoveNext();
    }

    // get the counts for each risk for this scan
    $query = "SELECT count(risk) as count, risk 
              FROM `nessus_results`
              where scantime='$scantime' 
                    and username='$uid' 
                    and scantype='$scantype' 
                    and sched_id=$schedid 
                    group by risk";
    $result=$dbconn->Execute($query);
    $index = 0;

    $pdf->Ln();
    $pdf->SetFont('Times', 'B', 12);
    $pdf->Cell(0, 6, "Total number of vulnerabilities identified on " .sizeof($hosts). " system(s)",0,1,'C');
    $pdf->Rect(10,31,196,48);
    $pdf->Ln();
    $pdf->SetFont('Arial', '', 10);
		#$pdf->Rect(100, 200, 130, 140, DF);
    while (list($riskcount, $risk)=$result->fields) {

        $pdf->MultiCell(70, 6, "".getrisk($risk)." : $riskcount" ,0,0,'C');
        $riskArray [getrisk($risk)] = $riskcount;
        $colorarray[$index] = getriskcolor($risk);
        $index++;
		#$pdf->Ln();
        $result->MoveNext();
    }

    //make pie chart and put current possition below

    $pdf->Ln();


    $pdf->SetXY(85, 38); #$valY);
    $pdf->PieChart(140, 40, $riskArray, '%l', $colorarray);
    $pdf->SetXY($valX, $valY + 40);


    //Host-Vulnerability Summary
    $pdf->Ln();
    $pdf->Ln();
    $pdf->Ln();
    $pdf->Ln();
    $pdf->SetFont('Times', 'B', 12);
    $size= 12 + (6 * sizeof($IPS));
    $pdf->Rect(10,85,196,$size);
    $pdf->Cell(0, 6, "Total number of vulnerabilities identified per system",0,1,'C');
    $pdf->SetFont('Arial', '', 10);
    // total of all cells should be 196
    $pdf->Cell(70, 6, "Host",1,0,'C');
    $pdf->Cell(18, 6, "Serious",1,0,'C');
    $pdf->Cell(18, 6, "High",1,0,'C');
    $pdf->Cell(18, 6, "Medium",1,0,'C');
    $pdf->Cell(18, 6, "Med/Low",1,0,'C');
    $pdf->Cell(18, 6, "Low/Med",1,0,'C');
    $pdf->Cell(18, 6, "Low",1,0,'C');
    $pdf->Cell(18, 6, "Info",1,0,'C');

    $pdf->Ln();

    // get the risk counts per host
    foreach ($hosts as $ip=>$hostname) {
       $pdf->Cell(70, 6, $ip . " - " . $hostname,1,0,'L');

       $query = "SELECT count(risk) as count, risk 
                 FROM `nessus_results`
	              where scantime='$scantime' 
                       and username='$uid' 
                       and scantype='$scantype'
	                    and sched_id=$schedid 
                       and host='$ip' 
                       and falsepositive <> 'Y' 
                  group by risk";
       $result1=$dbconn->Execute($query);

       $prevrisk=0;
       while(list($riskcount, $risk)=$result1->fields) {

          for ($k=0;$k<$risk-$prevrisk-1;$k++) {
             $pdf->Cell(18, 6, "--" ,1,0,'C');
          }

          $pdf->Cell(18, 6, "$riskcount" ,1,0,'C');
          $prevrisk=$risk;
          $result1->MoveNext();
       }

       $pdf->Ln();

   }

   $pdf->Ln();

   $pdf->SetFont('Arial', '', 8);
   // get the open ports data for the hosts
   $query="select host, 
                  service,
                  risk
           from nessus_results
           where scantime='$scantime' 
                 and username='$uid' 
                 and sched_id=$schedid 
                 and msg='' 
                 and risk='7'
           order by result_id ASC";
   $result1=$dbconn->execute($query); 
   // put it into an array for reference later
   $portResults=array();
   while(list($ip, $service, $risk)=$result1->fields) {
      $tmpport1=preg_split("/\(|\)/",$service);
      $tmpport2=preg_split("/\//",$tmpport1[1]);
      $service_num=$tmpport2[0];
      $service_proto=$tmpport2[1];

      $portResults[$ip][]=array( 'service_num' => $service_num, 
                                 'service_proto' => $service_proto, 
                                 'service' => $service, 
                                 'risk' => getrisk($risk) );
      $result1->MoveNext();
   }

   //build array of risks - join the hosts table to get the hostname
   $query = "select nr.host as ip,
                    h.hostname as host,
                    nr.service as service, 
                    nr.risk as risk, 
                    nr.msg as msg,
                    nr.scriptid as scriptid
             from nessus_results as nr
             left join hosts as h
             on nr.host=h.ip
             where nr.scantime='$scantime' 
                   and nr.scantype='$scantype' 
                   and nr.username='$uid'
	                and nr.sched_id=$schedid 
                   and nr.msg<>''
             order by INET_ATON(nr.host) ASC, nr.risk ASC";
   $result=$dbconn->Execute($query);

   $arrResults="";
   while(list($ip, $host, $service, $risk, $msg, $scriptid)=$result->fields) {
      $tmpport1=preg_split("/\(|\)/",$service);
      if (sizeof($tmpport1)==1) { $tmpport1[1]=$tmpport1[0]; }
#echo "$tmpport1[0] $tmpport1[1]<BR>";
      $tmpport2=preg_split("/\//",$tmpport1[1]);
#echo "$tmpport2[0] $tmpport2[1]<BR>";
      $service_num=$tmpport2[0];
      $service_proto=$tmpport2[1];

      $arrResults[$ip][]=array('hostname' => $host, 
                               'service_num' => $service_num, 
                               'service_proto' => $service_proto, 
                               'service' => $service, 
                               'risk' => getrisk($risk), 
                               'scriptid' => $scriptid, 
                               'msg' => $msg);
      $result->MoveNext();
   }
   //print_r($arrResults);
/*
   // now put together the results
   foreach ($arrResults as $ip=>$scanData) {
   
      // scan results
      foreach($scanData as $values) {
         $data.= "<tr valign=top><td>$ip</td>";
         for ($l=0; $l<count($values); $l++) {
            $data.= "<td>$values[$l]</td>";
         }
         $data.="</tr>";
      }
      // then open ports
      foreach($portResults[$ip] as $portData) {
         $data.= "<tr valign=top><td>$ip</td>";
         for ($l=0; $l<count($portData); $l++) {
            $data.= "<td>$portData[$l]</td>";
         }
         $data.="<td></td><td>Open Port</td></tr>";
      }
   }
*/
    
   //Vulnerability table configs
   $vcols = array('Service','Risk','PluginID','Description');
   //widths for columns
   $vwidth_array=array(39,25,17,115); // 196 total

   $count=0;
   // iterate through the IP is the results
   foreach ($arrResults as $ip=>$scanData) {
      $ip=htmlspecialchars_decode($ip);
      $hostname=htmlspecialchars_decode($hosts[$ip]);
      // new host record?
      if($oldip!=$ip) {
         $oldip=$ip;
         // don't print the table on the first host
         if($count==1) { 
            $pdf->InprotectTable($vcols, $all_results, $vwidth_array, $head_fill_color, $head_text_color, $fill_color, $text_color, $line_color, $boarder_type, $row_height);
            $pdf->Ln();
         }

         //print out the host cell
         $pdf->SetFont('','B',10);
         if($hostname<>"") {
            $pdf->Cell(0, 6, "Host: ".$ip." - ".$hostname, 0, 1, 'C');
         } else {
            $pdf->Cell(0, 6, "Host: ".$ip, 0, 1, 'C');
         }
         $pdf->SetFont('','');

         // print out the open ports cell
         $data = array();
         $carryOver = "";
         $i=0;
         foreach($portResults[$ip] as $portData) {
         //print_r($portData);
            if($i % 2) {
               $data[]= array( $carryOver, $portData['service']);
               $carryOver = "";
            } else {
               $carryOver = $portData['service'];
            }
            $i++;
         }
         if($carryOver <> "") {
            $data[] = array( $carryOver, "" );
         }
//         echo("<pre>");
//         print_r($data);
//         echo("</pre>");
         //Open port table configs
         $cols = array('Open Port','Open Port');
         //widths for columns
         $width_array=array(45,45); // 196 total
         // center the table
         $lo = 216 / 2 - 45;
         $pdf->OpenPortTable($cols, $data, $width_array, $head_fill_color, $head_text_color, $fill_color, $text_color, $line_color, $boarder_type, $row_height, $lo);
         $pdf->Ln();

      }

//echo('<pre>');
//print_r($scanData);
//echo('</pre>');

      // now iterate through the scan results for this IP
      $all_results = array();
      foreach($scanData as $vuln) {
	      $service=htmlspecialchars_decode($vuln['service']);
	      $service=wordwrap($service,8,"\n");
         $risk=getrisk($vuln['risk']);
         $msg=trim($vuln['msg']);
	      $msg=htmlspecialchars_decode($msg);
         $msg=preg_replace('/^\n+/','',$msg);
         $scriptid=$vuln['scriptid'];
         // append it to the results array
         $all_results[] = array($service,$risk,$scriptid,$msg);
      }
      // increment host counter
      $count=1;

   }
   // print out the final table
   if($count!=0) {
//echo('<pre>');
//print_r($all_results);
//echo('</pre>');
      $pdf->InprotectTable($vcols, $all_results, $vwidth_array, $head_fill_color, $head_text_color, $fill_color, $text_color, $line_color, $boarder_type, $row_height);
   }

/*
    //Vulnerability table configs
    $cols = array('Host','Service','Risk','Description');

    //widths for columns
    //$width_array=array(25,33,17,115);
    $width_array=array(46,25,125);

    //build table
    $pdf->InprotectTable($cols, $all_results, $width_array, $head_fill_color, $head_text_color, $fill_color, $text_color, $line_color, $boarder_type, $row_height);

*/
    $pdf->Ln();

  $pdf->Cell(0,6, 'Inprotect - web interface for Nessus and Nmap scanners',0, 1, 'C', 0);


} #$pdf->Image('/var/www/html/images/Picture2.png',50,90,0,0,$type='',$link='');

//output the pdf, now we're done$pdf-
header('Content-Type: application/pdf');
//header("Content-disposition:  attachment; filename=scanresults-$uid-$scantime.pdf");
$pdf->Output("scanresults-$uid-$scantime.pdf","I");

// prints out the table of risks
function printTable() {
    //build table
    $pdf->InprotectTable($cols, $all_results, $width_array, $head_fill_color, $head_text_color, $fill_color, $text_color, $line_color, $boarder_type, $row_height);

    $pdf->Ln();
}

//matches risks numbers with names
function getrisk($risk) {

    switch ($risk) {
    case 1:
            $risk="Serious";
        break;
    case 2:
        $risk="High";
        break;
    case 3:
        $risk="Medium";
        break;
    case 4:
        $risk="Medium/Low";
        break;
    case 5:
        $risk="Low/Medium";
        break;
    case 6:
        $risk="Low";
        break;
    case 7:
        $risk="Info";
        break;
    }

    return $risk;
}

//matches risks number with colors
function getriskcolor($risk)
{
    switch ($risk)
    {
    case 1:
        $risk=array(255,0,0);
        break;
    case 2:
        $risk=array(255,0,0);
        break;
    case 3:
        $risk=array(255,255,0);
        break;
    case 4:
        $risk=array(255,255,0);
        break;
    case 5:
        $risk=array(255,255,0);
        break;
    case 6:
        $risk=array(0,139,69);
        break;
    case 7:
        $risk=array(100,149,237);
        break;
    }
    return $risk;
}
?>
