<?php
//
// $Id: servers.php,v 1.10 2006/09/19 04:57:01 airwofl Exp $
//

$pageTitle = "Scanners";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$getParams = array( "item", "op", "nid" );
$postParams = array( "item", "op", "nnid", "nname", "ndescription",
                      "nhostname", "nport", "ntype", "nusername",
                      "npassword", "nmaxscans", "nessususer", "nessuspassword",
                      "submit" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST['item'])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

if ($op=="forcecheck")
{
   if( isset($meta_info) && is_array($meta_info) )
   {
      $meta_info_count = count($meta_info);
   }
   else
   {
      $meta_info_count = 0;
   }
   $meta_info[$meta_info_count]["http-equiv"] = "refresh";
   $meta_url = "servers.php";
   $meta_info[$meta_info_count]["content"] = "20;url=".$meta_url;
}

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Page accessed", PEAR_LOG_DEBUG);

//$acl=checkacl("zones", $dbconn);
/*
$zones = (strpos($_SESSION['roles'],"zones") === false) ? FALSE : TRUE;
*/

if (!$uroles['zones']) {
   echo "Access Denied!!!<br>";
} else {
   $query_log="insert into log (ip, username, action) 
               values('$_SERVER[REMOTE_ADDR]','$username',
                      'Allowed to access servers.php')";
   $result_log=$dbconn->execute($query_log);
   if ($item=="delete") {
      if ($op=="delete") {

         $query_log="insert into log (ip, username, action) 
                     values('$_SERVER[REMOTE_ADDR]','$username',
                            'Removed Nessus server - $nid')";
         $result_log=$dbconn->execute($query_log);

         $query = "delete from nessus_servers 
                   where id=$nid";
         $result=$dbconn->execute($query);
         $query= "delete from nessus_server_zones 
                  where nessusid=$nid";
         $result=$dbconn->execute($query);
         echo "Nessus server has been removed";
      } else {
         $query = "Select name, description, hostname 
                   from nessus_servers 
                   where id=$nid";
         $result = $dbconn->execute($query);
         list($nname, $ndescription, $nhostname) = $result->fields;
         echo <<<EOT
Are you sure you want to remove the following Nessus server from the database?<BR>
<B>$nname $ndescription $nhostname</B><BR>
<A href="servers.php?item=delete&amp;nid=$nid&amp;op=delete">Yes</a> 
<a href="servers.php">No</a>
EOT;
      }
   } elseif ($item=="edit") {
      if ($op=="updatezones") {
         if (isset($_POST['serverzones'])) {
            $serverzones=$_POST['serverzones'];
            for ($i = 0; $i < count($serverzones); $i++) {
               $serverzones[$i]=htmlspecialchars(mysql_escape_string(trim($serverzones[$i])), ENT_QUOTES);
               $query="delete from nessus_server_zones 
                       where zoneid=$serverzones[$i] and nessusid=$nid";
               $result=$dbconn->execute($query);
               $query="insert into nessus_server_zones (zoneid, nessusid) 
                       values ($serverzones[$i], $nid)";
               $result=$dbconn->execute($query);
            }
            echo "Zones updated";
         } else { 
            echo "Zones not updated as none selected / specified"; 
         }
      } elseif ($op=="editzones") {

         $query = "select t2.name, t2.id, t2.description 
                   from nessus_server_zones as t1, nessus_zones as t2 
                   where t1.nessusid=$nid and t1.zoneid=t2.id";
         $result=$dbconn->execute($query);
         echo <<<EOT
<table summary="Zone listing" border=1>
<tr>
<td></td>
<td>Name</td>
<td>Description</td>
</tr>
EOT;
         while (!$result->EOF) {
            list ($zname,$zid,$zdescription)=$result->fields;
            echo <<<EOT
<tr><td><a href="zones.php?item=edit&amp;zid=$zid">Edit</a></td>
<td>$zname</td>
<td>$zdescription</td></tr>
EOT;

            $result->MoveNext();
         }
         echo <<<EOT
</table>
<form method="post" action="servers.php">
<input type="hidden" name="op" value="updatezones">
<input type="hidden" name="item" value="edit">
<input type="hidden" name="nid" value="$nid">
EOT;
         $query = "select id, name 
                   from nessus_zones 
                   where type='G' or owner = '$username'";
         $result = $dbconn->Execute($query);
         echo "Network zones: <select name=\"serverzones[]\" multiple>";
         while (!$result->EOF) {
            list ($zid, $zname) = $result->fields;
            echo "<option value=\"$zid\">$zname";
            $result->MoveNext();
         }
         echo <<<EOT
</select><br>
<input type="submit" name="submit" value="Add selected Zones">
</form>
EOT;
      } elseif ($op=="save") {
         $query = "update nessus_servers 
                   set name='$nname', description='$ndescription', 
                      hostname='$nhostname', type='$ntype', 
                      user='$nusername', password='$npassword', 
                      max_scans=$nmaxscans, port=$nport 
                   where id=$nid";
//                   where id=$nid and owner='$username'";
         $result=$dbconn->execute($query);

         echo <<<EOT
Nessus server settings updated.<br>
Click <a href="servers.php">here</a> to review Nessus servers settings.
EOT;
      } else {
         $query="select id, name, description, hostname, port, user, 
                    password, max_scans,
                    count(nessus_scan.status) current_scans, type
                 from nessus_servers
                 left join nessus_scan 
                 on nessus_servers.id = nessus_scan.server_id 
                    and nessus_scan.status in ('P','R')
                 where id=$nid and (owner='$username' or type='G') 
                 group by id";
         $result=$dbconn->execute($query);

         list ($nid, $nname, $ndescription, $nhostname, $nport, $nusername, 
               $npassword, $nmaxscans, $currentscans, $ntype)=$result->fields;
         echo <<<EOT
<B>Edit Nessus Server</b><br>
<form method="post" action="servers.php">
<input type="hidden" name="item" value="edit">
<input type="hidden" name="op" value="save">
<input type="hidden" name="nid" value="$nid">
<table summary="Server Details">
<tr><td>Server ID</td><td>$nid</td></tr>
<tr><td>Server Name:</td>
<td><input type="text" name="nname" value="$nname"></td>
</tr>
<tr><td>Server Description:</td>
<td><input type="text" name="ndescription" value="$ndescription"></td>
</tr>
<tr><td>Server Hostname/IP address:</td>
<td><input type="text" name="nhostname" value="$nhostname"></td>
</tr>
<tr><td>Nessus Port:</td>
<td><input type="text" name="nport" value="$nport"></td>
</tr>
<tr><td>Server type:</td> 
<td><select name="ntype"> 
<option value="G" 
EOT;
if ($ntype=="G") { echo "selected"; } 
echo <<<EOT
>Global 
<option value="P" 
EOT;
if ($ntype=="P") { echo "selected"; } 
echo <<<EOT
>Private 
</select></td> 
</tr> 
<tr><td>Nessus Username:</td>
<td><input type="text" name="nusername" value="$nusername"></td>
</tr>
<tr><td>Nessus Password:</td>
<td><input type="password" name="npassword" value="$npassword"></td>
</tr>
<tr><td>Max number of hosts to scan:</td>
<td><input type="text" name="nmaxscans" value="$nmaxscans"></td>
</tr>
<tr><td>Current scans</td><td>$currentscans</td></tr>
</table>
<input type="submit" name="submit" value="Save">
</form>
<a href="servers.php?item=edit&amp;op=editzones&amp;nid=$nid">Add/Edit Zones</A>
EOT;
      }
   } elseif ($item=="addserver") {
      if($op=="save") {
         $flag=1;
         $problemtext="";
      
         //check input
         if($nname=="" or $nhostname=="" or $nport=="" or $nessususer=="" 
            or !is_numeric($nport)){
            $flag=0;
            $problemtext="Please fill in all required fields.<br>";
         }
      
         //check for duplicates
         $query="SELECT count(name)
                 FROM nessus_servers
                 WHERE name='$nname'
                    OR hostname='$nhostname'";
         $result=$dbconn->execute($query);
         list($hostsfound)=$result->fields;
         if($hostsfound>0){
            $flag=0;
            $problemtext="This Nessus server already defined";
         }

         if($flag==1){
            $query="Insert into nessus_servers 
                       (name, description, hostname, port, type, owner, 
                        user, password, checkin_time, status) 
                    values ('$nname', '$ndescription', '$nhostname', 
                            $nport, '$ntype', '$username', '$nessususer', 
                            '$nessuspassword', now()-interval 301 second, 'U')";
            $result=$dbconn->execute($query);

            echo "New Nessus server settings saved.<BR>";
       } else {
          echo "There was a problem saving configuration:<br />$problemtext";
       }
    } else {
       echo <<<EOT
<b>Add New Nessus Server</b><br>
<form method="POST" action="servers.php">
<input type="hidden" name="item" value="addserver">
<input type="hidden" name="op" value="save">
<table>
<tr><td>Server Name:</td>
<td><input type="text" name="nname" value=""></td>
</tr>
<tr><td>Server Description:</td>
<td><input type="text" name="ndescription" value=""></td>
</tr>
<tr><td>Server Hostname/IP address:</td>
<td><input type="text" name="nhostname" value=""></td>
</tr>
<tr>
<td>Server Port:</td>
<td><input type="text" name="nport" value="1241"></td>
</tr>
<tr><td>Server type:</td> 
<td><select name="ntype"> 
<option value="G" selected>Global
<option value="P">Private 
</select></td> 
</tr> 
<tr>
<td>Nessus Username:</td>
<td><input type="text" name="nessususer" value=""></td>
</tr>
<tr>
<td>Nessus Password:</td>
<td><input type="password" name="nessuspassword" value=""></td>
</tr></table>
<input type="submit" name="submit" value="Save">
</form>
EOT;
      }
   } else {
      if ($op=="forcecheck") {
         $query="Update nessus_servers 
                 set status='U', checkin_time=now()-interval 301 second";
         $result=$dbconn->execute($query);
         echo "<I>This page will automatically refresh in 20 seconds with a new status update</I><FONT SIZE=\"1\"><BR><BR></FONT>";
      }
      $query = "SELECT id, name, description, hostname, 
                   count(nessus_scan.status) current_scans, type,
                   max_scans, checkin_time, nessus_servers.status
                FROM nessus_servers
                left join nessus_scan 
                   on nessus_servers.id = nessus_scan.server_id 
                   and nessus_scan.status in ('P','R')
                WHERE (owner='$username' OR type='G')
                group by id";
      $result=$dbconn->Execute($query);

      echo <<<EOT
<B>Nessus Servers</B>
<br>
<table border=1>
<tr>
<td colspan=2>Action</td>
<td>Server ID</td>
<td>Name</td>
<td>Description</td>
<td>Hostname</td>
<td>Type</td>
<td>Check-In Time</td>
<td>Running Scans</td>
<td>Max Scans</td>
<td>Status</td>
EOT;
      while (!$result->EOF) {
         list ($nid, $nname, $ndescription, $nhostname, $ncurrent, 
               $ntype, $nmax, $checkin, $serv_status)=$result->fields;
         echo <<<EOT
<tr>
<td><a href="servers.php?item=edit&nid=$nid">Edit</a></td>
<td><a href="servers.php?item=delete&nid=$nid">Del</a></td>
<td>$nid</td><td>$nname</td><td>$ndescription</td><td>$nhostname</td><td>
EOT;
         if ($ntype=="G") { echo "Global"; }
         elseif ($ntype=="P") { echo "Private"; }
         echo <<<EOT
</td><td>$checkin</td>
<td>$ncurrent</td><td>$nmax</td>
EOT;
         switch ($serv_status) {
         case "N":
            $srv_stat_desc="Off-line";
            break;
         case "C":
            $srv_stat_desc="Checking";
            break;
         case "A":
            $srv_stat_desc="On-line";
            break;
         default:
            $srv_stat_desc="Unknown";
            break;
         }
         echo <<<EOT
<td>$srv_stat_desc</td>
</tr>
EOT;

         $result->MoveNext();
      }

      echo <<<EOT
</table><BR>
<a href="servers.php?item=addserver">Add new Nessus server</A>
 | <a href="servers.php?op=forcecheck">Force Servers Check</a>
EOT;
   }
}
require_once('footer.php');
?>
