<?php
//
// $Id: trend.php,v 1.8 2006/09/20 13:40:54 airwofl Exp $
//

$pageTitle = "Vulnerability Trend Analysis";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$logh->log("$username : " . $_SERVER['PHP_SELF']  . " : Accessed page", PEAR_LOG_DEBUG);

$hostlen=0;
$schedlen=0;
$proflen=0;

$getParams = array( "byuser", "userfilter", "schedule", "sid", "days",
                   "risk", "type", "submit", "ip", "uid" );
$postParams = array( "byuser", "userfilter", "schedule", "sid", "days",
                   "risk", "type", "submit", "ip", "uid" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp = ""; 
      }
   }
   break;
case "POST" :
   foreach ($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         if(is_array($_POST[$pp])) {
            foreach($_POST[$pp] as $i=>$tmp) {
               ${$pp}[$i]=htmlspecialchars(mysql_real_escape_string(trim($tmp)), ENT_QUOTES); 
            }
         } else {
            $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
         }
      } else { 
         $$pp = ""; 
      }
   }
   break;
}

$allowedAccess = ($uroles['admin'] || $uroles['reports']) ? TRUE : FALSE;

$uid_filter=0;
if (defined($uid) && !empty($uid)) { $uid_filter=1; }

if (!$allowedAccess) { 
   $uid=$username; 
} else {
    if (!$uid_filter) { $uid=$username; }
}

echo "<b>Vulnerability Trend Analysis</b><br><br>";

if ($allowedAccess)
{
    echo <<<EOT
<table border=0 cellspacing="0" cellpadding="0" style="border-collapse: collapse">
 <tr>
 <td valign="top">
  <form method="post" action="trend.php">
    <table border=1 bordercolor="#6797BF" cellspacing="1" cellpadding="1" style="border-collapse: collapse">
      <tr><td><B>Filter by user?</B></td></tr>
      <tr><td><select name="byuser">
      <option value=""
EOT;
//    if (($byuser=="") && (($userfilter=="Submit") || ($submit=="Go"))) { echo " selected"; }
    if ($byuser=="") { echo " selected"; }
    echo ">All</option>\n";

    $query="SELECT pn_uname 
            FROM users 
            ORDER BY pn_uname";
    $result=$dbconn->execute($query);

    while(!$result->EOF)
    {
       list($sql_uname)=$result->fields;
       echo "<option value=\"$sql_uname\"";
       if ($sql_uname==$byuser) { echo " selected"; }
       //elseif (($sql_uname==$uid) && ($byuser=="") && ($userfilter!="Submit") && ($submit!="Go")) { echo " selected"; }
    //   elseif ($sql_uname==$uid)  { echo " selected"; }
       echo ">$sql_uname</option>\n";
       $result->MoveNext();
    }

    echo <<<EOT
    </select></td></tr>
    </table>
    <input type="submit" name="userfilter" value="Submit">
 </td>
 <td>&nbsp;&nbsp;&nbsp;</td>
 <td valign="top">
EOT;
}

$sql_byuser="";
$sql_onlybyuser="";
$sql_byuser="";
$sql_t1byuser="";
$sql_t2byuser="";
$sql_nsubyuser="";

$allres=0;

if (($userfilter=="Submit") || ($byuser<>"")) {
   if (!$allowedAccess) { 
      echo "Cannot access this page - you don't have admin or reports rights."; 
      require_once('footer.php');
      die();
   }
 
   if ($byuser<>"") {
      $uid=$byuser;
      $sql_byuser="username='$uid' ";
      $sql_onlybyuser="where ".$sql_byuser;
      $sql_byuser.="and ";
      $sql_t1byuser="t1.".$sql_byuser;
      $sql_t2byuser="t2.".$sql_byuser;
      $sql_nsubyuser="nessus_settings_users.".$sql_byuser;
   } else { 
      $allres=1; 
   }

   echo "<input name='byuser' type='hidden' value='$byuser'>";
} elseif (($userfilter!="Submit") && ($byuser=="")) {
   if (!$allowedAccess) {
      $sql_byuser="username='$uid' ";
      $sql_onlybyuser="where ".$sql_byuser;
      $sql_byuser.="and ";
      $sql_t1byuser="t1.".$sql_byuser;
      $sql_t2byuser="t2.".$sql_byuser;
      $sql_nsubyuser="nessus_settings_users.".$sql_byuser;
   } else { 
      $allres=1; 
   }
}

if (!$allowedAccess) {
   echo "<form method='post' action='trend.php'>"; 
}

echo <<<EOT
<table>
  <tr><td><b>Host</b></td>
  <td><b>Schedule</b></td>
</tr>
<tr>
  <td><select name="ip">
    <option value="">All</option>
EOT;

$query="SELECT distinct nr.host as ip, h.hostname as hostname 
        FROM nessus_results as nr
        LEFT JOIN hosts as h
           ON h.ip = nr.host
        WHERE " . $sql_byuser . " falsepositive<>'Y' and scriptid <> 10180 
           and msg<>'' 
        ORDER BY hostname ASC";

$result=$dbconn->execute($query);
$resArr = $result->GetArray();

foreach($resArr as $data) {
   echo "   <option value='" . $data['ip'] . "'";
   if($data['ip']==$ip) { echo " selected";}
   if($data['hostname']!="") {
      echo ">" . $data['hostname'] . " (" . $data['ip'] . ")</option>\n";
   } else {
      echo ">" . $data['ip'] . "</option>\n";
   }
   if(strlen($data['ip']) > $hostlen) $hostlen=strlen($data['ip']);
}
echo <<<EOT
</select></td>
<td><select name="schedule">
<option value="">All</option>
EOT;
$query="SELECT name, id 
        from nessus_schedule ". $sql_onlybyuser .
       "order by name";
$result=$dbconn->execute($query);
while(!$result->EOF) {
   list($scname, $scid)=$result->fields;
   echo "<option value=\"$scid\"";
   if ($scid==$schedule) {echo" selected";}
   echo ">$scname</option>\n";
   if(strlen($scname) > $schedlen) $schedlen=strlen($scname);
   $result->MoveNext();
}
echo <<<EOT
</select></td></tr>
</table>
<font size="1"><br></font>
<table>
<tr>
  <td><b>Profile</b></td>
  <td><b>Days</b></td>
  <td><b>Risk</b></td>
  <td><b>Analysis</b></td>
  <td rowspan="2" valign="center">
    <input type="submit" name="submit" value="Go"></td>
</tr>
<tr>
  <td><select name="sid">
    <option value="">All</option>
EOT;
$query="SELECT distinct t1.id, t1.name 
        from nessus_settings t1, nessus_settings_users t2 
        where ".$sql_t2byuser."t1.id=t2.sid 
        order by t1.name";
$result=$dbconn->execute($query);
while(!$result->EOF){
   list($prid, $prname)=$result->fields;
   echo "<option value=\"$prid\"";
   if($prid==$sid) {echo" selected";}
   echo ">$prname</option>\n";
   if(strlen($prname) > $proflen) $proflen=strlen($prname);
   $result->MoveNext();
}
echo <<<EOT
</select></td>
<td>
  <select name="days">
  <option value="">All</option>
EOT;

$daysArr = array( "2", "7", "10", "14", "30", "90", "180", "365");
foreach ($daysArr as $val) {
   echo "<option value='$val'";
   if($days==$val) {
      echo " selected";
   } 
   echo ">$val Days</option>\n";
}

# Commented out because tdays is not used
#echo "<option value=\"other\"";if($days<>"" && $days==$tdays) {echo " selected";} echo ">Other";
$selected = ($risk=="") ? " selected" : "";
echo <<<EOT
</select></td>
<td><select name="risk[]" MULTIPLE>
<option value="" $selected>All</option>
EOT;
$query="select id, description 
        from risk_level 
        order by id";
$result=$dbconn->execute($query);
while(!$result->EOF){
   list($rid, $rname)=$result->fields;
   echo "<option value=\"$rid\"";
   if(is_array($risk) && in_array($rid,$risk)) { echo " selected"; }
   elseif($rid==$risk) { echo " selected"; }
   echo ">$rname</option>\n";
   $result->MoveNext();
}
echo <<<EOT
</select></td>
<td><select name="type">
EOT;
$tmpArr = array( 1 => "By Scan", 2 => "By Date", 3 => "Pie Chart" );
foreach ($tmpArr as $key=>$val) {
   echo "<option value='$key'";
   if($type==$key) {
      echo " selected";
   }
   echo ">$val";
}

echo <<<EOT
</select></td>
</tr>
</table>
</form>
EOT;

if ($allowedAccess) {
   echo <<<EOT
 </td>
 </tr>
 </table>
EOT;
}

if ($submit=="Go") {
   //Check variables
   $msg1="All";
   $msg2="All";
   $msg3="All";
   $msg4="All";
   $img="";
# Commented out - other and tdays / thost are not used
#    if($days=="other") $days=$tdays;
#    if($ip=="other") $ip=$thost;

   if ($type=="1") {
      $img="<img src=\"graph3.php?";
   } elseif ($type=="2") {
      $img="<img src=\"graph2.php?";
   } elseif ($type=="3") {
      if ($days=="") { $days=365; }
      if ($ip<>"") { $sql_t1whereip="t1.host LIKE '%$ip%' and "; }
      else { $sql_t1whereip=""; }
      if ($schedule<>"") { $sql_t1wheresched="t1.sched_id='$schedule' and "; }
      else { $sql_t1wheresched=""; }
      if ($sid<>"") { $sql_t1wheresid="t1.sid='$sid' and "; }
      else { $sql_t1wheresid=""; }

      $q1 = "SELECT count(t1.risk) as count, t1.risk 
             FROM `nessus_results` as t1 
             where " . $sql_t1byuser . $sql_t1wheresched . $sql_t1wheresid .
                $sql_t1whereip . "t1.falsepositive<>'Y' 
                and TO_DAYS(now()) - TO_DAYS(t1.scantime) < '$days' 
                and t1.scriptid <> 10180 
             group by risk";
      $result=$dbconn->Execute($q1);

      $totalrisk=0;
      $prevrisk=0;
      $chartimg="graph1.php?graph=1";
      while (list($riskcount, $risk)=$result->fields) {
         for ($i=0;$i<$risk-$prevrisk-1;$i++) {
            $missedrisk=$prevrisk+$i+1;
            $chartimg.="&amp;risk$missedrisk=0";
         }
         $prevrisk=$risk;
         $chartimg.="&amp;risk$risk=$riskcount";
         $totalrisk=$totalrisk+$riskcount;
         $result->MoveNext();
      }

      if($totalrisk>0) { $img="<img src=\"$chartimg\""; }
   } else {
      echo "Incorrect parameter (graph type)";
      require_once('footer.php');
      die();
   }

   if ($type <> "3") {
      if ($schedule<>"") {
         if(!is_numeric($schedule)) {
            $logh->log("$username : " . $_SERVER['PHP_SELF'] . 
                       " : Incorrect parameter - schedule = " . 
                       $schedule, PEAR_LOG_ERR);
            echo "Incorrect parameter (schedule id)";
            require_once('footer.php');
            die();
         }
         $query="select count(id) 
                 from nessus_schedule 
                 where " . $sql_byuser . "id='$schedule'";
         $result=$dbconn->execute($query);
         list($allowaccess)=$result->fields;
         if ($allowaccess<1) {
            echo "Incorrect parameter - current user or no users 
                  own the schedule";
            require_once('footer.php');
            die();
         }
         $img.="&amp;schedule=$schedule";
         $msg2="$schedule";
      }

      if ($sid<>"") {
         if(!is_numeric($sid)) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Incorrect parameter - sid = " . $sid, PEAR_LOG_ERR);
            echo "Incorrect parameter (scan profile id)";
            require_once('footer.php');
            die();
         }
         $query="select count(nessus_settings.id) 
                 from nessus_settings 
                 inner join nessus_settings_users 
                    on nessus_settings.id=nessus_settings_users.sid 
                 where ".$sql_nsubyuser."nessus_settings.id=$sid";
         $result=$dbconn->execute($query);
         list($allowaccess)=$result->fields;

         if ($allowaccess<1) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Invalid search criteria ", PEAR_LOG_ERR);
            echo "Incorrect parameter - current user or no users
                  have access to the scan profile (sid)";
            require_once('footer.php');
            die();
         }
         $img.="&amp;sid=$sid";
         $msg3=$sid;
      }

      if ($days<>"") {
         if(!is_numeric($days) or $days<0) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Incorrect parameter - days = " . 
                       $days, PEAR_LOG_ERR);
            echo "Incorrect parameter (days)";
            require_once('footer.php');
            die();
         }
         $img.="&amp;days=$days";
         $msg4=$days;
      }
   
      if ($risk<>"") {
      /*
         if(!is_numeric($risk)) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Incorrect parameter - risk = " . 
                       $risk, PEAR_LOG_ERR);
            echo "Incorrect parameter (risk)";
            require_once('footer.php');
            die();
         }
         if($risk<1 or $risk>7) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Incorrect parameter - risk = " . 
                       $risk, PEAR_LOG_ERR);
            echo "Incorrect parameter (risk out of bounds)";
            require_once('footer.php');
            die();
         }
      */
         if(is_array($risk)) {
            $img.="&amp;rrisk=" . implode("|",$risk);
         } else {
            $img.="&amp;rrisk=$risk";
         }
      }
   
      if ($ip<>"") {
         //already declared in functions.inc this would be a duplicate declaration
         //require_once('validateip.inc.php');

         if (!inrange($ip, $dbconn)) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Invalid IP range ", PEAR_LOG_ERR);
            echo "Incorrect parameter (IP address not in a valid 
                  network zone - configure one to view Trend results)";
            require_once('footer.php');
            die();
         }
         $img.="&amp;ip=$ip";
         $msg1=$ip;
      }

      if ($allres) { 
         $img.="&amp;allres=$allres"; 
      } elseif ($allowedAcess && ($uid_filter || ($byuser<>"All"))) { 
         $img.="&amp;uid=$uid"; 
      }
   }

   if ((($type=="3") && ($totalrisk>0)) || (($type=="1") || ($type=="2"))) {
      $img.="\">";
      echo "<B>Host:</B> $msg1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
            <B>Days:</B> $msg4<br><br>";
   }

   if ($img<>"") { 
      echo "$img<br><br>"; 
   } elseif (($type=="3") && ($totalrisk==0)) { 
      echo "<br><br>There are no results to display.<br><br>"; 
   }
}

require_once('footer.php');
?>
