<?php
//
// $Id: user.php,v 1.4 2006/08/10 17:19:33 airwofl Exp $
//

$pageTitle = "Account Settings ";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Page accessed", PEAR_LOG_DEBUG);

$getParams = array( "op" );
$postParams = array( "op", "email", "submit", "saveuserinfo", 
                     "currentpass", "newpass1", "newpass2" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

// get the dashboard info from the DB
$dquery = "SELECT d.dashModule, d.dashName, d.dashDesc, ud.dashStatus,
                  d.dashID, d.dashOrder, d.dashLocation
           FROM dashboards as d
           LEFT JOIN user_dashboards as ud ON ud.dashID = d.dashID
           WHERE (ud.pn_uname = '$username' OR ud.pn_uname IS NULL)
               AND d.dashStatus = 1";
$dashboards = $dbconn->GetArray($dquery);
/*
echo "<pre>";
print_r($dashboards);
echo "<br>";
print_r($_POST);
echo "</pre>";
*/

if($dashboards === false) {
   $errMsg[] = "Error getting dashboard information: " . $dbconn->ErrorMsg();
   dispSQLError($errMsg, 1);
} else {
}

if ($op=="dashboard") {
   $uquery="update user_dashboards 
           set dashStatus = ? 
           where pn_uname='$username' AND dashID = ?";
              //(select dashID from dashboards where dashName = ?)";
   $ustmt = $dbconn->Prepare($uquery);
   $iquery="INSERT INTO user_dashboards 
               (pn_uname, dashID, dashStatus)
            VALUES (?, ?, ?)"; 
   $istmt = $dbconn->Prepare($iquery);
   foreach($dashboards as $key=>$dash) {
      // check to see if this is a new dashboard to be added for the user
      if($_POST[$dash['dashID']]) {
         $status = 1;
         if($dashboards[$key]['dashStatus'] == "") {
            $result=$dbconn->execute($istmt,array($username, $dash['dashID'], 
                                                  1));
         } else {
            $result=$dbconn->execute($ustmt,array(1, $dash['dashID']));
         }
      } else {
         $status = 0;
         if($dashboards[$key]['dashStatus'] == "") {
            $result=$dbconn->execute($istmt,array($username, $dash['dashID'],
                                                  0));
         } else {
            $result=$dbconn->execute($ustmt,array(0, $dash['dashID']));
         }
      }
      
      if($result === false) {
         $errMsg[] = "Error updating user_dashboards: " . $dbconn->ErrorMsg();
         dispSQLError($errMsg,1);
      } else {
         $dashboards[$key]['dashStatus'] = $status;
      }
   }

   echo "<B>Dashboard settings saved</B>";
   
} elseif ($op=="email") {
   $query="update users 
           set pn_email='$email' 
           where pn_uname='$username'";
   $result=$dbconn->execute($query);

   $useremail=$email;
} elseif ($op=="pass") {
   $pass1=md5($newpass1);
   $pass2=md5($newpass2);
   $currentpass=md5($currentpass);

   echo "<font color='#FF0000'>";
   if ($pass1!=$pass2) {
      echo "<B>New passwords don't match.</B>";
   } elseif (strlen($newpass1) <= 0) { 
      echo "<B>Password cannot be blank.</B>"; 
   } else {
      $query="select count(pn_uname) 
              from users 
              where pn_uname='$username' and pn_pass='$currentpass'";
      $passcheck=$dbconn->GetOne($query);

      if($passcheck==1) { 
         if(checkPass($newpass1)) {
            $query="update users 
                    set pn_pass='$pass1' 
                    where pn_uname='$username'";
            $result=$dbconn->Execute($query);
            $_SESSION['pass'] = $pass1;
            echo "<B>Password has been reset for user $username.</B>";
         } else {
            echo "<B>New Password did not meet password standards.</b>";
         }
      } else {
         echo "<B>Incorrect current password provided.</B>";
      }
   }
   echo "</font>";
}

// Get user info
$uquery = "SELECT pn_email
           FROM users
           WHERE pn_uname = '$username'";
$useremail=$dbconn->GetOne($uquery);


$dashHTML = "";
foreach($dashboards as $dash) {
   if ($dash['dashStatus'] == 1) {
      $checked = "checked";
   } else {
      $checked = "";
   }
   $dashHTML .= "<input type='checkbox' name='" . $dash['dashID'] .
                "' $checked>" . $dash['dashDesc'] . "</input>";
   $dashHTML .= "<br>";
}

echo <<<EOT
<p></p>
<b>Settings for $username</b>
<p></p>
<form method="post" action="user.php">
<input type="hidden" name="op" value="email">
<table>
<td>Email:</td>
<td><input type="text" name="email" size="40" maxlength="60" value="$useremail"></td>
</tr>
</table>
<input type="submit" name="submit" value="Update Email">
</form>

<FORM method="POST" action="user.php">
<input type="hidden" name="op" value="pass">
<p>Password settings only apply if LDAP authentication is unavailable or not
configured</p>
<table>
<tr>
<td>Current password:</td>
<td><INPUT type="password" name="currentpass" value="" size="25"></td>
</tr>
<tr>
<td>New Password:</td>
<td><INPUT type="password" name="newpass1" value="" size="25"></td>
</tr>
<tr>
<td></td>
<td><INPUT type="password" name="newpass2" value="" size="25"></td>
</tr>
<tr>
<td><input type="submit" name="saveuserinfo" value="Change Password"></td>
<td></td>
</tr>
</table>
</FORM>

<FORM method="POST" action="user.php">
<input type="hidden" name="op" value="dashboard">
<table>
<tr>
<td>Dashboard settings</td>
<td>
$dashHTML
</td>
</tr>
<tr>
<td><input type="submit" name="savedashboard" value="Save Settings"></td>
<td></td>
</tr>
</table>
</form>
EOT;

require_once('footer.php');
?>
