<?php
//
// $Id: zones.php,v 1.7 2006/08/10 17:19:33 airwofl Exp $
//

$pageTitle = "Network Zones";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Page accessed", PEAR_LOG_DEBUG);

$netedit="";

$getParams = array( "item", "op", "zid", "netid", "nid", "uid" );
$postParams = array( "item", "op", "zonename", "zonedescription", "zname",
                     "zdescription", "zid", "range_start", "range_end",
                     "netid", "submit" );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES);
      } else { 
         $$gp="";
      }
   }
	$range_start="";
	$range_end="";
	break;
case "POST" :
   foreach($postParams as $pp) {
	   if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else { 
         $$pp="";
      }
   }
	break;
}

//$allowedAccess = (strpos($_SESSION['roles'],"zones") === false) ? FALSE : TRUE;

if (!$uroles['zones']) {
   echo "Access Denied!!!<br>";
   require_once('footer.php');
   die();
} else {
//   require_once('validateip.inc.php');
    
   if ($item=="delete")
   {
      if ($op=="delete")
      {
         $query="select name from nessus_zones 
                 where id=$zid";
         $zname=$dbconn->getOne($query);
         $query="delete from nessus_zones 
                 where id=$zid";
         $result=$dbconn->execute($query);
         $query="delete from nessus_zone_ranges 
                 where zoneid=$zid";
         $result=$dbconn->execute($query);
         echo <<<EOT
<p>Zone has been deleted</p>
<p><a href="zones.php">Edit Zones</a></p>
EOT;

      } else {
         $query = "select name, description 
                   from nessus_zones 
                   where id=$zid";
         $result = $dbconn->execute($query);
         list ($zname, $zdescription) = $result->fields;
         echo "Are you sure you want to remove the following zone?<BR>
         <B>$zname - $zdescription<BR>
         <a href=\"zones.php?item=delete&amp;zid=$zid&amp;op=delete\">Yes</A> <a href=\"zones.php\">No</a>";
      }
   } elseif ($item=="add") {
      if ($op=="save") {
	    //check input
	      $flag=1;
	      $problemtext="";

	      if($zonename==""){
		      $flag=0;
		      $problemtext="Zone name can not be blank<br />";
	      }

	      //check for duplicates
	      $query="SELECT count(*)
                 FROM nessus_zones
                 WHERE name='$zonename'";
	      $result=$dbconn->execute($query);
	      list($iszonefound)=$result->fields;

	      if($iszonefound>0){
		      $flag=0;
		      $problemtext.="Zone '$zonename' already exist in the database<br />";
	      }
		
	      if($flag==1){
            $query="INSERT into nessus_zones
	    		        (name, description, owner)
		       	     VALUES ('$zonename', '$zonedescription', '$username')";
            $result=$dbconn->execute($query);

	    // removed owner check - hsh
            //$query="SELECT id from nessus_zones where name = '$zonename' and owner = '$username'";
            $query="SELECT id from nessus_zones where name = '$zonename'";
            $result=$dbconn->execute($query);
            list ($zid)=$result->fields;

            $query="insert into nessus_user_zones (zid, username) values ($zid, '$username')";
            $result=$dbconn->execute($query);

            echo <<<EOT
Zone added<br />
<p></p>
<a href="zones.php?item=editzone&amp;zid=$zid">Edit Zone</a> 
EOT;
	      } else {
		      echo "There was a problem creating a new zone, please review details below:<br />$problemtext";
	      }
      } else {
         echo <<<EOT
<b>Add New Network Zone</b><br><form method="POST" action="zones.php">
<input type="hidden" name="item" value="add"><input type="hidden" name="op" value="save">
<table>
<tr><td>Zone Name:</td>
<td><input type="text" name="zonename" value=""><td>
</tr>
<tr><td>Zone Description:</td>
<td><input type="text" name="zonedescription" value=""><td>
</tr></table>
<input type="submit" name="submit" value="Add Zone">
</form>
EOT;
      }
   } elseif ($item=="edit") {
      if ($op=="delserver") {
         $query="delete from nessus_server_zones 
                 where nessusid=$nid 
                       and zoneid=$zid";
         $result=$dbconn->execute($query);
      }

      if ($op=="delrange") {
         $query="SELECT range 
                 FROM nessus_zone_ranges 
                 WHERE id=$netid";
         $rname=$dbconn->getOne($query);
         $query="delete from nessus_zone_ranges 
                 where id=$netid";
         $result=$dbconn->execute($query);
         $netid="";
      }

      if ($op=="addservers") {
	      if (isset($_POST['nessusservers'])) {
		      $nessusservers=$_POST['nessusservers'];
            for ($i = 0; $i < count($nessusservers); $i++) {
		         $nessusservers[$i]=htmlspecialchars(mysql_escape_string(trim($nessusservers[$i])), ENT_QUOTES);
               $query="delete from nessus_server_zones 
                       where zoneid=$zid 
                             and nessusid=$nessusservers[$i]";
               $result=$dbconn->execute($query);
               $query="insert into nessus_server_zones (zoneid, nessusid) 
                       values ($zid, $nessusservers[$i])";
               $result=$dbconn->execute($query);
            }
         }
      }

      if ($op=="addrange") {
         if (validateip($range_start)==1 and validateip($range_end)==1) {
            if ($netid=="") {
               $query="Insert into nessus_zone_ranges
		                 (zoneid, range_start, range_end)
		                 values ($zid, inet_aton('$range_start'), 
                              inet_aton('$range_end'))";
               $result=$dbconn->execute($query);
            } elseif(is_numeric($netid)) {
               $query="update nessus_zone_ranges
		                 set range_start=inet_aton('$range_start'), 
                           range_end=inet_aton('$range_end')
		                 where zoneid=$zid and id=$netid";
               $result=$dbconn->execute($query);
               $netid="";
            } else{
			      echo "There was a problem with your input";
		      }
         }
      }

      // edited hsh - remove owner check
      //$query="select name from nessus_zones where owner='$username' and id=$zid";
      $query="select name 
              from nessus_zones 
              where id=$zid";
      $result=$dbconn->execute($query);
      list($zname)=$result->fields;

      echo <<<EOT
<a href="zones.php?item=editusers&amp;zid=$zid">Edit Zone Users</a> | 
<a href="zones.php">Edit Zones</a>
<p></p>
Zone Details: <B>$zname </b>
<p></p>
EOT;

      $netrange="";

      if ($netid<>"") {
         $query="select inet_ntoa(range_start), inet_ntoa(range_end) 
                 from nessus_zone_ranges 
                 where zoneid=$zid 
                       and id=$netid 
                 order by range_start ASC";
         $result=$dbconn->execute($query);
         list($range_start, $range_end)=$result->fields;
         $netedit=$netid;
         //              $query="delete from nessus_zone_ranges where id=$netid";
         //              $result=$dbconn->execute($query);
      }

      $query="Select t1.id, t1.zoneid, inet_ntoa(t1.range_start), 
                     inet_ntoa(t1.range_end) 
              from nessus_zone_ranges as t1, 
                   nessus_zones as t2 
              where t1.zoneid=t2.id 
                    and (t2.owner='$username' or t2.type='G') 
                    and t1.zoneid=$zid 
              order by t1.range_start";
      $result=$dbconn->Execute($query);

      echo <<<EOT
<table><tr><td valign="top"><B>Zone Network Ranges</b><br>
<table border=1><tr><td></td><td></td><td>Network/Range</td></tr>
EOT;

      while (!$result->EOF) {
         list ($netid, $zoneid, $drange_start, $drange_end)=$result->fields;
         echo <<<EOT
<tr><td><a href="zones.php?item=edit&amp;zid=$zid&amp;netid=$netid&amp;op=netedit">Edit</a></td>
<td><a href="zones.php?item=edit&amp;op=delrange&amp;netid=$netid&amp;zid=$zid">Del</a></td>
<td>$drange_start-$drange_end</td></tr>
EOT;
         $result->MoveNext();
      }

      echo "</table></td>
      <td valign=\"top\"><b>Zone Nessus Servers</b></br>";
      $query="select t3.id, t3.name, t3.hostname 
              from nessus_server_zones as t1, 
                   nessus_zones as t2, 
                   nessus_servers as t3 
              where t1.nessusid=t3.id 
                    and t1.zoneid=t2.id 
                    and t2.id=$zid 
              order by t3.name";
      $result=$dbconn->Execute($query);
      echo "<table border=1><tr><td></td><td></td><td>Name</td><td>Hostname</td></tr>";

      while (!$result->EOF) {
         list ($nid, $nname, $nhostname) = $result->fields;
         echo "<tr><td><a href=\"servers.php?item=edit&amp;nid=$nid\">Edit</a></td>
         <td><a href=\"zones.php?item=edit&amp;op=delserver&amp;nid=$nid&amp;zid=$zid\">Del</a></td>
         <td>$nname</td><td>$nhostname</td></tr>";

         $result->MoveNext();
      }

      echo <<<EOT
</table></td></tr></table><BR>
<form method="post" action="zones.php">
<input type="hidden" name="item" value="edit">
<input type="hidden" name="op" value="addrange">
<input type="hidden" name="zid" value="$zid">
<input type="hidden" name="netid" value="$netedit">
Network Range/IP Address:<br>
<input type="text" name="range_start" value="$range_start"> - 
<input type="text" name="range_end" value="$range_end"><br>
<input type="submit" name="submit" value="Add Range">
</form>
<form method="post" action="zones.php">
<input type="hidden" name="item" value="edit">
<input type="hidden" name="op" value="addservers">
<input type="hidden" name="zid" value="$zid">
<table>
<tr>
<td valign="top">Nessus servers:</td><td> 
EOT;
        $query="select id, name, hostname 
                from nessus_servers 
                where type='G' 
                      or owner='$username' 
                order by name";
        $result=$dbconn->execute($query);
        echo "<select align=\"top\" name=\"nessusservers\" size=\"3\" multiple>";

        while (!$result->EOF) {
            list ($nid, $nname, $nhostname)=$result->fields;
            echo "<option value=\"$nid\">$nname - $nhostname";

            $result->MoveNext();
        }

        echo <<<EOT
</select></td>
</tr></table>
<input type="submit" name="submit" value="Add servers">
</form>
EOT;
    } elseif ($item=="editzone") {
        if ($op=="save") {
	        // removed owner check in where clause - hsh
           //$query="update nessus_zones set name='$zname', description='$zdescription' where id=$zid and owner='$username'";
           $query="update nessus_zones 
                   set name='$zname', description='$zdescription' 
                   where id=$zid";
           $result=$dbconn->execute($query);
            echo "Zone - $zname has been updated.</br>Plesa click <a href=\"zones.php\">here</a> to return to the main Network Zones page.";
        } else {
	        //check input
	        if(is_numeric($zid)){
		
	    // removed owner check - hsh
            //$query="select name, description from nessus_zones where owner='$username' and id=$zid";
              $query="select name, description 
                      from nessus_zones 
                      where id=$zid";
              $result=$dbconn->execute($query);
              list($zname, $zdescription) = $result->fields;

              echo <<<EOT
<B>Edit Zone</B><br>
<a href="zones.php?item=edit&amp;zid=$zid">Zone Details</a> |  
<a href="zones.php?item=editusers&amp;zid=$zid">Edit Zone Users</a> | 
<a href="zones.php">Edit Zones</a>
<p></p>
<form method="POST" action="zones.php">
<input type="hidden" name="item" value="editzone"><input type="hidden" name="op" value="save"><input type="hidden" name="zid" value="$zid">
<table>
<tr><td>Name</td>
<td><input type="text" name="zname" value="$zname"></td>
</tr>
<tr><td>Description</td>
<td><input type="text" name="zdescription" value="$zdescription"></td>
</tr>
</table>
<input type="submit" name="submit" value="Save">
EOT;
           } else {
		        echo "It was a problem accessing the data";
	        }

        }
    } elseif($item=="editusers") {
        if ($op=="adduser") {
	        if (isset($_POST['zoneusers'])) {
		        $zoneusers=$_POST['zoneusers'];
              for ($i = 0; $i < count($zoneusers); $i++) {
		           $zoneusers[$i]=htmlspecialchars(mysql_escape_string(trim($zoneusers[$i])), ENT_QUOTES);
                 $query="delete from nessus_user_zones 
                         where zid=$zid 
                               and username='$zoneusers[$i]'";
                 $result=$dbconn->execute($query);
                 $query="insert into nessus_user_zones (zid, username) 
                         values ($zid, '$zoneusers[$i]')";
                 $result=$dbconn->execute($query);
		        }
           }
        }

        if ($op=="delete") {
           $query="delete from nessus_user_zones where id=$uid";
           $result=$dbconn->execute($query);
        }

	// removed owner check - hsh
        //$query="select name from nessus_zones where id=$zid and owner='$username'";
        $query="select name 
                from nessus_zones 
                where id=$zid";
        $result=$dbconn->execute($query);
        list($zname)=$result->fields;

echo <<<EOT
<a href="zones.php?item=edit&amp;zid=$zid">Zone Details</a> | 
<a href="zones.php">Edit Zones</a>
<p></p>
Zone Users: <B>$zname</b>
<p></p>
EOT;

        $query="select id, username, zid 
                from nessus_user_zones 
                where zid=$zid 
                order by username";
        $result=$dbconn->execute($query);

        echo <<<EOT
<table>
<tr>
   <th>User</th>
   <th>&nbsp;</th>
</tr>
EOT;
        while (!$result->EOF) {
           list($uid, $uname, $uzid)=$result->fields;
           echo <<<EOT
<tr>
   <td>$uname</td>
   <td><a href="zones.php?item=editusers&amp;op=delete&amp;uid=$uid&amp;zid=$zid">Del</a></td>
</tr>
EOT;
           $result->MoveNext();
        }

        echo "</table>";

        $query="select pn_uname
                from users 
                order by pn_uname";
        $result=$dbconn->execute($query);
        echo <<<EOT
<p></p>
<form method="post" action="zones.php">
<input type="hidden" name="item" value="editusers">
<input type="hidden" name="op" value="adduser">
<input type="hidden" name="zid" value="$zid">
<select name="zoneusers[]" size="4" multiple>
EOT;

        while (!$result->EOF) {
           list($uname)=$result->fields;
           echo "<option value=\"$uname\"> $uname";

           $result->MoveNext();
        }

        echo <<<EOT
</select><br>
<input type="submit" name="submit" value="Add Users">
</form>
EOT;
    } else {
        echo "<B>Network Zones Setup</B><BR>";

	// removed owner check - hsh
        //$query="SELECT * from nessus_zones where owner='$username' or type='G'";
       $query="SELECT * from nessus_zones";
       $result=$dbconn->execute($query);

       echo "<table border=1><tr><td></td><td></td><td>Zone Name</td><td>Description</td></tr>";

       while (!$result->EOF) {
          list($zoneid, $zonename, $zonedescription, $zonetype, $zoneowner)=$result->fields;
           echo <<<EOT
<tr><td><A href="zones.php?item=editzone&amp;zid=$zoneid">Edit</A></td>
<td><a href="zones.php?item=delete&amp;zid=$zoneid">Del</a></td>
<td>$zonename</td><td>$zonedescription</td></tr>
EOT;

           $result->MoveNext();
       }

       echo "</table>";
       echo "<a href=\"zones.php?item=add\">Add new zone</A>";
    }
}

require_once('footer.php');
?>
